//
// Latex Project Public Licence (lppl1.3) applies
// Originally written by Kwanleung Tse
// First Release : 1st July, 2014
// Last Update : 27th September, 2014
//
//

package worker4math.hktex2;

import java.util.*;

public class KnuthLiangTable  {
	String pattern1[] = new String[]{
		  ".ach4",
		  ".ad4der",
		  ".af1t",
		  ".al3t",
		  ".am5at",
		  ".an5c",
		  ".ang4",
		  ".ani5m",
		  ".ant4",
		  ".an3te",
		  ".anti5s",
		  ".ar5s",
		  ".ar4tie",
		  ".ar4ty",
		  ".as3c",
		  ".as1p",
		  ".as1s",
		  ".aster5",
		  ".atom5",
		  ".au1d",
		  ".av4i",
		  ".awn4",
		  ".ba4g",
		  ".ba5na",
		  ".bas4e",
		  ".ber4",
		  ".be5ra",
		  ".be3sm",
		  ".be5sto",
		  ".bri2",
		  ".but4ti",
		  ".cam4pe",
		  ".can5c",
		  ".capa5b",
		  ".car5ol",
		  ".ca4t",
		  ".ce4la",
		  ".ch4",
		  ".chill5i",
		  ".ci2",
		  ".cit5r",
		  ".co3e",
		  ".co4r",
		  ".cor5ner",
		  ".de4moi",
		  ".de3o",
		  ".de3ra",
		  ".de3ri",
		  ".des4c",
		  ".dictio5",
		  ".do4t",
		  ".du4c",
		  ".dumb5",
		  ".earth5",
		  ".eas3i",
		  ".eb4",
		  ".eer4",
		  ".eg2",
		  ".el5d",
		  ".el3em",
		  ".enam3",
		  ".en3g",
		  ".en3s",
		  ".eq5ui5t",
		  ".er4ri",
		  ".es3",
		  ".eu3",
		  ".eye5",
		  ".fes3",
		  ".for5mer",
		  ".ga2",
		  ".ge2",
		  ".gen3t4",
		  ".ge5og",
		  ".gi5a",
		  ".gi4b",
		  ".go4r",
		  ".hand5i",
		  ".han5k",
		  ".he2",
		  ".hero5i",
		  ".hes3",
		  ".het3",
		  ".hi3b",
		  ".hi3er",
		  ".hon5ey",
		  ".hon3o",
		  ".hov5",
		  ".id4l",
		  ".idol3",
		  ".im3m",
		  ".im5pin",
		  ".in1",
		  ".in3ci",
		  ".ine2",
		  ".in2k",
		  ".in3s",
		  ".ir5r",
		  ".is4i",
		  ".ju3r",
		  ".la4cy",
		  ".la4m",
		  ".lat5er",
		  ".lath5",
		  ".le2",
		  ".leg5e",
		  ".len4",
		  ".lep5",
		  ".lev1",
		  ".li4g",
		  ".lig5a",
		  ".li2n",
		  ".li3o",
		  ".li4t",
		  ".mag5a5",
		  ".mal5o",
		  ".man5a",
		  ".mar5ti",
		  ".me2",
		  ".mer3c",
		  ".me5ter",
		  ".mis1",
		  ".mist5i",
		  ".mon3e",
		  ".mo3ro",
		  ".mu5ta",
		  ".muta5b",
		  ".ni4c",
		  ".od2",
		  ".odd5",
		  ".of5te",
		  ".or5ato",
		  ".or3c",
		  ".or1d",
		  ".or3t",
		  ".os3",
		  ".os4tl",
		  ".oth3",
		  ".out3",
		  ".ped5al",
		  ".pe5te",
		  ".pe5tit",
		  ".pi4e",
		  ".pio5n",
		  ".pi2t",
		  ".pre3m",
		  ".ra4c",
		  ".ran4t",
		  ".ratio5na",
		  ".ree2",
		  ".re5mit",
		  ".res2",
		  ".re5stat",
		  ".ri4g",
		  ".rit5u",
		  ".ro4q",
		  ".ros5t",
		  ".row5d",
		  ".ru4d",
		  ".sci3e",
		  ".self5",
		  ".sell5",
		  ".se2n",
		  ".se5rie",
		  ".sh2",
		  ".si2",
		  ".sing4",
		  ".st4",
		  ".sta5bl",
		  ".sy2",
		  ".ta4",
		  ".te4",
		  ".ten5an",
		  ".th2",
		  ".ti2",
		  ".til4",
		  ".tim5o5",
		  ".ting4",
		  ".tin5k",
		  ".ton4a",
		  ".to4p",
		  ".top5i",
		  ".tou5s",
		  ".trib5ut",
		  ".un1a",
		  ".un3ce",
		  ".under5",
		  ".un1e",
		  ".un5k",
		  ".un5o",
		  ".un3u",
		  ".up3",
		  ".ure3",
		  ".us5a",
		  ".ven4de",
		  ".ve5ra",
		  ".wil5i",
		  ".ye4",
		  "4ab.",
		  "a5bal",
		  "a5ban",
		  "abe2",
		  "ab5erd",
		  "abi5a",
		  "ab5it5ab",
		  "ab5lat",
		  "ab5o5liz",
		  "4abr",
		  "ab5rog",
		  "ab3ul",
		  "a4car",
		  "ac5ard",
		  "ac5aro",
		  "a5ceou",
		  "ac1er",
		  "a5chet",
		  "4a2ci",
		  "a3cie",
		  "ac1in",
		  "a3cio",
		  "ac5rob",
		  "act5if",
		  "ac3ul",
		  "ac4um",
		  "a2d",
		  "ad4din",
		  "ad5er.",
		  "2adi",
		  "a3dia",
		  "ad3ica",
		  "adi4er",
		  "a3dio",
		  "a3dit",
		  "a5diu",
		  "ad4le",
		  "ad3ow",
		  "ad5ran",
		  "ad4su",
		  "4adu",
		  "a3duc",
		  "ad5um",
		  "ae4r",
		  "aeri4e",
		  "a2f",
		  "aff4",
		  "a4gab",
		  "aga4n",
		  "ag5ell",
		  "age4o",
		  "4ageu",
		  "ag1i",
		  "4ag4l",
		  "ag1n",
		  "a2go",
		  "3agog",
		  "ag3oni",
		  "a5guer",
		  "ag5ul",
		  "a4gy",
		  "a3ha",
		  "a3he",
		  "ah4l",
		  "a3ho",
		  "ai2",
		  "a5ia",
		  "a3ic.",
		  "ai5ly",
		  "a4i4n",
		  "ain5in",
		  "ain5o",
		  "ait5en",
		  "a1j",
		  "ak1en",
		  "al5ab",
		  "al3ad",
		  "a4lar",
		  "4aldi",
		  "2ale",
		  "al3end",
		  "a4lenti",
		  "a5le5o",
		  "al1i",
		  "al4ia.",
		  "ali4e",
		  "al5lev",
		  "4allic",
		  "4alm",
		  "a5log.",
		  "a4ly.",
		  "4alys",
		  "5a5lyst",
		  "5alyt",
		  "3alyz",
		  "4ama",
		  "am5ab",
		  "am3ag",
		  "ama5ra",
		  "am5asc",
		  "a4matis",
		  "a4m5ato",
		  "am5era",
		  "am3ic",
		  "am5if",
		  "am5ily",
		  "am1in",
		  "ami4no",
		  "a2mo",
		  "a5mon",
		  "amor5i",
		  "amp5en",
		  "a2n",
		  "an3age",
		  "3analy",
		  "a3nar",
		  "an3arc",
		  "anar4i",
		  "a3nati",
		  "4and",
		  "ande4s",
		  "an3dis",
		  "an1dl",
		  "an4dow",
		  "a5nee",
		  "a3nen",
		  "an5est.",
		  "a3neu",
		  "2ang",
		  "ang5ie",
		  "an1gl",
		  "a4n1ic",
		  "a3nies",
		  "an3i3f",
		  "an4ime",
		  "a5nimi",
		  "a5nine",
		  "an3io",
		  "a3nip",
		  "an3ish",
		  "an3it",
		  "a3niu",
		  "an4kli",
		  "5anniz",
		  "ano4",
		  "an5ot",
		  "anoth5",
		  "an2sa",
		  "an4sco",
		  "an4sn",
		  "an2sp",
		  "ans3po",
		  "an4st",
		  "an4sur",
		  "antal4",
		  "an4tie",
		  "4anto",
		  "an2tr",
		  "an4tw",
		  "an3ua",
		  "an3ul",
		  "a5nur",
		  "4ao",
		  "apar4",
		  "ap5at",
		  "ap5ero",
		  "a3pher",
		  "4aphi",
		  "a4pilla",
		  "ap5illar",
		  "ap3in",
		  "ap3ita",
		  "a3pitu",
		  "a2pl",
		  "apoc5",
		  "ap5ola",
		  "apor5i",
		  "apos3t",
		  "aps5es",
		  "a3pu",
		  "aque5",
		  "2a2r",
		  "ar3act",
		  "a5rade",
		  "ar5adis",
		  "ar3al",
		  "a5ramete",
		  "aran4g",
		  "ara3p",
		  "ar4at",
		  "a5ratio",
		  "ar5ativ",
		  "a5rau",
		  "ar5av4",
		  "araw4",
		  "arbal4",
		  "ar4chan",
		  "ar5dine",
		  "ar4dr",
		  "ar5eas",
		  "a3ree",
		  "ar3ent",
		  "a5ress",
		  "ar4fi",
		  "ar4fl",
		  "ar1i",
		  "ar5ial",
		  "ar3ian",
		  "a3riet",
		  "ar4im",
		  "ar5inat",
		  "ar3io",
		  "ar2iz",
		  "ar2mi",
		  "ar5o5d",
		  "a5roni",
		  "a3roo",
		  "ar2p",
		  "ar3q",
		  "arre4",
		  "ar4sa",
		  "ar2sh",
		  "4as.",
		  "as4ab",
		  "as3ant",
		  "ashi4",
		  "a5sia.",
		  "a3sib",
		  "a3sic",
		  "5a5si4t",
		  "ask3i",
		  "as4l",
		  "a4soc",
		  "as5ph",
		  "as4sh",
		  "as3ten",
		  "as1tr",
		  "asur5a",
		  "a2ta",
		  "at3abl",
		  "at5ac",
		  "at3alo",
		  "at5ap",
		  "ate5c",
		  "at5ech",
		  "at3ego",
		  "at3en.",
		  "at3era",
		  "ater5n",
		  "a5terna",
		  "at3est",
		  "at5ev",
		  "4ath",
		  "ath5em",
		  "a5then",
		  "at4ho",
		  "ath5om",
		  "4ati.",
		  "a5tia",
		  "at5i5b",
		  "at1ic",
		  "at3if",
		  "ation5ar",
		  "at3itu",
		  "a4tog",
		  "a2tom",
		  "at5omiz",
		  "a4top",
		  "a4tos",
		  "a1tr",
		  "at5rop",
		  "at4sk",
		  "at4tag",
		  "at5te",
		  "at4th",
		  "a2tu",
		  "at5ua",
		  "at5ue",
		  "at3ul",
		  "at3ura",
		  "a2ty",
		  "au4b",
		  "augh3",
		  "au3gu",
		  "au4l2",
		  "aun5d",
		  "au3r",
		  "au5sib",
		  "aut5en",
		  "au1th",
		  "a2va",
		  "av3ag",
		  "a5van",
		  "ave4no",
		  "av3era",
		  "av5ern",
		  "av5ery",
		  "av1i",
		  "avi4er",
		  "av3ig",
		  "av5oc",
		  "a1vor",
		  "3away",
		  "aw3i",
		  "aw4ly",
		  "aws4",
		  "ax4ic",
		  "ax4id",
		  "ay5al",
		  "aye4",
		  "ays4",
		  "azi4er",
		  "azz5i",
		  "5ba.",
		  "bad5ger",
		  "ba4ge",
		  "bal1a",
		  "ban5dag",
		  "ban4e",
		  "ban3i",
		  "barbi5",
		  "bari4a",
		  "bas4si",
		  "1bat",
		  "ba4z",
		  "2b1b",
		  "b2be",
		  "b3ber",
		  "bbi4na",
		  "4b1d",
		  "4be.",
		  "beak4",
		  "beat3",
		  "4be2d",
		  "be3da",
		  "be3de",
		  "be3di",
		  "be3gi",
		  "be5gu",
		  "1bel",
		  "be1li",
		  "be3lo",
		  "4be5m",
		  "be5nig",
		  "be5nu",
		  "4bes4",
		  "be3sp",
		  "be5str",
		  "3bet",
		  "bet5iz",
		  "be5tr",
		  "be3tw",
		  "be3w",
		  "be5yo",
		  "2bf",
		  "4b3h",
		  "bi2b",
		  "bi4d",
		  "3bie",
		  "bi5en",
		  "bi4er",
		  "2b3if",
		  "1bil",
		  "bi3liz",
		  "bina5r4",
		  "bin4d",
		  "bi5net",
		  "bi3ogr",
		  "bi5ou",
		  "bi2t",
		  "3bi3tio",
		  "bi3tr",
		  "3bit5ua",
		  "b5itz",
		  "b1j",
		  "bk4",
		  "b2l2",
		  "blath5",
		  "b4le.",
		  "blen4",
		  "5blesp",
		  "b3lis",
		  "b4lo",
		  "blun4t",
		  "4b1m",
		  "4b3n",
		  "bne5g",
		  "3bod",
		  "bod3i",
		  "bo4e",
		  "bol3ic",
		  "bom4bi",
		  "bon4a",
		  "bon5at",
		  "3boo",
		  "5bor.",
		  "4b1ora",
		  "bor5d",
		  "5bore",
		  "5bori",
		  "5bos4",
		  "b5ota",
		  "both5",
		  "bo4to",
		  "bound3",
		  "4bp",
		  "4brit",
		  "broth3",
		  "2b5s2",
		  "bsor4",
		  "2bt",
		  "bt4l",
		  "b4to",
		  "b3tr",
		  "buf4fer",
		  "bu4ga",
		  "bu3li",
		  "bumi4",
		  "bu4n",
		  "bunt4i",
		  "bu3re",
		  "bus5ie",
		  "buss4e",
		  "5bust",
		  "4buta",
		  "3butio",
		  "b5uto",
		  "b1v",
		  "4b5w",
		  "5by.",
		  "bys4",
		  "1ca",
		  "cab3in",
		  "ca1bl",
		  "cach4",
		  "ca5den",
		  "4cag4",
		  "2c5ah",
		  "ca3lat",
		  "cal4la",
		  "call5in",
		  "4calo",
		  "can5d",
		  "can4e",
		  "can4ic",
		  "can5is",
		  "can3iz",
		  "can4ty",
		  "cany4",
		  "ca5per",
		  "car5om",
		  "cast5er",
		  "cas5tig",
		  "4casy",
		  "ca4th",
		  "4cativ",
		  "cav5al",
		  "c3c",
		  "ccha5",
		  "cci4a",
		  "ccompa5",
		  "ccon4",
		  "ccou3t",
		  "2ce.",
		  "4ced.",
		  "4ceden",
		  "3cei",
		  "5cel.",
		  "3cell",
		  "1cen",
		  "3cenc",
		  "2cen4e",
		  "4ceni",
		  "3cent",
		  "3cep",
		  "ce5ram",
		  "4cesa",
		  "3cessi",
		  "ces5si5b",
		  "ces5t",
		  "cet4",
		  "c5e4ta",
		  "cew4",
		  "2ch",
		  "4ch.",
		  "4ch3ab",
		  "5chanic",
		  "ch5a5nis",
		  "che2",
		  "cheap3",
		  "4ched",
		  "che5lo",
		  "3chemi",
		  "ch5ene",
		  "ch3er.",
		  "ch3ers",
		  "4ch1in",
		  "5chine.",
		  "ch5iness",
		  "5chini",
		  "5chio",
		  "3chit",
		  "chi2z",
		  "3cho2",
		  "ch4ti",
		  "1ci",
		  "3cia",
		  "ci2a5b",
		  "cia5r",
		  "ci5c",
		  "4cier",
		  "5cific.",
		  "4cii",
		  "ci4la",
		  "3cili",
		  "2cim",
		  "2cin",
		  "c4ina",
		  "3cinat",
		  "cin3em",
		  "c1ing",
		  "c5ing.",
		  "5cino",
		  "cion4",
		  "4cipe",
		  "ci3ph",
		  "4cipic",
		  "4cista",
		  "4cisti",
		  "2c1it",
		  "cit3iz",
		  "5ciz",
		  "ck1",
		  "ck3i",
		  "1c4l4",
		  "4clar",
		  "c5laratio",
		  "5clare",
		  "cle4m",
		  "4clic",
		  "clim4",
		  "cly4",
		  "c5n",
		  "1co",
		  "co5ag",
		  "coe2",
		  "2cog",
		  "co4gr",
		  "coi4",
		  "co3inc",
		  "col5i",
		  "5colo",
		  "col3or",
		  "com5er",
		  "con4a",
		  "c4one",
		  "con3g",
		  "con5t",
		  "co3pa",
		  "cop3ic",
		  "co4pl",
		  "4corb",
		  "coro3n",
		  "cos4e",
		  "cov1",
		  "cove4",
		  "cow5a",
		  "coz5e",
		  "co5zi",
		  "c1q",
		  "cras5t",
		  "5crat.",
		  "5cratic",
		  "cre3at",
		  "5cred",
		  "4c3reta",
		  "cre4v",
		  "cri2",
		  "cri5f",
		  "c4rin",
		  "cris4",
		  "5criti",
		  "cro4pl",
		  "crop5o",
		  "cros4e",
		  "cru4d",
		  "4c3s2",
		  "2c1t",
		  "cta4b",
		  "ct5ang",
		  "c5tant",
		  "c2te",
		  "c3ter",
		  "c4ticu",
		  "ctim3i",
		  "ctu4r",
		  "c4tw",
		  "cud5",
		  "c4uf",
		  "c4ui",
		  "cu5ity",
		  "5culi",
		  "cul4tis",
		  "3cultu",
		  "cu2ma",
		  "c3ume",
		  "cu4mi",
		  "3cun",
		  "cu3pi",
		  "cu5py",
		  "cur5a4b",
		  "cu5ria",
		  "1cus",
		  "cuss4i",
		  "3c4ut",
		  "cu4tie",
		  "4c5utiv",
		  "4cutr",
		  "1cy",
		  "cze4",
		  "1d2a",
		  "5da.",
		  "2d3a4b",
		  "dach4",
		  "4daf",
		  "2dag",
		  "da2m2",
		  "dan3g",
		  "dard5",
		  "dark5",
		  "4dary",
		  "3dat",
		  "4dativ",
		  "4dato",
		  "5dav4",
		  "dav5e",
		  "5day",
		  "d1b",
		  "d5c",
		  "d1d4",
		  "2de.",
		  "deaf5",
		  "deb5it",
		  "de4bon",
		  "decan4",
		  "de4cil",
		  "de5com",
		  "2d1ed",
		  "4dee.",
		  "de5if",
		  "deli4e",
		  "del5i5q",
		  "de5lo",
		  "d4em",
		  "5dem.",
		  "3demic",
		  "dem5ic.",
		  "de5mil",
		  "de4mons",
		  "demor5",
		  "1den",
		  "de4nar",
		  "de3no",
		  "denti5f",
		  "de3nu",
		  "de1p",
		  "de3pa",
		  "depi4",
		  "de2pu",
		  "d3eq",
		  "d4erh",
		  "5derm",
		  "dern5iz",
		  "der5s",
		  "des2",
		  "d2es.",
		  "de1sc",
		  "de2s5o",
		  "des3ti",
		  "de3str",
		  "de4su",
		  "de1t",
		  "de2to",
		  "de1v",
		  "dev3il",
		  "4dey",
		  "4d1f",
		  "d4ga",
		  "d3ge4t",
		  "dg1i",
		  "d2gy",
		  "d1h2",
		  "5di.",
		  "1d4i3a",
		  "dia5b",
		  "di4cam",
		  "d4ice",
		  "3dict",
		  "3did",
		  "5di3en",
		  "d1if",
		  "di3ge",
		  "di4lato",
		  "d1in",
		  "1dina",
		  "3dine.",
		  "5dini",
		  "di5niz",
		  "1dio",
		  "dio5g",
		  "di4pl",
		  "dir2",
		  "di1re",
		  "dirt5i",
		  "dis1",
		  "5disi",
		  "d4is3t",
		  "d2iti",
		  "1di1v",
		  "d1j",
		  "d5k2",
		  "4d5la",
		  "3dle.",
		  "3dled",
		  "3dles.",
		  "4dless",
		  "2d3lo",
		  "4d5lu",
		  "2dly",
		  "d1m",
		  "4d1n4",
		  "1do",
		  "3do.",
		  "do5de",
		  "5doe",
		  "2d5of",
		  "d4og",
		  "do4la",
		  "doli4",
		  "do5lor",
		  "dom5iz",
		  "do3nat",
		  "doni4",
		  "doo3d",
		  "dop4p",
		  "d4or",
		  "3dos",
		  "4d5out",
		  "do4v",
		  "3dox",
		  "d1p",
		  "1dr",
		  "drag5on",
		  "4drai",
		  "dre4",
		  "drea5r",
		  "5dren",
		  "dri4b",
		  "dril4",
		  "dro4p",
		  "4drow",
		  "5drupli",
		  "4dry",
		  "2d1s2",
		  "ds4p",
		  "d4sw",
		  "d4sy",
		  "d2th",
		  "1du",
		  "d1u1a",
		  "du2c",
		  "d1uca",
		  "duc5er",
		  "4duct.",
		  "4ducts",
		  "du5el",
		  "du4g",
		  "d3ule",
		  "dum4be",
		  "du4n",
		  "4dup",
		  "du4pe",
		  "d1v",
		  "d1w",
		  "d2y",
		  "5dyn",
		  "dy4se",
		  "dys5p",
		  "e1a4b",
		  "e3act",
		  "ead1",
		  "ead5ie",
		  "ea4ge",
		  "ea5ger",
		  "ea4l",
		  "eal5er",
		  "eal3ou",
		  "eam3er",
		  "e5and",
		  "ear3a",
		  "ear4c",
		  "ear5es",
		  "ear4ic",
		  "ear4il",
		  "ear5k",
		  "ear2t",
		  "eart3e",
		  "ea5sp",
		  "e3ass",
		  "east3",
		  "ea2t",
		  "eat5en",
		  "eath3i",
		  "e5atif",
		  "e4a3tu",
		  "ea2v",
		  "eav3en",
		  "eav5i",
		  "eav5o",
		  "2e1b",
		  "e4bel.",
		  "e4bels",
		  "e4ben",
		  "e4bit",
		  "e3br",
		  "e4cad",
		  "ecan5c",
		  "ecca5",
		  "e1ce",
		  "ec5essa",
		  "ec2i",
		  "e4cib",
		  "ec5ificat",
		  "ec5ifie",
		  "ec5ify",
		  "ec3im",
		  "eci4t",
		  "e5cite",
		  "e4clam",
		  "e4clus",
		  "e2col",
		  "e4comm",
		  "e4compe",
		  "e4conc",
		  "e2cor",
		  "ec3ora",
		  "eco5ro",
		  "e1cr",
		  "e4crem",
		  "ec4tan",
		  "ec4te",
		  "e1cu",
		  "e4cul",
		  "ec3ula",
		  "2e2da",
		  "4ed3d",
		  "e4d1er",
		  "ede4s",
		  "4edi",
		  "e3dia",
		  "ed3ib",
		  "ed3ica",
		  "ed3im",
		  "ed1it",
		  "edi5z",
		  "4edo",
		  "e4dol",
		  "edon2",
		  "e4dri",
		  "e4dul",
		  "ed5ulo",
		  "ee2c",
		  "eed3i",
		  "ee2f",
		  "eel3i",
		  "ee4ly",
		  "ee2m",
		  "ee4na",
		  "ee4p1",
		  "ee2s4",
		  "eest4",
		  "ee4ty",
		  "e5ex",
		  "e1f",
		  "e4f3ere",
		  "1eff",
		  "e4fic",
		  "5efici",
		  "efil4",
		  "e3fine",
		  "ef5i5nite",
		  "3efit",
		  "efor5es",
		  "e4fuse.",
		  "4egal",
		  "eger4",
		  "eg5ib",
		  "eg4ic",
		  "eg5ing",
		  "e5git5",
		  "eg5n",
		  "e4go.",
		  "e4gos",
		  "eg1ul",
		  "e5gur",
		  "5egy",
		  "e1h4",
		  "eher4",
		  "ei2",
		  "e5ic",
		  "ei5d",
		  "eig2",
		  "ei5gl",
		  "e3imb",
		  "e3inf",
		  "e1ing",
		  "e5inst",
		  "eir4d",
		  "eit3e",
		  "ei3th",
		  "e5ity",
		  "e1j",
		  "e4jud",
		  "ej5udi",
		  "eki4n",
		  "ek4la",
		  "e1la",
		  "e4la.",
		  "e4lac",
		  "elan4d",
		  "el5ativ",
		  "e4law",
		  "elaxa4",
		  "e3lea",
		  "el5ebra",
		  "5elec",
		  "e4led",
		  "el3ega",
		  "e5len",
		  "e4l1er",
		  "e1les",
		  "el2f",
		  "el2i",
		  "e3libe",
		  "e4l5ic.",
		  "el3ica",
		  "e3lier",
		  "el5igib",
		  "e5lim",
		  "e4l3ing",
		  "e3lio",
		  "e2lis",
		  "el5ish",
		  "e3liv3",
		  "4ella",
		  "el4lab",
		  "ello4",
		  "e5loc",
		  "el5og",
		  "el3op.",
		  "el2sh",
		  "el4ta",
		  "e5lud",
		  "el5ug",
		  "e4mac",
		  "e4mag",
		  "e5man",
		  "em5ana",
		  "em5b",
		  "e1me",
		  "e2mel",
		  "e4met",
		  "em3ica",
		  "emi4e",
		  "em5igra",
		  "em1in2",
		  "em5ine",
		  "em3i3ni",
		  "e4mis",
		  "em5ish",
		  "e5miss",
		  "em3iz",
		  "5emniz",
		  "emo4g",
		  "emoni5o",
		  "em3pi",
		  "e4mul",
		  "em5ula",
		  "emu3n",
		  "e3my",
		  "en5amo",
		  "e4nant",
		  "ench4er",
		  "en3dic",
		  "e5nea",
		  "e5nee",
		  "en3em",
		  "en5ero",
		  "en5esi",
		  "en5est",
		  "en3etr",
		  "e3new",
		  "en5ics",
		  "e5nie",
		  "e5nil",
		  "e3nio",
		  "en3ish",
		  "en3it",
		  "e5niu",
		  "5eniz",
		  "4enn",
		  "4eno",
		  "eno4g",
		  "e4nos",
		  "en3ov",
		  "en4sw",
		  "ent5age",
		  "4enthes",
		  "en3ua",
		  "en5uf",
		  "e3ny.",
		  "4en3z",
		  "e5of",
		  "eo2g",
		  "e4oi4",
		  "e3ol",
		  "eop3ar",
		  "e1or",
		  "eo3re",
		  "eo5rol",
		  "eos4",
		  "e4ot",
		  "eo4to",
		  "e5out",
		  "e5ow",
		  "e2pa",
		  "e3pai",
		  "ep5anc",
		  "e5pel",
		  "e3pent",
		  "ep5etitio",
		  "ephe4",
		  "e4pli",
		  "e1po",
		  "e4prec",
		  "ep5reca",
		  "e4pred",
		  "ep3reh",
		  "e3pro",
		  "e4prob",
		  "ep4sh",
		  "ep5ti5b",
		  "e4put",
		  "ep5uta",
		  "e1q",
		  "equi3l",
		  "e4q3ui3s",
		  "er1a",
		  "era4b",
		  "4erand",
		  "er3ar",
		  "4erati.",
		  "2erb",
		  "er4bl",
		  "er3ch",
		  "er4che",
		  "2ere.",
		  "e3real",
		  "ere5co",
		  "ere3in",
		  "er5el.",
		  "er3emo",
		  "er5ena",
		  "er5ence",
		  "4erene",
		  "er3ent",
		  "ere4q",
		  "er5ess",
		  "er3est",
		  "eret4",
		  "er1h",
		  "er1i",
		  "e1ria4",
		  "5erick",
		  "e3rien",
		  "eri4er",
		  "er3ine",
		  "e1rio",
		  "4erit",
		  "er4iu",
		  "eri4v",
		  "e4riva",
		  "er3m4",
		  "er4nis",
		  "4ernit",
		  "5erniz",
		  "er3no",
		  "2ero",
		  "er5ob",
		  "e5roc",
		  "ero4r",
		  "er1ou",
		  "er1s",
		  "er3set",
		  "ert3er",
		  "4ertl",
		  "er3tw",
		  "4eru",
		  "eru4t",
		  "5erwau",
		  "e1s4a",
		  "e4sage.",
		  "e4sages",
		  "es2c",
		  "e2sca",
		  "es5can",
		  "e3scr",
		  "es5cu",
		  "e1s2e",
		  "e2sec",
		  "es5ecr",
		  "es5enc",
		  "e4sert.",
		  "e4serts",
		  "e4serva",
		  "4esh",
		  "e3sha",
		  "esh5en",
		  "e1si",
		  "e2sic",
		  "e2sid",
		  "es5iden",
		  "es5igna",
		  "e2s5im",
		  "es4i4n",
		  "esis4te",
		  "esi4u",
		  "e5skin",
		  "es4mi",
		  "e2sol",
		  "es3olu",
		  "e2son",
		  "es5ona",
		  "e1sp",
		  "es3per",
		  "es5pira",
		  "es4pre",
		  "2ess",
		  "es4si4b",
		  "estan4",
		  "es3tig",
		  "es5tim",
		  "4es2to",
		  "e3ston",
		  "2estr",
		  "e5stro",
		  "estruc5",
		  "e2sur",
		  "es5urr",
		  "es4w",
		  "eta4b",
		  "eten4d",
		  "e3teo",
		  "ethod3",
		  "et1ic",
		  "e5tide",
		  "etin4",
		  "eti4no",
		  "e5tir",
		  "e5titio",
		  "et5itiv",
		  "4etn",
		  "et5ona",
		  "e3tra",
		  "e3tre",
		  "et3ric",
		  "et5rif",
		  "et3rog",
		  "et5ros",
		  "et3ua",
		  "et5ym",
		  "et5z",
		  "4eu",
		  "e5un",
		  "e3up",
		  "eu3ro",
		  "eus4",
		  "eute4",
		  "euti5l",
		  "eu5tr",
		  "eva2p5",
		  "e2vas",
		  "ev5ast",
		  "e5vea",
		  "ev3ell",
		  "evel3o",
		  "e5veng",
		  "even4i",
		  "ev1er",
		  "e5verb",
		  "e1vi",
		  "ev3id",
		  "evi4l",
		  "e4vin",
		  "evi4v",
		  "e5voc",
		  "e5vu",
		  "e1wa",
		  "e4wag",
		  "e5wee",
		  "e3wh",
		  "ewil5",
		  "ew3ing",
		  "e3wit",
		  "1exp",
		  "5eyc",
		  "5eye.",
		  "eys4",
		  "1fa",
		  "fa3bl",
		  "fab3r",
		  "fa4ce",
		  "4fag",
		  "fain4",
		  "fall5e",
		  "4fa4ma",
		  "fam5is",
		  "5far",
		  "far5th",
		  "fa3ta",
		  "fa3the",
		  "4fato",
		  "fault5",
		  "4f5b",
		  "4fd",
		  "4fe.",
		  "feas4",
		  "feath3",
		  "fe4b",
		  "4feca",
		  "5fect",
		  "2fed",
		  "fe3li",
		  "fe4mo",
		  "fen2d",
		  "fend5e",
		  "fer1",
		  "5ferr",
		  "fev4",
		  "4f1f",
		  "f4fes",
		  "f4fie",
		  "f5fin.",
		  "f2f5is",
		  "f4fly",
		  "f2fy",
		  "4fh",
		  "1fi",
		  "fi3a",
		  "2f3ic.",
		  "4f3ical",
		  "f3ican",
		  "4ficate",
		  "f3icen",
		  "fi3cer",
		  "fic4i",
		  "5ficia",
		  "5ficie",
		  "4fics",
		  "fi3cu",
		  "fi5del",
		  "fight5",
		  "fil5i",
		  "fill5in",
		  "4fily",
		  "2fin",
		  "5fina",
		  "fin2d5",
		  "fi2ne",
		  "f1in3g",
		  "fin4n",
		  "fis4ti",
		  "f4l2",
		  "f5less",
		  "flin4",
		  "flo3re",
		  "f2ly5",
		  "4fm",
		  "4fn",
		  "1fo",
		  "5fon",
		  "fon4de",
		  "fon4t",
		  "fo2r",
		  "fo5rat",
		  "for5ay",
		  "fore5t",
		  "for4i",
		  "fort5a",
		  "fos5",
		  "4f5p",
		  "fra4t",
		  "f5rea",
		  "fres5c",
		  "fri2",
		  "fril4",
		  "frol5",
		  "2f3s",
		  "2ft",
		  "f4to",
		  "f2ty",
		  "3fu",
		  "fu5el",
		  "4fug",
		  "fu4min",
		  "fu5ne",
		  "fu3ri",
		  "fusi4",
		  "fus4s",
		  "4futa",
		  "1fy",
		  "1ga",
		  "gaf4",
		  "5gal.",
		  "3gali",
		  "ga3lo",
		  "2gam",
		  "ga5met",
		  "g5amo",
		  "gan5is",
		  "ga3niz",
		  "gani5za",
		  "4gano",
		  "gar5n4",
		  "gass4",
		  "gath3",
		  "4gativ",
		  "4gaz",
		  "g3b",
		  "gd4",
		  "2ge.",
		  "2ged",
		  "geez4",
		  "gel4in",
		  "ge5lis",
		  "ge5liz",
		  "4gely",
		  "1gen",
		  "ge4nat",
		  "ge5niz",
		  "4geno",
		  "4geny",
		  "1geo",
		  "ge3om",
		  "g4ery",
		  "5gesi",
		  "geth5",
		  "4geto",
		  "ge4ty",
		  "ge4v",
		  "4g1g2",
		  "g2ge",
		  "g3ger",
		  "gglu5",
		  "ggo4",
		  "gh3in",
		  "gh5out",
		  "gh4to",
		  "5gi.",
		  "1gi4a",
		  "gia5r",
		  "g1ic",
		  "5gicia",
		  "g4ico",
		  "gien5",
		  "5gies.",
		  "gil4",
		  "g3imen",
		  "3g4in.",
		  "gin5ge",
		  "5g4ins",
		  "5gio",
		  "3gir",
		  "gir4l",
		  "g3isl",
		  "gi4u",
		  "5giv",
		  "3giz",
		  "gl2",
		  "gla4",
		  "glad5i",
		  "5glas",
		  "1gle",
		  "gli4b",
		  "g3lig",
		  "3glo",
		  "glo3r",
		  "g1m",
		  "g4my",
		  "gn4a",
		  "g4na.",
		  "gnet4t",
		  "g1ni",
		  "g2nin",
		  "g4nio",
		  "g1no",
		  "g4non",
		  "1go",
		  "3go.",
		  "gob5",
		  "5goe",
		  "3g4o4g",
		  "go3is",
		  "gon2",
		  "4g3o3na",
		  "gondo5",
		  "go3ni",
		  "5goo",
		  "go5riz",
		  "gor5ou",
		  "5gos.",
		  "gov1",
		  "g3p",
		  "1gr",
		  "4grada",
		  "g4rai",
		  "gran2",
		  "5graph.",
		  "g5rapher",
		  "5graphic",
		  "4graphy",
		  "4gray",
		  "gre4n",
		  "4gress.",
		  "4grit",
		  "g4ro",
		  "gruf4",
		  "gs2",
		  "g5ste",
		  "gth3",
		  "gu4a",
		  "3guard",
		  "2gue",
		  "5gui5t",
		  "3gun",
		  "3gus",
		  "4gu4t",
		  "g3w",
		  "1gy",
		  "2g5y3n",
		  "gy5ra",
		  "h3ab4l",
		  "hach4",
		  "hae4m",
		  "hae4t",
		  "h5agu",
		  "ha3la",
		  "hala3m",
		  "ha4m",
		  "han4ci",
		  "han4cy",
		  "5hand.",
		  "han4g",
		  "hang5er",
		  "hang5o",
		  "h5a5niz",
		  "han4k",
		  "han4te",
		  "hap3l",
		  "hap5t",
		  "ha3ran",
		  "ha5ras",
		  "har2d",
		  "hard3e",
		  "har4le",
		  "harp5en",
		  "har5ter",
		  "has5s",
		  "haun4",
		  "5haz",
		  "haz3a",
		  "h1b",
		  "1head",
		  "3hear",
		  "he4can",
		  "h5ecat",
		  "h4ed",
		  "he5do5",
		  "he3l4i",
		  "hel4lis",
		  "hel4ly",
		  "h5elo",
		  "hem4p",
		  "he2n",
		  "hena4",
		  "hen5at",
		  "heo5r",
		  "hep5",
		  "h4era",
		  "hera3p",
		  "her4ba",
		  "here5a",
		  "h3ern",
		  "h5erou",
		  "h3ery",
		  "h1es",
		  "he2s5p",
		  "he4t",
		  "het4ed",
		  "heu4",
		  "h1f",
		  "h1h",
		  "hi5an",
		  "hi4co",
		  "high5",
		  "h4il2",
		  "himer4",
		  "h4ina",
		  "hion4e",
		  "hi4p",
		  "hir4l",
		  "hi3ro",
		  "hir4p",
		  "hir4r",
		  "his3el",
		  "his4s",
		  "hith5er",
		  "hi2v",
		  "4hk",
		  "4h1l4",
		  "hlan4",
		  "h2lo",
		  "hlo3ri",
		  "4h1m",
		  "hmet4",
		  "2h1n",
		  "h5odiz",
		  "h5ods",
		  "ho4g",
		  "hoge4",
		  "hol5ar",
		  "3hol4e",
		  "ho4ma",
		  "home3",
		  "hon4a",
		  "ho5ny",
		  "3hood",
		  "hoon4",
		  "hor5at",
		  "ho5ris",
		  "hort3e",
		  "ho5ru",
		  "hos4e",
		  "ho5sen",
		  "hos1p",
		  "1hous",
		  "house3",
		  "hov5el",
		  "4h5p",
		  "4hr4",
		  "hree5",
		  "hro5niz",
		  "hro3po",
		  "4h1s2",
		  "h4sh",
		  "h4tar",
		  "ht1en",
		  "ht5es",
		  "h4ty",
		  "hu4g",
		  "hu4min",
		  "hun5ke",
		  "hun4t",
		  "hus3t4",
		  "hu4t",
		  "h1w",
		  "h4wart",
		  "hy3pe",
		  "hy3ph",
		  "hy2s",
		  "2i1a",
		  "i2al",
		  "iam4",
		  "iam5ete",
		  "i2an",
		  "4ianc",
		  "ian3i",
		  "4ian4t",
		  "ia5pe",
		  "iass4",
		  "i4ativ",
		  "ia4tric",
		  "i4atu",
		  "ibe4",
		  "ib3era",
		  "ib5ert",
		  "ib5ia",
		  "ib3in",
		  "ib5it.",
		  "ib5ite",
		  "i1bl",
		  "ib3li",
		  "i5bo",
		  "i1br",
		  "i2b5ri",
		  "i5bun",
		  "4icam",
		  "5icap",
		  "4icar",
		  "i4car.",
		  "i4cara",
		  "icas5",
		  "i4cay",
		  "iccu4",
		  "4iceo",
		  "4ich",
		  "2ici",
		  "i5cid",
		  "ic5ina",
		  "i2cip",
		  "ic3ipa",
		  "i4cly",
		  "i2c5oc",
		  "4i1cr",
		  "5icra",
		  "i4cry",
		  "ic4te",
		  "ictu2",
		  "ic4t3ua",
		  "ic3ula",
		  "ic4um",
		  "ic5uo",
		  "i3cur",
		  "2id",
		  "i4dai",
		  "id5anc",
		  "id5d",
		  "ide3al",
		  "ide4s",
		  "i2di",
		  "id5ian",
		  "idi4ar",
		  "i5die",
		  "id3io",
		  "idi5ou",
		  "id1it",
		  "id5iu",
		  "i3dle",
		  "i4dom",
		  "id3ow",
		  "i4dr",
		  "i2du",
		  "id5uo",
		  "2ie4",
		  "ied4e",
		  "5ie5ga",
		  "ield3",
		  "ien5a4",
		  "ien4e",
		  "i5enn",
		  "i3enti",
		  "i1er.",
		  "i3esc",
		  "i1est",
		  "i3et",
		  "4if.",
		  "if5ero",
		  "iff5en",
		  "if4fr",
		  "4ific.",
		  "i3fie",
		  "i3fl",
		  "4ift",
		  "2ig",
		  "iga5b",
		  "ig3era",
		  "ight3i",
		  "4igi",
		  "i3gib",
		  "ig3il",
		  "ig3in",
		  "ig3it",
		  "i4g4l",
		  "i2go",
		  "ig3or",
		  "ig5ot",
		  "i5gre",
		  "igu5i",
		  "ig1ur",
		  "i3h",
		  "4i5i4",
		  "i3j",
		  "4ik",
		  "i1la",
		  "il3a4b",
		  "i4lade",
		  "i2l5am",
		  "ila5ra",
		  "i3leg",
		  "il1er",
		  "ilev4",
		  "il5f",
		  "il1i",
		  "il3ia",
		  "il2ib",
		  "il3io",
		  "il4ist",
		  "2ilit",
		  "il2iz",
		  "ill5ab",
		  "4iln",
		  "il3oq",
		  "il4ty",
		  "il5ur",
		  "il3v",
		  "i4mag",
		  "im3age",
		  "ima5ry",
		  "imenta5r",
		  "4imet",
		  "im1i",
		  "im5ida",
		  "imi5le",
		  "i5mini",
		  "4imit",
		  "im4ni",
		  "i3mon",
		  "i2mu",
		  "im3ula",
		  "2in.",
		  "i4n3au",
		  "4inav",
		  "incel4",
		  "in3cer",
		  "4ind",
		  "in5dling",
		  "2ine",
		  "i3nee",
		  "iner4ar",
		  "i5ness",
		  "4inga",
		  "4inge",
		  "in5gen",
		  "4ingi",
		  "in5gling",
		  "4ingo",
		  "4ingu",
		  "2ini",
		  "i5ni.",
		  "i4nia",
		  "in3io",
		  "in1is",
		  "i5nite.",
		  "5initio",
		  "in3ity",
		  "4ink",
		  "4inl",
		  "2inn",
		  "2i1no",
		  "i4no4c",
		  "ino4s",
		  "i4not",
		  "2ins",
		  "in3se",
		  "insur5a",
		  "2int.",
		  "2in4th",
		  "in1u",
		  "i5nus",
		  "4iny",
		  "2io",
		  "4io.",
		  "ioge4",
		  "io2gr",
		  "i1ol",
		  "io4m",
		  "ion3at",
		  "ion4ery",
		  "ion3i",
		  "io5ph",
		  "ior3i",
		  "i4os",
		  "io5th",
		  "i5oti",
		  "io4to",
		  "i4our",
		  "2ip",
		  "ipe4",
		  "iphras4",
		  "ip3i",
		  "ip4ic",
		  "ip4re4",
		  "ip3ul",
		  "i3qua",
		  "iq5uef",
		  "iq3uid",
		  "iq3ui3t",
		  "4ir",
		  "i1ra",
		  "ira4b",
		  "i4rac",
		  "ird5e",
		  "ire4de",
		  "i4ref",
		  "i4rel4",
		  "i4res",
		  "ir5gi",
		  "ir1i",
		  "iri5de",
		  "ir4is",
		  "iri3tu",
		  "5i5r2iz",
		  "ir4min",
		  "iro4g",
		  "5iron.",
		  "ir5ul",
		  "2is.",
		  "is5ag",
		  "is3ar",
		  "isas5",
		  "2is1c",
		  "is3ch",
		  "4ise",
		  "is3er",
		  "3isf",
		  "is5han",
		  "is3hon",
		  "ish5op",
		  "is3ib",
		  "isi4d",
		  "i5sis",
		  "is5itiv",
		  "4is4k",
		  "islan4",
		  "4isms",
		  "i2so",
		  "iso5mer",
		  "is1p",
		  "is2pi",
		  "is4py",
		  "4is1s",
		  "is4sal",
		  "issen4",
		  "is4ses",
		  "is4ta.",
		  "is1te",
		  "is1ti",
		  "ist4ly",
		  "4istral",
		  "i2su",
		  "is5us",
		  "4ita.",
		  "ita4bi",
		  "i4tag",
		  "4ita5m",
		  "i3tan",
		  "i3tat",
		  "2ite",
		  "it3era",
		  "i5teri",
		  "it4es",
		  "2ith",
		  "i1ti",
		  "4itia",
		  "4i2tic",
		  "it3ica",
		  "5i5tick",
		  "it3ig",
		  "it5ill",
		  "i2tim",
		  "2itio",
		  "4itis",
		  "i4tism",
		  "i2t5o5m",
		  "4iton",
		  "i4tram",
		  "it5ry",
		  "4itt",
		  "it3uat",
		  "i5tud",
		  "it3ul",
		  "4itz.",
		  "i1u",
		  "2iv",
		  "iv3ell",
		  "iv3en.",
		  "i4v3er.",
		  "i4vers.",
		  "iv5il.",
		  "iv5io",
		  "iv1it",
		  "i5vore",
		  "iv3o3ro",
		  "i4v3ot",
		  "4i5w",
		  "ix4o",
		  "4iy",
		  "4izar",
		  "izi4",
		  "5izont",
		  "5ja",
		  "jac4q",
		  "ja4p",
		  "1je",
		  "jer5s",
		  "4jestie",
		  "4jesty",
		  "jew3",
		  "jo4p",
		  "5judg",
		  "3ka.",
		  "k3ab",
		  "k5ag",
		  "kais4",
		  "kal4",
		  "k1b",
		  "k2ed",
		  "1kee",
		  "ke4g",
		  "ke5li",
		  "k3en4d",
		  "k1er",
		  "kes4",
		  "k3est.",
		  "ke4ty",
		  "k3f",
		  "kh4",
		  "k1i",
		  "5ki.",
		  "5k2ic",
		  "k4ill",
		  "kilo5",
		  "k4im",
		  "k4in.",
		  "kin4de",
		  "k5iness",
		  "kin4g",
		  "ki4p",
		  "kis4",
		  "k5ish",
		  "kk4",
		  "k1l",
		  "4kley",
		  "4kly",
		  "k1m",
		  "k5nes",
		  "1k2no",
		  "ko5r",
		  "kosh4",
		  "k3ou",
		  "kro5n",
		  "4k1s2",
		  "k4sc",
		  "ks4l",
		  "k4sy",
		  "k5t",
		  "k1w",
		  "lab3ic",
		  "l4abo",
		  "laci4",
		  "l4ade",
		  "la3dy",
		  "lag4n",
		  "lam3o",
		  "3land",
		  "lan4dl",
		  "lan5et",
		  "lan4te",
		  "lar4g",
		  "lar3i",
		  "las4e",
		  "la5tan",
		  "4lateli",
		  "4lativ",
		  "4lav",
		  "la4v4a",
		  "2l1b",
		  "lbin4",
		  "4l1c2",
		  "lce4",
		  "l3ci",
		  "2ld",
		  "l2de",
		  "ld4ere",
		  "ld4eri",
		  "ldi4",
		  "ld5is",
		  "l3dr",
		  "l4dri",
		  "le2a",
		  "le4bi",
		  "left5",
		  "5leg.",
		  "5legg",
		  "le4mat",
		  "lem5atic",
		  "4len.",
		  "3lenc",
		  "5lene.",
		  "1lent",
		  "le3ph",
		  "le4pr",
		  "lera5b",
		  "ler4e",
		  "3lerg",
		  "3l4eri",
		  "l4ero",
		  "les2",
		  "le5sco",
		  "5lesq",
		  "3less",
		  "5less.",
		  "l3eva",
		  "lev4er.",
		  "lev4era",
		  "lev4ers",
		  "3ley",
		  "4leye",
		  "2lf",
		  "l5fr",
		  "4l1g4",
		  "l5ga",
		  "lgar3",
		  "l4ges",
		  "lgo3",
		  "2l3h",
		  "li4ag",
		  "li2am",
		  "liar5iz",
		  "li4as",
		  "li4ato",
		  "li5bi",
		  "5licio",
		  "li4cor",
		  "4lics",
		  "4lict.",
		  "l4icu",
		  "l3icy",
		  "l3ida",
		  "lid5er",
		  "3lidi",
		  "lif3er",
		  "l4iff",
		  "li4fl",
		  "5ligate",
		  "3ligh",
		  "li4gra",
		  "3lik",
		  "4l4i4l",
		  "lim4bl",
		  "lim3i",
		  "li4mo",
		  "l4im4p",
		  "l4ina",
		  "1l4ine",
		  "lin3ea",
		  "lin3i",
		  "link5er",
		  "li5og",
		  "4l4iq",
		  "lis4p",
		  "l1it",
		  "l2it.",
		  "5litica",
		  "l5i5tics",
		  "liv3er",
		  "l1iz",
		  "4lj",
		  "lka3",
		  "l3kal",
		  "lka4t",
		  "l1l",
		  "l4law",
		  "l2le",
		  "l5lea",
		  "l3lec",
		  "l3leg",
		  "l3lel",
		  "l3le4n",
		  "l3le4t",
		  "ll2i",
		  "l2lin4",
		  "l5lina",
		  "ll4o",
		  "lloqui5",
		  "ll5out",
		  "l5low",
		  "2lm",
		  "l5met",
		  "lm3ing",
		  "l4mod",
		  "lmon4",
		  "2l1n2",
		  "3lo.",
		  "lob5al",
		  "lo4ci",
		  "4lof",
		  "3logic",
		  "l5ogo",
		  "3logu",
		  "lom3er",
		  "5long",
		  "lon4i",
		  "l3o3niz",
		  "lood5",
		  "5lope.",
		  "lop3i",
		  "l3opm",
		  "lora4",
		  "lo4rato",
		  "lo5rie",
		  "lor5ou",
		  "5los.",
		  "los5et",
		  "5losophiz",
		  "5losophy",
		  "los4t",
		  "lo4ta",
		  "loun5d",
		  "2lout",
		  "4lov",
		  "2lp",
		  "lpa5b",
		  "l3pha",
		  "l5phi",
		  "lp5ing",
		  "l3pit",
		  "l4pl",
		  "l5pr",
		  "4l1r",
		  "2l1s2",
		  "l4sc",
		  "l2se",
		  "l4sie",
		  "4lt",
		  "lt5ag",
		  "ltane5",
		  "l1te",
		  "lten4",
		  "ltera4",
		  "lth3i",
		  "l5ties.",
		  "ltis4",
		  "l1tr",
		  "ltu2",
		  "ltur3a",
		  "lu5a",
		  "lu3br",
		  "luch4",
		  "lu3ci",
		  "lu3en",
		  "luf4",
		  "lu5id",
		  "lu4ma",
		  "5lumi",
		  "l5umn.",
		  "5lumnia",
		  "lu3o",
		  "luo3r",
		  "4lup",
		  "luss4",
		  "lus3te",
		  "1lut",
		  "l5ven",
		  "l5vet4",
		  "2l1w",
		  "1ly",
		  "4lya",
		  "4lyb",
		  "ly5me",
		  "ly3no",
		  "2lys4",
		  "l5yse",
		  "1ma",
		  "2mab",
		  "ma2ca",
		  "ma5chine",
		  "ma4cl",
		  "mag5in",
		  "5magn",
		  "2mah",
		  "maid5",
		  "4mald",
		  "ma3lig",
		  "ma5lin",
		  "mal4li",
		  "mal4ty",
		  "5mania",
		  "man5is",
		  "man3iz",
		  "4map",
		  "ma5rine.",
		  "ma5riz",
		  "mar4ly",
		  "mar3v",
		  "ma5sce",
		  "mas4e",
		  "mas1t",
		  "5mate",
		  "math3",
		  "ma3tis",
		  "4matiza",
		  "4m1b",
		  "mba4t5",
		  "m5bil",
		  "m4b3ing",
		  "mbi4v",
		  "4m5c",
		  "4me.",
		  "2med",
		  "4med.",
		  "5media",
		  "me3die",
		  "m5e5dy",
		  "me2g",
		  "mel5on",
		  "mel4t",
		  "me2m",
		  "mem1o3",
		  "1men",
		  "men4a",
		  "men5ac",
		  "men4de",
		  "4mene",
		  "men4i",
		  "mens4",
		  "mensu5",
		  "3ment",
		  "men4te",
		  "me5on",
		  "m5ersa",
		  "2mes",
		  "3mesti",
		  "me4ta",
		  "met3al",
		  "me1te",
		  "me5thi",
		  "m4etr",
		  "5metric",
		  "me5trie",
		  "me3try",
		  "me4v",
		  "4m1f",
		  "2mh",
		  "5mi.",
		  "mi3a",
		  "mid4a",
		  "mid4g",
		  "mig4",
		  "3milia",
		  "m5i5lie",
		  "m4ill",
		  "min4a",
		  "3mind",
		  "m5inee",
		  "m4ingl",
		  "min5gli",
		  "m5ingly",
		  "min4t",
		  "m4inu",
		  "miot4",
		  "m2is",
		  "mis4er.",
		  "mis5l",
		  "mis4ti",
		  "m5istry",
		  "4mith",
		  "m2iz",
		  "4mk",
		  "4m1l",
		  "m1m",
		  "mma5ry",
		  "4m1n",
		  "mn4a",
		  "m4nin",
		  "mn4o",
		  "1mo",
		  "4mocr",
		  "5mocratiz",
		  "mo2d1",
		  "mo4go",
		  "mois2",
		  "moi5se",
		  "4mok",
		  "mo5lest",
		  "mo3me",
		  "mon5et",
		  "mon5ge",
		  "moni3a",
		  "mon4ism",
		  "mon4ist",
		  "mo3niz",
		  "monol4",
		  "mo3ny.",
		  "mo2r",
		  "4mora.",
		  "mos2",
		  "mo5sey",
		  "mo3sp",
		  "moth3",
		  "m5ouf",
		  "3mous",
		  "mo2v",
		  "4m1p",
		  "mpara5",
		  "mpa5rab",
		  "mpar5i",
		  "m3pet",
		  "mphas4",
		  "m2pi",
		  "mpi4a",
		  "mp5ies",
		  "m4p1in",
		  "m5pir",
		  "mp5is",
		  "mpo3ri",
		  "mpos5ite",
		  "m4pous",
		  "mpov5",
		  "mp4tr",
		  "m2py",
		  "4m3r",
		  "4m1s2",
		  "m4sh",
		  "m5si",
		  "4mt",
		  "1mu",
		  "mula5r4",
		  "5mult",
		  "multi3",
		  "3mum",
		  "mun2",
		  "4mup",
		  "mu4u",
		  "4mw",
		  "1na",
		  "2n1a2b",
		  "n4abu",
		  "4nac.",
		  "na4ca",
		  "n5act",
		  "nag5er.",
		  "nak4",
		  "na4li",
		  "na5lia",
		  "4nalt",
		  "na5mit",
		  "n2an",
		  "nanci4",
		  "nan4it",
		  "nank4",
		  "nar3c",
		  "4nare",
		  "nar3i",
		  "nar4l",
		  "n5arm",
		  "n4as",
		  "nas4c",
		  "nas5ti",
		  "n2at",
		  "na3tal",
		  "nato5miz",
		  "n2au",
		  "nau3se",
		  "3naut",
		  "nav4e",
		  "4n1b4",
		  "ncar5",
		  "n4ces.",
		  "n3cha",
		  "n5cheo",
		  "n5chil",
		  "n3chis",
		  "nc1in",
		  "nc4it",
		  "ncour5a",
		  "n1cr",
		  "n1cu",
		  "n4dai",
		  "n5dan",
		  "n1de",
		  "nd5est.",
		  "ndi4b",
		  "n5d2if",
		  "n1dit",
		  "n3diz",
		  "n5duc",
		  "ndu4r",
		  "nd2we",
		  "2ne.",
		  "n3ear",
		  "ne2b",
		  "neb3u",
		  "ne2c",
		  "5neck",
		  "2ned",
		  "ne4gat",
		  "neg5ativ",
		  "5nege",
		  "ne4la",
		  "nel5iz",
		  "ne5mi",
		  "ne4mo",
		  "1nen",
		  "4nene",
		  "3neo",
		  "ne4po",
		  "ne2q",
		  "n1er",
		  "nera5b",
		  "n4erar",
		  "n2ere",
		  "n4er5i",
		  "ner4r",
		  "1nes",
		  "2nes.",
		  "4nesp",
		  "2nest",
		  "4nesw",
		  "3netic",
		  "ne4v",
		  "n5eve",
		  "ne4w",
		  "n3f",
		  "n4gab",
		  "n3gel",
		  "nge4n4e",
		  "n5gere",
		  "n3geri",
		  "ng5ha",
		  "n3gib",
		  "ng1in",
		  "n5git",
		  "n4gla",
		  "ngov4",
		  "ng5sh",
		  "n1gu",
		  "n4gum",
		  "n2gy",
		  "4n1h4",
		  "nha4",
		  "nhab3",
		  "nhe4",
		  "3n4ia",
		  "ni3an",
		  "ni4ap",
		  "ni3ba",
		  "ni4bl",
		  "ni4d",
		  "ni5di",
		  "ni4er",
		  "ni2fi",
		  "ni5ficat",
		  "n5igr",
		  "nik4",
		  "n1im",
		  "ni3miz",
		  "n1in",
		  "5nine.",
		  "nin4g",
		  "ni4o",
		  "5nis.",
		  "nis4ta",
		  "n2it",
		  "n4ith",
		  "3nitio",
		  "n3itor",
		  "ni3tr",
		  "n1j",
		  "4nk2",
		  "n5kero",
		  "n3ket",
		  "nk3in",
		  "n1kl",
		  "4n1l",
		  "n5m",
		  "nme4",
		  "nmet4",
		  "4n1n2",
		  "nne4",
		  "nni3al",
		  "nni4v",
		  "nob4l",
		  "no3ble",
		  "n5ocl",
		  "4n3o2d",
		  "3noe",
		  "4nog",
		  "noge4",
		  "nois5i",
		  "no5l4i",
		  "5nologis",
		  "3nomic",
		  "n5o5miz",
		  "no4mo",
		  "no3my",
		  "no4n",
		  "non4ag",
		  "non5i",
		  "n5oniz",
		  "4nop",
		  "5nop5o5li",
		  "nor5ab",
		  "no4rary",
		  "4nosc",
		  "nos4e",
		  "nos5t",
		  "no5ta",
		  "1nou",
		  "3noun",
		  "nov3el3",
		  "nowl3",
		  "n1p4",
		  "npi4",
		  "npre4c",
		  "n1q",
		  "n1r",
		  "nru4",
		  "2n1s2",
		  "ns5ab",
		  "nsati4",
		  "ns4c",
		  "n2se",
		  "n4s3es",
		  "nsid1",
		  "nsig4",
		  "n2sl",
		  "ns3m",
		  "n4soc",
		  "ns4pe",
		  "n5spi",
		  "nsta5bl",
		  "n1t",
		  "nta4b",
		  "nter3s",
		  "nt2i",
		  "n5tib",
		  "nti4er",
		  "nti2f",
		  "n3tine",
		  "n4t3ing",
		  "nti4p",
		  "ntrol5li",
		  "nt4s",
		  "ntu3me",
		  "nu1a",
		  "nu4d",
		  "nu5en",
		  "nuf4fe",
		  "n3uin",
		  "3nu3it",
		  "n4um",
		  "nu1me",
		  "n5umi",
		  "3nu4n",
		  "n3uo",
		  "nu3tr",
		  "n1v2",
		  "n1w4",
		  "nym4",
		  "nyp4",
		  "4nz",
		  "n3za",
		  "4oa",
		  "oad3",
		  "o5a5les",
		  "oard3",
		  "oas4e",
		  "oast5e",
		  "oat5i",
		  "ob3a3b",
		  "o5bar",
		  "obe4l",
		  "o1bi",
		  "o2bin",
		  "ob5ing",
		  "o3br",
		  "ob3ul",
		  "o1ce",
		  "och4",
		  "o3chet",
		  "ocif3",
		  "o4cil",
		  "o4clam",
		  "o4cod",
		  "oc3rac",
		  "oc5ratiz",
		  "ocre3",
		  "5ocrit",
		  "octor5a",
		  "oc3ula",
		  "o5cure",
		  "od5ded",
		  "od3ic",
		  "odi3o",
		  "o2do4",
		  "odor3",
		  "od5uct.",
		  "od5ucts",
		  "o4el",
		  "o5eng",
		  "o3er",
		  "oe4ta",
		  "o3ev",
		  "o2fi",
		  "of5ite",
		  "ofit4t",
		  "o2g5a5r",
		  "og5ativ",
		  "o4gato",
		  "o1ge",
		  "o5gene",
		  "o5geo",
		  "o4ger",
		  "o3gie",
		  "1o1gis",
		  "og3it",
		  "o4gl",
		  "o5g2ly",
		  "3ogniz",
		  "o4gro",
		  "ogu5i",
		  "1ogy",
		  "2ogyn",
		  "o1h2",
		  "ohab5",
		  "oi2",
		  "oic3es",
		  "oi3der",
		  "oiff4",
		  "oig4",
		  "oi5let",
		  "o3ing",
		  "oint5er",
		  "o5ism",
		  "oi5son",
		  "oist5en",
		  "oi3ter",
		  "o5j",
		  "2ok",
		  "o3ken",
		  "ok5ie",
		  "o1la",
		  "o4lan",
		  "olass4",
		  "ol2d",
		  "old1e",
		  "ol3er",
		  "o3lesc",
		  "o3let",
		  "ol4fi",
		  "ol2i",
		  "o3lia",
		  "o3lice",
		  "ol5id.",
		  "o3li4f",
		  "o5lil",
		  "ol3ing",
		  "o5lio",
		  "o5lis.",
		  "ol3ish",
		  "o5lite",
		  "o5litio",
		  "o5liv",
		  "olli4e",
		  "ol5ogiz",
		  "olo4r",
		  "ol5pl",
		  "ol2t",
		  "ol3ub",
		  "ol3ume",
		  "ol3un",
		  "o5lus",
		  "ol2v",
		  "o2ly",
		  "om5ah",
		  "oma5l",
		  "om5atiz",
		  "om2be",
		  "om4bl",
		  "o2me",
		  "om3ena",
		  "om5erse",
		  "o4met",
		  "om5etry",
		  "o3mia",
		  "om3ic.",
		  "om3ica",
		  "o5mid",
		  "om1in",
		  "o5mini",
		  "5ommend",
		  "omo4ge",
		  "o4mon",
		  "om3pi",
		  "ompro5",
		  "o2n",
		  "on1a",
		  "on4ac",
		  "o3nan",
		  "on1c",
		  "3oncil",
		  "2ond",
		  "on5do",
		  "o3nen",
		  "on5est",
		  "on4gu",
		  "on1ic",
		  "o3nio",
		  "on1is",
		  "o5niu",
		  "on3key",
		  "on4odi",
		  "on3omy",
		  "on3s",
		  "onspi4",
		  "onspir5a",
		  "onsu4",
		  "onten4",
		  "on3t4i",
		  "ontif5",
		  "on5um",
		  "onva5",
		  "oo2",
		  "ood5e",
		  "ood5i",
		  "oo4k",
		  "oop3i",
		  "o3ord",
		  "oost5",
		  "o2pa",
		  "ope5d",
		  "op1er",
		  "3opera",
		  "4operag",
		  "2oph",
		  "o5phan",
		  "o5pher",
		  "op3ing",
		  "o3pit",
		  "o5pon",
		  "o4posi",
		  "o1pr",
		  "op1u",
		  "opy5",
		  "o1q",
		  "o1ra",
		  "o5ra.",
		  "o4r3ag",
		  "or5aliz",
		  "or5ange",
		  "ore5a",
		  "o5real",
		  "or3ei",
		  "ore5sh",
		  "or5est.",
		  "orew4",
		  "or4gu",
		  "4o5ria",
		  "or3ica",
		  "o5ril",
		  "or1in",
		  "o1rio",
		  "or3ity",
		  "o3riu",
		  "or2mi",
		  "orn2e",
		  "o5rof",
		  "or3oug",
		  "or5pe",
		  "3orrh",
		  "or4se",
		  "ors5en",
		  "orst4",
		  "or3thi",
		  "or3thy",
		  "or4ty",
		  "o5rum",
		  "o1ry",
		  "os3al",
		  "os2c",
		  "os4ce",
		  "o3scop",
		  "4oscopi",
		  "o5scr",
		  "os4i4e",
		  "os5itiv",
		  "os3ito",
		  "os3ity",
		  "osi4u",
		  "os4l",
		  "o2so",
		  "os4pa",
		  "os4po",
		  "os2ta",
		  "o5stati",
		  "os5til",
		  "os5tit",
		  "o4tan",
		  "otele4g",
		  "ot3er.",
		  "ot5ers",
		  "o4tes",
		  "4oth",
		  "oth5esi",
		  "oth3i4",
		  "ot3ic.",
		  "ot5ica",
		  "o3tice",
		  "o3tif",
		  "o3tis",
		  "oto5s",
		  "ou2",
		  "ou3bl",
		  "ouch5i",
		  "ou5et",
		  "ou4l",
		  "ounc5er",
		  "oun2d",
		  "ou5v",
		  "ov4en",
		  "over4ne",
		  "over3s",
		  "ov4ert",
		  "o3vis",
		  "oviti4",
		  "o5v4ol",
		  "ow3der",
		  "ow3el",
		  "ow5est",
		  "ow1i",
		  "own5i",
		  "o4wo",
		  "oy1a",
		  "1pa",
		  "pa4ca",
		  "pa4ce",
		  "pac4t",
		  "p4ad",
		  "5pagan",
		  "p3agat",
		  "p4ai",
		  "pain4",
		  "p4al",
		  "pan4a",
		  "pan3el",
		  "pan4ty",
		  "pa3ny",
		  "pa1p",
		  "pa4pu",
		  "para5bl",
		  "par5age",
		  "par5di",
		  "3pare",
		  "par5el",
		  "p4a4ri",
		  "par4is",
		  "pa2te",
		  "pa5ter",
		  "5pathic",
		  "pa5thy",
		  "pa4tric",
		  "pav4",
		  "3pay",
		  "4p1b",
		  "pd4",
		  "4pe.",
		  "3pe4a",
		  "pear4l",
		  "pe2c",
		  "2p2ed",
		  "3pede",
		  "3pedi",
		  "pedia4",
		  "ped4ic",
		  "p4ee",
		  "pee4d",
		  "pek4",
		  "pe4la",
		  "peli4e",
		  "pe4nan",
		  "p4enc",
		  "pen4th",
		  "pe5on",
		  "p4era.",
		  "pera5bl",
		  "p4erag",
		  "p4eri",
		  "peri5st",
		  "per4mal",
		  "perme5",
		  "p4ern",
		  "per3o",
		  "per3ti",
		  "pe5ru",
		  "per1v",
		  "pe2t",
		  "pe5ten",
		  "pe5tiz",
		  "4pf",
		  "4pg",
		  "4ph.",
		  "phar5i",
		  "phe3no",
		  "ph4er",
		  "ph4es.",
		  "ph1ic",
		  "5phie",
		  "ph5ing",
		  "5phisti",
		  "3phiz",
		  "ph2l",
		  "3phob",
		  "3phone",
		  "5phoni",
		  "pho4r",
		  "4phs",
		  "ph3t",
		  "5phu",
		  "1phy",
		  "pi3a",
		  "pian4",
		  "pi4cie",
		  "pi4cy",
		  "p4id",
		  "p5ida",
		  "pi3de",
		  "5pidi",
		  "3piec",
		  "pi3en",
		  "pi4grap",
		  "pi3lo",
		  "pi2n",
		  "p4in.",
		  "pind4",
		  "p4ino",
		  "3pi1o",
		  "pion4",
		  "p3ith",
		  "pi5tha",
		  "pi2tu",
		  "2p3k2",
		  "1p2l2",
		  "3plan",
		  "plas5t",
		  "pli3a",
		  "pli5er",
		  "4plig",
		  "pli4n",
		  "ploi4",
		  "plu4m",
		  "plum4b",
		  "4p1m",
		  "2p3n",
		  "po4c",
		  "5pod.",
		  "po5em",
		  "po3et5",
		  "5po4g",
		  "poin2",
		  "5point",
		  "poly5t",
		  "po4ni",
		  "po4p",
		  "1p4or",
		  "po4ry",
		  "1pos",
		  "pos1s",
		  "p4ot",
		  "po4ta",
		  "5poun",
		  "4p1p",
		  "ppa5ra",
		  "p2pe",
		  "p4ped",
		  "p5pel",
		  "p3pen",
		  "p3per",
		  "p3pet",
		  "ppo5site",
		  "pr2",
		  "pray4e",
		  "5preci",
		  "pre5co",
		  "pre3em",
		  "pref5ac",
		  "pre4la",
		  "pre3r",
		  "p3rese",
		  "3press",
		  "pre5ten",
		  "pre3v",
		  "5pri4e",
		  "prin4t3",
		  "pri4s",
		  "pris3o",
		  "p3roca",
		  "prof5it",
		  "pro3l",
		  "pros3e",
		  "pro1t",
		  "2p1s2",
		  "p2se",
		  "ps4h",
		  "p4sib",
		  "2p1t",
		  "pt5a4b",
		  "p2te",
		  "p2th",
		  "pti3m",
		  "ptu4r",
		  "p4tw",
		  "pub3",
		  "pue4",
		  "puf4",
		  "pul3c",
		  "pu4m",
		  "pu2n",
		  "pur4r",
		  "5pus",
		  "pu2t",
		  "5pute",
		  "put3er",
		  "pu3tr",
		  "put4ted",
		  "put4tin",
		  "p3w",
		  "qu2",
		  "qua5v",
		  "2que.",
		  "3quer",
		  "3quet",
		  "2rab",
		  "ra3bi",
		  "rach4e",
		  "r5acl",
		  "raf5fi",
		  "raf4t",
		  "r2ai",
		  "ra4lo",
		  "ram3et",
		  "r2ami",
		  "rane5o",
		  "ran4ge",
		  "r4ani",
		  "ra5no",
		  "rap3er",
		  "3raphy",
		  "rar5c",
		  "rare4",
		  "rar5ef",
		  "4raril",
		  "r2as",
		  "ration4",
		  "rau4t",
		  "ra5vai",
		  "rav3el",
		  "ra5zie",
		  "r1b",
		  "r4bab",
		  "r4bag",
		  "rbi2",
		  "rbi4f",
		  "r2bin",
		  "r5bine",
		  "rb5ing.",
		  "rb4o",
		  "r1c",
		  "r2ce",
		  "rcen4",
		  "r3cha",
		  "rch4er",
		  "r4ci4b",
		  "rc4it",
		  "rcum3",
		  "r4dal",
		  "rd2i",
		  "rdi4a",
		  "rdi4er",
		  "rdin4",
		  "rd3ing",
		  "2re.",
		  "re1al",
		  "re3an",
		  "re5arr",
		  "5reav",
		  "re4aw",
		  "r5ebrat",
		  "rec5oll",
		  "rec5ompe",
		  "re4cre",
		  "2r2ed",
		  "re1de",
		  "re3dis",
		  "red5it",
		  "re4fac",
		  "re2fe",
		  "re5fer.",
		  "re3fi",
		  "re4fy",
		  "reg3is",
		  "re5it",
		  "re1li",
		  "re5lu",
		  "r4en4ta",
		  "ren4te",
		  "re1o",
		  "re5pin",
		  "re4posi",
		  "re1pu",
		  "r1er4",
		  "r4eri",
		  "rero4",
		  "re5ru",
		  "r4es.",
		  "re4spi",
		  "ress5ib",
		  "res2t",
		  "re5stal",
		  "re3str",
		  "re4ter",
		  "re4ti4z",
		  "re3tri",
		  "reu2",
		  "re5uti",
		  "rev2",
		  "re4val",
		  "rev3el",
		  "r5ev5er.",
		  "re5vers",
		  "re5vert",
		  "re5vil",
		  "rev5olu",
		  "re4wh",
		  "r1f",
		  "rfu4",
		  "r4fy",
		  "rg2",
		  "rg3er",
		  "r3get",
		  "r3gic",
		  "rgi4n",
		  "rg3ing",
		  "r5gis",
		  "r5git",
		  "r1gl",
		  "rgo4n",
		  "r3gu",
		  "rh4",
		  "4rh.",
		  "4rhal",
		  "ri3a",
		  "ria4b",
		  "ri4ag",
		  "r4ib",
		  "rib3a",
		  "ric5as",
		  "r4ice",
		  "4rici",
		  "5ricid",
		  "ri4cie",
		  "r4ico",
		  "rid5er",
		  "ri3enc",
		  "ri3ent",
		  "ri1er",
		  "ri5et",
		  "rig5an",
		  "5rigi",
		  "ril3iz",
		  "5riman",
		  "rim5i",
		  "3rimo",
		  "rim4pe",
		  "r2ina",
		  "5rina.",
		  "rin4d",
		  "rin4e",
		  "rin4g",
		  "ri1o",
		  "5riph",
		  "riph5e",
		  "ri2pl",
		  "rip5lic",
		  "r4iq",
		  "r2is",
		  "r4is.",
		  "ris4c",
		  "r3ish",
		  "ris4p",
		  "ri3ta3b",
		  "r5ited.",
		  "rit5er.",
		  "rit5ers",
		  "rit3ic",
		  "ri2tu",
		  "rit5ur",
		  "riv5el",
		  "riv3et",
		  "riv3i",
		  "r3j",
		  "r3ket",
		  "rk4le",
		  "rk4lin",
		  "r1l",
		  "rle4",
		  "r2led",
		  "r4lig",
		  "r4lis",
		  "rl5ish",
		  "r3lo4",
		  "r1m",
		  "rma5c",
		  "r2me",
		  "r3men",
		  "rm5ers",
		  "rm3ing",
		  "r4ming.",
		  "r4mio",
		  "r3mit",
		  "r4my",
		  "r4nar",
		  "r3nel",
		  "r4ner",
		  "r5net",
		  "r3ney",
		  "r5nic",
		  "r1nis4",
		  "r3nit",
		  "r3niv",
		  "rno4",
		  "r4nou",
		  "r3nu",
		  "rob3l",
		  "r2oc",
		  "ro3cr",
		  "ro4e",
		  "ro1fe",
		  "ro5fil",
		  "rok2",
		  "ro5ker",
		  "5role.",
		  "rom5ete",
		  "rom4i",
		  "rom4p",
		  "ron4al",
		  "ron4e",
		  "ro5n4is",
		  "ron4ta",
		  "1room",
		  "5root",
		  "ro3pel",
		  "rop3ic",
		  "ror3i",
		  "ro5ro",
		  "ros5per",
		  "ros4s",
		  "ro4the",
		  "ro4ty",
		  "ro4va",
		  "rov5el",
		  "rox5",
		  "r1p",
		  "r4pea",
		  "r5pent",
		  "rp5er.",
		  "r3pet",
		  "rp4h4",
		  "rp3ing",
		  "r3po",
		  "r1r4",
		  "rre4c",
		  "rre4f",
		  "r4reo",
		  "rre4st",
		  "rri4o",
		  "rri4v",
		  "rron4",
		  "rros4",
		  "rrys4",
		  "4rs2",
		  "r1sa",
		  "rsa5ti",
		  "rs4c",
		  "r2se",
		  "r3sec",
		  "rse4cr",
		  "rs5er.",
		  "rs3es",
		  "rse5v2",
		  "r1sh",
		  "r5sha",
		  "r1si",
		  "r4si4b",
		  "rson3",
		  "r1sp",
		  "r5sw",
		  "rtach4",
		  "r4tag",
		  "r3teb",
		  "rten4d",
		  "rte5o",
		  "r1ti",
		  "rt5ib",
		  "rti4d",
		  "r4tier",
		  "r3tig",
		  "rtil3i",
		  "rtil4l",
		  "r4tily",
		  "r4tist",
		  "r4tiv",
		  "r3tri",
		  "rtroph4",
		  "rt4sh",
		  "ru3a",
		  "ru3e4l",
		  "ru3en",
		  "ru4gl",
		  "ru3in",
		  "rum3pl",
		  "ru2n",
		  "runk5",
		  "run4ty",
		  "r5usc",
		  "ruti5n",
		  "rv4e",
		  "rvel4i",
		  "r3ven",
		  "rv5er.",
		  "r5vest",
		  "r3vey",
		  "r3vic",
		  "rvi4v",
		  "r3vo",
		  "r1w",
		  "ry4c",
		  "5rynge",
		  "ry3t",
		  "sa2",
		  "2s1ab",
		  "5sack",
		  "sac3ri",
		  "s3act",
		  "5sai",
		  "salar4",
		  "sal4m",
		  "sa5lo",
		  "sal4t",
		  "3sanc",
		  "san4de",
		  "s1ap",
		  "sa5ta",
		  "5sa3tio",
		  "sat3u",
		  "sau4",
		  "sa5vor",
		  "5saw",
		  "4s5b",
		  "scan4t5",
		  "sca4p",
		  "scav5",
		  "s4ced",
		  "4scei",
		  "s4ces",
		  "sch2",
		  "s4cho",
		  "3s4cie",
		  "5scin4d",
		  "scle5",
		  "s4cli",
		  "scof4",
		  "4scopy",
		  "scour5a",
		  "s1cu",
		  "4s5d",
		  "4se.",
		  "se4a",
		  "seas4",
		  "sea5w",
		  "se2c3o",
		  "3sect",
		  "4s4ed",
		  "se4d4e",
		  "s5edl",
		  "se2g",
		  "seg3r",
		  "5sei",
		  "se1le",
		  "5self",
		  "5selv",
		  "4seme",
		  "se4mol",
		  "sen5at",
		  "4senc",
		  "sen4d",
		  "s5ened",
		  "sen5g",
		  "s5enin",
		  "4sentd",
		  "4sentl",
		  "sep3a3",
		  "4s1er.",
		  "s4erl",
		  "ser4o",
		  "4servo",
		  "s1e4s",
		  "se5sh",
		  "ses5t",
		  "5se5um",
		  "5sev",
		  "sev3en",
		  "sew4i",
		  "5sex",
		  "4s3f",
		  "2s3g",
		  "s2h",
		  "2sh.",
		  "sh1er",
		  "5shev",
		  "sh1in",
		  "sh3io",
		  "3ship",
		  "shiv5",
		  "sho4",
		  "sh5old",
		  "shon3",
		  "shor4",
		  "short5",
		  "4shw",
		  "si1b",
		  "s5icc",
		  "3side.",
		  "5sides",
		  "5sidi",
		  "si5diz",
		  "4signa",
		  "sil4e",
		  "4sily",
		  "2s1in",
		  "s2ina",
		  "5sine.",
		  "s3ing",
		  "1sio",
		  "5sion",
		  "sion5a",
		  "si2r",
		  "sir5a",
		  "1sis",
		  "3sitio",
		  "5siu",
		  "1siv",
		  "5siz",
		  "sk2",
		  "4ske",
		  "s3ket",
		  "sk5ine",
		  "sk5ing",
		  "s1l2",
		  "s3lat",
		  "s2le",
		  "slith5",
		  "2s1m",
		  "s3ma",
		  "small3",
		  "sman3",
		  "smel4",
		  "s5men",
		  "5smith",
		  "smol5d4",
		  "s1n4",
		  "1so",
		  "so4ce",
		  "soft3",
		  "so4lab",
		  "sol3d2",
		  "so3lic",
		  "5solv",
		  "3som",
		  "3s4on.",
		  "sona4",
		  "son4g",
		  "s4op",
		  "5sophic",
		  "s5ophiz",
		  "s5ophy",
		  "sor5c",
		  "sor5d",
		  "4sov",
		  "so5vi",
		  "2spa",
		  "5spai",
		  "spa4n",
		  "spen4d",
		  "2s5peo",
		  "2sper",
		  "s2phe",
		  "3spher",
		  "spho5",
		  "spil4",
		  "sp5ing",
		  "4spio",
		  "s4ply",
		  "s4pon",
		  "spor4",
		  "4spot",
		  "squal4l",
		  "s1r",
		  "2ss",
		  "s1sa",
		  "ssas3",
		  "s2s5c",
		  "s3sel",
		  "s5seng",
		  "s4ses.",
		  "s5set",
		  "s1si",
		  "s4sie",
		  "ssi4er",
		  "ss5ily",
		  "s4sl",
		  "ss4li",
		  "s4sn",
		  "sspend4",
		  "ss2t",
		  "ssur5a",
		  "ss5w",
		  "2st.",
		  "s2tag",
		  "s2tal",
		  "stam4i",
		  "5stand",
		  "s4ta4p",
		  "5stat.",
		  "s4ted",
		  "stern5i",
		  "s5tero",
		  "ste2w",
		  "stew5a",
		  "s3the",
		  "st2i",
		  "s4ti.",
		  "s5tia",
		  "s1tic",
		  "5stick",
		  "s4tie",
		  "s3tif",
		  "st3ing",
		  "5stir",
		  "s1tle",
		  "5stock",
		  "stom3a",
		  "5stone",
		  "s4top",
		  "3store",
		  "st4r",
		  "s4trad",
		  "5stratu",
		  "s4tray",
		  "s4trid",
		  "4stry",
		  "4st3w",
		  "s2ty",
		  "1su",
		  "su1al",
		  "su4b3",
		  "su2g3",
		  "su5is",
		  "suit3",
		  "s4ul",
		  "su2m",
		  "sum3i",
		  "su2n",
		  "su2r",
		  "4sv",
		  "sw2",
		  "4swo",
		  "s4y",
		  "4syc",
		  "3syl",
		  "syn5o",
		  "sy5rin",
		  "1ta",
		  "3ta.",
		  "2tab",
		  "ta5bles",
		  "5taboliz",
		  "4taci",
		  "ta5do",
		  "4taf4",
		  "tai5lo",
		  "ta2l",
		  "ta5la",
		  "tal5en",
		  "tal3i",
		  "4talk",
		  "tal4lis",
		  "ta5log",
		  "ta5mo",
		  "tan4de",
		  "tanta3",
		  "ta5per",
		  "ta5pl",
		  "tar4a",
		  "4tarc",
		  "4tare",
		  "ta3riz",
		  "tas4e",
		  "ta5sy",
		  "4tatic",
		  "ta4tur",
		  "taun4",
		  "tav4",
		  "2taw",
		  "tax4is",
		  "2t1b",
		  "4tc",
		  "t4ch",
		  "tch5et",
		  "4t1d",
		  "4te.",
		  "tead4i",
		  "4teat",
		  "tece4",
		  "5tect",
		  "2t1ed",
		  "te5di",
		  "1tee",
		  "teg4",
		  "te5ger",
		  "te5gi",
		  "3tel.",
		  "teli4",
		  "5tels",
		  "te2ma2",
		  "tem3at",
		  "3tenan",
		  "3tenc",
		  "3tend",
		  "4tenes",
		  "1tent",
		  "ten4tag",
		  "1teo",
		  "te4p",
		  "te5pe",
		  "ter3c",
		  "5ter3d",
		  "1teri",
		  "ter5ies",
		  "ter3is",
		  "teri5za",
		  "5ternit",
		  "ter5v",
		  "4tes.",
		  "4tess",
		  "t3ess.",
		  "teth5e",
		  "3teu",
		  "3tex",
		  "4tey",
		  "2t1f",
		  "4t1g",
		  "2th.",
		  "than4",
		  "th2e",
		  "4thea",
		  "th3eas",
		  "the5at",
		  "the3is",
		  "3thet",
		  "th5ic.",
		  "th5ica",
		  "4thil",
		  "5think",
		  "4thl",
		  "th5ode",
		  "5thodic",
		  "4thoo",
		  "thor5it",
		  "tho5riz",
		  "2ths",
		  "1tia",
		  "ti4ab",
		  "ti4ato",
		  "2ti2b",
		  "4tick",
		  "t4ico",
		  "t4ic1u",
		  "5tidi",
		  "3tien",
		  "tif2",
		  "ti5fy",
		  "2tig",
		  "5tigu",
		  "till5in",
		  "1tim",
		  "4timp",
		  "tim5ul",
		  "2t1in",
		  "t2ina",
		  "3tine.",
		  "3tini",
		  "1tio",
		  "ti5oc",
		  "tion5ee",
		  "5tiq",
		  "ti3sa",
		  "3tise",
		  "tis4m",
		  "ti5so",
		  "tis4p",
		  "5tistica",
		  "ti3tl",
		  "ti4u",
		  "1tiv",
		  "tiv4a",
		  "1tiz",
		  "ti3za",
		  "ti3zen",
		  "2tl",
		  "t5la",
		  "tlan4",
		  "3tle.",
		  "3tled",
		  "3tles.",
		  "t5let.",
		  "t5lo",
		  "4t1m",
		  "tme4",
		  "2t1n2",
		  "1to",
		  "to3b",
		  "to5crat",
		  "4todo",
		  "2tof",
		  "to2gr",
		  "to5ic",
		  "to2ma",
		  "tom4b",
		  "to3my",
		  "ton4ali",
		  "to3nat",
		  "4tono",
		  "4tony",
		  "to2ra",
		  "to3rie",
		  "tor5iz",
		  "tos2",
		  "5tour",
		  "4tout",
		  "to3war",
		  "4t1p",
		  "1tra",
		  "tra3b",
		  "tra5ch",
		  "traci4",
		  "trac4it",
		  "trac4te",
		  "tras4",
		  "tra5ven",
		  "trav5es5",
		  "tre5f",
		  "tre4m",
		  "trem5i",
		  "5tria",
		  "tri5ces",
		  "5tricia",
		  "4trics",
		  "2trim",
		  "tri4v",
		  "tro5mi",
		  "tron5i",
		  "4trony",
		  "tro5phe",
		  "tro3sp",
		  "tro3v",
		  "tru5i",
		  "trus4",
		  "4t1s2",
		  "t4sc",
		  "tsh4",
		  "t4sw",
		  "4t3t2",
		  "t4tes",
		  "t5to",
		  "ttu4",
		  "1tu",
		  "tu1a",
		  "tu3ar",
		  "tu4bi",
		  "tud2",
		  "4tue",
		  "4tuf4",
		  "5tu3i",
		  "3tum",
		  "tu4nis",
		  "2t3up.",
		  "3ture",
		  "5turi",
		  "tur3is",
		  "tur5o",
		  "tu5ry",
		  "3tus",
		  "4tv",
		  "tw4",
		  "4t1wa",
		  "twis4",
		  "4two",
		  "1ty",
		  "4tya",
		  "2tyl",
		  "type3",
		  "ty5ph",
		  "4tz",
		  "tz4e",
		  "4uab",
		  "uac4",
		  "ua5na",
		  "uan4i",
		  "uar5ant",
		  "uar2d",
		  "uar3i",
		  "uar3t",
		  "u1at",
		  "uav4",
		  "ub4e",
		  "u4bel",
		  "u3ber",
		  "u4bero",
		  "u1b4i",
		  "u4b5ing",
		  "u3ble.",
		  "u3ca",
		  "uci4b",
		  "uc4it",
		  "ucle3",
		  "u3cr",
		  "u3cu",
		  "u4cy",
		  "ud5d",
		  "ud3er",
		  "ud5est",
		  "udev4",
		  "u1dic",
		  "ud3ied",
		  "ud3ies",
		  "ud5is",
		  "u5dit",
		  "u4don",
		  "ud4si",
		  "u4du",
		  "u4ene",
		  "uens4",
		  "uen4te",
		  "uer4il",
		  "3ufa",
		  "u3fl",
		  "ugh3en",
		  "ug5in",
		  "2ui2",
		  "uil5iz",
		  "ui4n",
		  "u1ing",
		  "uir4m",
		  "uita4",
		  "uiv3",
		  "uiv4er.",
		  "u5j",
		  "4uk",
		  "u1la",
		  "ula5b",
		  "u5lati",
		  "ulch4",
		  "5ulche",
		  "ul3der",
		  "ul4e",
		  "u1len",
		  "ul4gi",
		  "ul2i",
		  "u5lia",
		  "ul3ing",
		  "ul5ish",
		  "ul4lar",
		  "ul4li4b",
		  "ul4lis",
		  "4ul3m",
		  "u1l4o",
		  "4uls",
		  "uls5es",
		  "ul1ti",
		  "ultra3",
		  "4ultu",
		  "u3lu",
		  "ul5ul",
		  "ul5v",
		  "um5ab",
		  "um4bi",
		  "um4bly",
		  "u1mi",
		  "u4m3ing",
		  "umor5o",
		  "um2p",
		  "unat4",
		  "u2ne",
		  "un4er",
		  "u1ni",
		  "un4im",
		  "u2nin",
		  "un5ish",
		  "uni3v",
		  "un3s4",
		  "un4sw",
		  "unt3ab",
		  "un4ter.",
		  "un4tes",
		  "unu4",
		  "un5y",
		  "un5z",
		  "u4ors",
		  "u5os",
		  "u1ou",
		  "u1pe",
		  "uper5s",
		  "u5pia",
		  "up3ing",
		  "u3pl",
		  "up3p",
		  "upport5",
		  "upt5ib",
		  "uptu4",
		  "u1ra",
		  "4ura.",
		  "u4rag",
		  "u4ras",
		  "ur4be",
		  "urc4",
		  "ur1d",
		  "ure5at",
		  "ur4fer",
		  "ur4fr",
		  "u3rif",
		  "uri4fic",
		  "ur1in",
		  "u3rio",
		  "u1rit",
		  "ur3iz",
		  "ur2l",
		  "url5ing.",
		  "ur4no",
		  "uros4",
		  "ur4pe",
		  "ur4pi",
		  "urs5er",
		  "ur5tes",
		  "ur3the",
		  "urti4",
		  "ur4tie",
		  "u3ru",
		  "2us",
		  "u5sad",
		  "u5san",
		  "us4ap",
		  "usc2",
		  "us3ci",
		  "use5a",
		  "u5sia",
		  "u3sic",
		  "us4lin",
		  "us1p",
		  "us5sl",
		  "us5tere",
		  "us1tr",
		  "u2su",
		  "usur4",
		  "uta4b",
		  "u3tat",
		  "4ute.",
		  "4utel",
		  "4uten",
		  "uten4i",
		  "4u1t2i",
		  "uti5liz",
		  "u3tine",
		  "ut3ing",
		  "ution5a",
		  "u4tis",
		  "5u5tiz",
		  "u4t1l",
		  "ut5of",
		  "uto5g",
		  "uto5matic",
		  "u5ton",
		  "u4tou",
		  "uts4",
		  "u3u",
		  "uu4m",
		  "u1v2",
		  "uxu3",
		  "uz4e",
		  "1va",
		  "5va.",
		  "2v1a4b",
		  "vac5il",
		  "vac3u",
		  "vag4",
		  "va4ge",
		  "va5lie",
		  "val5o",
		  "val1u",
		  "va5mo",
		  "va5niz",
		  "va5pi",
		  "var5ied",
		  "3vat",
		  "4ve.",
		  "4ved",
		  "veg3",
		  "v3el.",
		  "vel3li",
		  "ve4lo",
		  "v4ely",
		  "ven3om",
		  "v5enue",
		  "v4erd",
		  "5vere.",
		  "v4erel",
		  "v3eren",
		  "ver5enc",
		  "v4eres",
		  "ver3ie",
		  "vermi4n",
		  "3verse",
		  "ver3th",
		  "v4e2s",
		  "4ves.",
		  "ves4te",
		  "ve4te",
		  "vet3er",
		  "ve4ty",
		  "vi5ali",
		  "5vian",
		  "5vide.",
		  "5vided",
		  "4v3iden",
		  "5vides",
		  "5vidi",
		  "v3if",
		  "vi5gn",
		  "vik4",
		  "2vil",
		  "5vilit",
		  "v3i3liz",
		  "v1in",
		  "4vi4na",
		  "v2inc",
		  "vin5d",
		  "4ving",
		  "vio3l",
		  "v3io4r",
		  "vi1ou",
		  "vi4p",
		  "vi5ro",
		  "vis3it",
		  "vi3so",
		  "vi3su",
		  "4viti",
		  "vit3r",
		  "4vity",
		  "3viv",
		  "5vo.",
		  "voi4",
		  "3vok",
		  "vo4la",
		  "v5ole",
		  "5volt",
		  "3volv",
		  "vom5i",
		  "vor5ab",
		  "vori4",
		  "vo4ry",
		  "vo4ta",
		  "4votee",
		  "4vv4",
		  "v4y",
		  "w5abl",
		  "2wac",
		  "wa5ger",
		  "wag5o",
		  "wait5",
		  "w5al.",
		  "wam4",
		  "war4t",
		  "was4t",
		  "wa1te",
		  "wa5ver",
		  "w1b",
		  "wea5rie",
		  "weath3",
		  "wed4n",
		  "weet3",
		  "wee5v",
		  "wel4l",
		  "w1er",
		  "west3",
		  "w3ev",
		  "whi4",
		  "wi2",
		  "wil2",
		  "will5in",
		  "win4de",
		  "win4g",
		  "wir4",
		  "3wise",
		  "with3",
		  "wiz5",
		  "w4k",
		  "wl4es",
		  "wl3in",
		  "w4no",
		  "1wo2",
		  "wom1",
		  "wo5ven",
		  "w5p",
		  "wra4",
		  "wri4",
		  "writa4",
		  "w3sh",
		  "ws4l",
		  "ws4pe",
		  "w5s4t",
		  "4wt",
		  "wy4",
		  "x1a",
		  "xac5e",
		  "x4ago",
		  "xam3",
		  "x4ap",
		  "xas5",
		  "x3c2",
		  "x1e",
		  "xe4cuto",
		  "x2ed",
		  "xer4i",
		  "xe5ro",
		  "x1h",
		  "xhi2",
		  "xhil5",
		  "xhu4",
		  "x3i",
		  "xi5a",
		  "xi5c",
		  "xi5di",
		  "x4ime",
		  "xi5miz",
		  "x3o",
		  "x4ob",
		  "x3p",
		  "xpan4d",
		  "xpecto5",
		  "xpe3d",
		  "x1t2",
		  "x3ti",
		  "x1u",
		  "xu3a",
		  "xx4",
		  "y5ac",
		  "3yar4",
		  "y5at",
		  "y1b",
		  "y1c",
		  "y2ce",
		  "yc5er",
		  "y3ch",
		  "ych4e",
		  "ycom4",
		  "ycot4",
		  "y1d",
		  "y5ee",
		  "y1er",
		  "y4erf",
		  "yes4",
		  "ye4t",
		  "y5gi",
		  "4y3h",
		  "y1i",
		  "y3la",
		  "ylla5bl",
		  "y3lo",
		  "y5lu",
		  "ymbol5",
		  "yme4",
		  "ympa3",
		  "yn3chr",
		  "yn5d",
		  "yn5g",
		  "yn5ic",
		  "5ynx",
		  "y1o4",
		  "yo5d",
		  "y4o5g",
		  "yom4",
		  "yo5net",
		  "y4ons",
		  "y4os",
		  "y4ped",
		  "yper5",
		  "yp3i",
		  "y3po",
		  "y4poc",
		  "yp2ta",
		  "y5pu",
		  "yra5m",
		  "yr5ia",
		  "y3ro",
		  "yr4r",
		  "ys4c",
		  "y3s2e",
		  "ys3ica",
		  "ys3io",
		  "3ysis",
		  "y4so",
		  "yss4",
		  "ys1t",
		  "ys3ta",
		  "ysur4",
		  "y3thin",
		  "yt3ic",
		  "y1w",
		  "za1",
		  "z5a2b",
		  "zar2",
		  "4zb",
		  "2ze",
		  "ze4n",
		  "ze4p",
		  "z1er",
		  "ze3ro",
		  "zet4",
		  "2z1i",
		  "z4il",
		  "z4is",
		  "5zl",
		  "4zm",
		  "1zo",
		  "zo4m",
		  "zo5ol",
		  "zte4",
		  "4z1z2",
		  "z4zy"
  };

	
	TreeSet<String> pattern2 = new TreeSet<String>();
	
	public void list(){
		
		pattern2.add(".ach");
		pattern2.add(".adder");
		pattern2.add(".aft");
		pattern2.add(".alt");
		pattern2.add(".amat");
		pattern2.add(".anc");
		pattern2.add(".ang");
		pattern2.add(".anim");
		pattern2.add(".ant");
		pattern2.add(".ante");
		pattern2.add(".antis");
		pattern2.add(".ars");
		pattern2.add(".artie");
		pattern2.add(".arty");
		pattern2.add(".asc");
		pattern2.add(".asp");
		pattern2.add(".ass");
		pattern2.add(".aster");
		pattern2.add(".atom");
		pattern2.add(".aud");
		pattern2.add(".avi");
		pattern2.add(".awn");
		pattern2.add(".bag");
		pattern2.add(".bana");
		pattern2.add(".base");
		pattern2.add(".ber");
		pattern2.add(".bera");
		pattern2.add(".besm");
		pattern2.add(".besto");
		pattern2.add(".bri");
		pattern2.add(".butti");
		pattern2.add(".campe");
		pattern2.add(".canc");
		pattern2.add(".capab");
		pattern2.add(".carol");
		pattern2.add(".cat");
		pattern2.add(".cela");
		pattern2.add(".ch");
		pattern2.add(".chilli");
		pattern2.add(".ci");
		pattern2.add(".citr");
		pattern2.add(".coe");
		pattern2.add(".cor");
		pattern2.add(".corner");
		pattern2.add(".demoi");
		pattern2.add(".deo");
		pattern2.add(".dera");
		pattern2.add(".deri");
		pattern2.add(".desc");
		pattern2.add(".dictio");
		pattern2.add(".dot");
		pattern2.add(".duc");
		pattern2.add(".dumb");
		pattern2.add(".earth");
		pattern2.add(".easi");
		pattern2.add(".eb");
		pattern2.add(".eer");
		pattern2.add(".eg");
		pattern2.add(".eld");
		pattern2.add(".elem");
		pattern2.add(".enam");
		pattern2.add(".eng");
		pattern2.add(".ens");
		pattern2.add(".equit");
		pattern2.add(".erri");
		pattern2.add(".es");
		pattern2.add(".eu");
		pattern2.add(".eye");
		pattern2.add(".fes");
		pattern2.add(".former");
		pattern2.add(".ga");
		pattern2.add(".ge");
		pattern2.add(".gent");
		pattern2.add(".geog");
		pattern2.add(".gia");
		pattern2.add(".gib");
		pattern2.add(".gor");
		pattern2.add(".handi");
		pattern2.add(".hank");
		pattern2.add(".he");
		pattern2.add(".heroi");
		pattern2.add(".hes");
		pattern2.add(".het");
		pattern2.add(".hib");
		pattern2.add(".hier");
		pattern2.add(".honey");
		pattern2.add(".hono");
		pattern2.add(".hov");
		pattern2.add(".idl");
		pattern2.add(".idol");
		pattern2.add(".imm");
		pattern2.add(".impin");
		pattern2.add(".in");
		pattern2.add(".inci");
		pattern2.add(".ine");
		pattern2.add(".ink");
		pattern2.add(".ins");
		pattern2.add(".irr");
		pattern2.add(".isi");
		pattern2.add(".jur");
		pattern2.add(".lacy");
		pattern2.add(".lam");
		pattern2.add(".later");
		pattern2.add(".lath");
		pattern2.add(".le");
		pattern2.add(".lege");
		pattern2.add(".len");
		pattern2.add(".lep");
		pattern2.add(".lev");
		pattern2.add(".lig");
		pattern2.add(".liga");
		pattern2.add(".lin");
		pattern2.add(".lio");
		pattern2.add(".lit");
		pattern2.add(".maga");
		pattern2.add(".malo");
		pattern2.add(".mana");
		pattern2.add(".marti");
		pattern2.add(".me");
		pattern2.add(".merc");
		pattern2.add(".meter");
		pattern2.add(".mis");
		pattern2.add(".misti");
		pattern2.add(".mone");
		pattern2.add(".moro");
		pattern2.add(".muta");
		pattern2.add(".mutab");
		pattern2.add(".nic");
		pattern2.add(".od");
		pattern2.add(".odd");
		pattern2.add(".ofte");
		pattern2.add(".orato");
		pattern2.add(".orc");
		pattern2.add(".ord");
		pattern2.add(".ort");
		pattern2.add(".os");
		pattern2.add(".ostl");
		pattern2.add(".oth");
		pattern2.add(".out");
		pattern2.add(".pedal");
		pattern2.add(".pete");
		pattern2.add(".petit");
		pattern2.add(".pie");
		pattern2.add(".pion");
		pattern2.add(".pit");
		pattern2.add(".prem");
		pattern2.add(".rac");
		pattern2.add(".rant");
		pattern2.add(".rationa");
		pattern2.add(".ree");
		pattern2.add(".remit");
		pattern2.add(".res");
		pattern2.add(".restat");
		pattern2.add(".rig");
		pattern2.add(".ritu");
		pattern2.add(".roq");
		pattern2.add(".rost");
		pattern2.add(".rowd");
		pattern2.add(".rud");
		pattern2.add(".scie");
		pattern2.add(".self");
		pattern2.add(".sell");
		pattern2.add(".sen");
		pattern2.add(".serie");
		pattern2.add(".sh");
		pattern2.add(".si");
		pattern2.add(".sing");
		pattern2.add(".st");
		pattern2.add(".stabl");
		pattern2.add(".sy");
		pattern2.add(".ta");
		pattern2.add(".te");
		pattern2.add(".tenan");
		pattern2.add(".th");
		pattern2.add(".ti");
		pattern2.add(".til");
		pattern2.add(".timo");
		pattern2.add(".ting");
		pattern2.add(".tink");
		pattern2.add(".tona");
		pattern2.add(".top");
		pattern2.add(".topi");
		pattern2.add(".tous");
		pattern2.add(".tribut");
		pattern2.add(".una");
		pattern2.add(".unce");
		pattern2.add(".under");
		pattern2.add(".une");
		pattern2.add(".unk");
		pattern2.add(".uno");
		pattern2.add(".unu");
		pattern2.add(".up");
		pattern2.add(".ure");
		pattern2.add(".usa");
		pattern2.add(".vende");
		pattern2.add(".vera");
		pattern2.add(".wili");
		pattern2.add(".ye");
		pattern2.add("ab.");
		pattern2.add("abal");
		pattern2.add("aban");
		pattern2.add("abe");
		pattern2.add("aberd");
		pattern2.add("abia");
		pattern2.add("abitab");
		pattern2.add("ablat");
		pattern2.add("aboliz");
		pattern2.add("abr");
		pattern2.add("abrog");
		pattern2.add("abul");
		pattern2.add("acar");
		pattern2.add("acard");
		pattern2.add("acaro");
		pattern2.add("aceou");
		pattern2.add("acer");
		pattern2.add("achet");
		pattern2.add("aci");
		pattern2.add("acie");
		pattern2.add("acin");
		pattern2.add("acio");
		pattern2.add("acrob");
		pattern2.add("actif");
		pattern2.add("acul");
		pattern2.add("acum");
		pattern2.add("ad");
		pattern2.add("addin");
		pattern2.add("ader.");
		pattern2.add("adi");
		pattern2.add("adia");
		pattern2.add("adica");
		pattern2.add("adier");
		pattern2.add("adio");
		pattern2.add("adit");
		pattern2.add("adiu");
		pattern2.add("adle");
		pattern2.add("adow");
		pattern2.add("adran");
		pattern2.add("adsu");
		pattern2.add("adu");
		pattern2.add("aduc");
		pattern2.add("adum");
		pattern2.add("aer");
		pattern2.add("aerie");
		pattern2.add("af");
		pattern2.add("aff");
		pattern2.add("agab");
		pattern2.add("agan");
		pattern2.add("agell");
		pattern2.add("ageo");
		pattern2.add("ageu");
		pattern2.add("agi");
		pattern2.add("agl");
		pattern2.add("agn");
		pattern2.add("ago");
		pattern2.add("agog");
		pattern2.add("agoni");
		pattern2.add("aguer");
		pattern2.add("agul");
		pattern2.add("agy");
		pattern2.add("aha");
		pattern2.add("ahe");
		pattern2.add("ahl");
		pattern2.add("aho");
		pattern2.add("ai");
		pattern2.add("aia");
		pattern2.add("aic.");
		pattern2.add("aily");
		pattern2.add("ain");
		pattern2.add("ainin");
		pattern2.add("aino");
		pattern2.add("aiten");
		pattern2.add("aj");
		pattern2.add("aken");
		pattern2.add("alab");
		pattern2.add("alad");
		pattern2.add("alar");
		pattern2.add("aldi");
		pattern2.add("ale");
		pattern2.add("alend");
		pattern2.add("alenti");
		pattern2.add("aleo");
		pattern2.add("ali");
		pattern2.add("alia.");
		pattern2.add("alie");
		pattern2.add("allev");
		pattern2.add("allic");
		pattern2.add("alm");
		pattern2.add("alog.");
		pattern2.add("aly.");
		pattern2.add("alys");
		pattern2.add("alyst");
		pattern2.add("alyt");
		pattern2.add("alyz");
		pattern2.add("ama");
		pattern2.add("amab");
		pattern2.add("amag");
		pattern2.add("amara");
		pattern2.add("amasc");
		pattern2.add("amatis");
		pattern2.add("amato");
		pattern2.add("amera");
		pattern2.add("amic");
		pattern2.add("amif");
		pattern2.add("amily");
		pattern2.add("amin");
		pattern2.add("amino");
		pattern2.add("amo");
		pattern2.add("amon");
		pattern2.add("amori");
		pattern2.add("ampen");
		pattern2.add("an");
		pattern2.add("anage");
		pattern2.add("analy");
		pattern2.add("anar");
		pattern2.add("anarc");
		pattern2.add("anari");
		pattern2.add("anati");
		pattern2.add("and");
		pattern2.add("andes");
		pattern2.add("andis");
		pattern2.add("andl");
		pattern2.add("andow");
		pattern2.add("anee");
		pattern2.add("anen");
		pattern2.add("anest.");
		pattern2.add("aneu");
		pattern2.add("ang");
		pattern2.add("angie");
		pattern2.add("angl");
		pattern2.add("anic");
		pattern2.add("anies");
		pattern2.add("anif");
		pattern2.add("anime");
		pattern2.add("animi");
		pattern2.add("anine");
		pattern2.add("anio");
		pattern2.add("anip");
		pattern2.add("anish");
		pattern2.add("anit");
		pattern2.add("aniu");
		pattern2.add("ankli");
		pattern2.add("anniz");
		pattern2.add("ano");
		pattern2.add("anot");
		pattern2.add("anoth");
		pattern2.add("ansa");
		pattern2.add("ansco");
		pattern2.add("ansn");
		pattern2.add("ansp");
		pattern2.add("anspo");
		pattern2.add("anst");
		pattern2.add("ansur");
		pattern2.add("antal");
		pattern2.add("antie");
		pattern2.add("anto");
		pattern2.add("antr");
		pattern2.add("antw");
		pattern2.add("anua");
		pattern2.add("anul");
		pattern2.add("anur");
		pattern2.add("ao");
		pattern2.add("apar");
		pattern2.add("apat");
		pattern2.add("apero");
		pattern2.add("apher");
		pattern2.add("aphi");
		pattern2.add("apilla");
		pattern2.add("apillar");
		pattern2.add("apin");
		pattern2.add("apita");
		pattern2.add("apitu");
		pattern2.add("apl");
		pattern2.add("apoc");
		pattern2.add("apola");
		pattern2.add("apori");
		pattern2.add("apost");
		pattern2.add("apses");
		pattern2.add("apu");
		pattern2.add("aque");
		pattern2.add("ar");
		pattern2.add("aract");
		pattern2.add("arade");
		pattern2.add("aradis");
		pattern2.add("aral");
		pattern2.add("aramete");
		pattern2.add("arang");
		pattern2.add("arap");
		pattern2.add("arat");
		pattern2.add("aratio");
		pattern2.add("arativ");
		pattern2.add("arau");
		pattern2.add("arav");
		pattern2.add("araw");
		pattern2.add("arbal");
		pattern2.add("archan");
		pattern2.add("ardine");
		pattern2.add("ardr");
		pattern2.add("areas");
		pattern2.add("aree");
		pattern2.add("arent");
		pattern2.add("aress");
		pattern2.add("arfi");
		pattern2.add("arfl");
		pattern2.add("ari");
		pattern2.add("arial");
		pattern2.add("arian");
		pattern2.add("ariet");
		pattern2.add("arim");
		pattern2.add("arinat");
		pattern2.add("ario");
		pattern2.add("ariz");
		pattern2.add("armi");
		pattern2.add("arod");
		pattern2.add("aroni");
		pattern2.add("aroo");
		pattern2.add("arp");
		pattern2.add("arq");
		pattern2.add("arre");
		pattern2.add("arsa");
		pattern2.add("arsh");
		pattern2.add("as.");
		pattern2.add("asab");
		pattern2.add("asant");
		pattern2.add("ashi");
		pattern2.add("asia.");
		pattern2.add("asib");
		pattern2.add("asic");
		pattern2.add("asit");
		pattern2.add("aski");
		pattern2.add("asl");
		pattern2.add("asoc");
		pattern2.add("asph");
		pattern2.add("assh");
		pattern2.add("asten");
		pattern2.add("astr");
		pattern2.add("asura");
		pattern2.add("ata");
		pattern2.add("atabl");
		pattern2.add("atac");
		pattern2.add("atalo");
		pattern2.add("atap");
		pattern2.add("atec");
		pattern2.add("atech");
		pattern2.add("atego");
		pattern2.add("aten.");
		pattern2.add("atera");
		pattern2.add("atern");
		pattern2.add("aterna");
		pattern2.add("atest");
		pattern2.add("atev");
		pattern2.add("ath");
		pattern2.add("athem");
		pattern2.add("athen");
		pattern2.add("atho");
		pattern2.add("athom");
		pattern2.add("ati.");
		pattern2.add("atia");
		pattern2.add("atib");
		pattern2.add("atic");
		pattern2.add("atif");
		pattern2.add("ationar");
		pattern2.add("atitu");
		pattern2.add("atog");
		pattern2.add("atom");
		pattern2.add("atomiz");
		pattern2.add("atop");
		pattern2.add("atos");
		pattern2.add("atr");
		pattern2.add("atrop");
		pattern2.add("atsk");
		pattern2.add("attag");
		pattern2.add("atte");
		pattern2.add("atth");
		pattern2.add("atu");
		pattern2.add("atua");
		pattern2.add("atue");
		pattern2.add("atul");
		pattern2.add("atura");
		pattern2.add("aty");
		pattern2.add("aub");
		pattern2.add("augh");
		pattern2.add("augu");
		pattern2.add("aul");
		pattern2.add("aund");
		pattern2.add("aur");
		pattern2.add("ausib");
		pattern2.add("auten");
		pattern2.add("auth");
		pattern2.add("ava");
		pattern2.add("avag");
		pattern2.add("avan");
		pattern2.add("aveno");
		pattern2.add("avera");
		pattern2.add("avern");
		pattern2.add("avery");
		pattern2.add("avi");
		pattern2.add("avier");
		pattern2.add("avig");
		pattern2.add("avoc");
		pattern2.add("avor");
		pattern2.add("away");
		pattern2.add("awi");
		pattern2.add("awly");
		pattern2.add("aws");
		pattern2.add("axic");
		pattern2.add("axid");
		pattern2.add("ayal");
		pattern2.add("aye");
		pattern2.add("ays");
		pattern2.add("azier");
		pattern2.add("azzi");
		pattern2.add("ba.");
		pattern2.add("badger");
		pattern2.add("bage");
		pattern2.add("bala");
		pattern2.add("bandag");
		pattern2.add("bane");
		pattern2.add("bani");
		pattern2.add("barbi");
		pattern2.add("baria");
		pattern2.add("bassi");
		pattern2.add("bat");
		pattern2.add("baz");
		pattern2.add("bb");
		pattern2.add("bbe");
		pattern2.add("bber");
		pattern2.add("bbina");
		pattern2.add("bd");
		pattern2.add("be.");
		pattern2.add("beak");
		pattern2.add("beat");
		pattern2.add("bed");
		pattern2.add("beda");
		pattern2.add("bede");
		pattern2.add("bedi");
		pattern2.add("begi");
		pattern2.add("begu");
		pattern2.add("bel");
		pattern2.add("beli");
		pattern2.add("belo");
		pattern2.add("bem");
		pattern2.add("benig");
		pattern2.add("benu");
		pattern2.add("bes");
		pattern2.add("besp");
		pattern2.add("bestr");
		pattern2.add("bet");
		pattern2.add("betiz");
		pattern2.add("betr");
		pattern2.add("betw");
		pattern2.add("bew");
		pattern2.add("beyo");
		pattern2.add("bf");
		pattern2.add("bh");
		pattern2.add("bib");
		pattern2.add("bid");
		pattern2.add("bie");
		pattern2.add("bien");
		pattern2.add("bier");
		pattern2.add("bif");
		pattern2.add("bil");
		pattern2.add("biliz");
		pattern2.add("binar");
		pattern2.add("bind");
		pattern2.add("binet");
		pattern2.add("biogr");
		pattern2.add("biou");
		pattern2.add("bit");
		pattern2.add("bitio");
		pattern2.add("bitr");
		pattern2.add("bitua");
		pattern2.add("bitz");
		pattern2.add("bj");
		pattern2.add("bk");
		pattern2.add("bl");
		pattern2.add("blath");
		pattern2.add("ble.");
		pattern2.add("blen");
		pattern2.add("blesp");
		pattern2.add("blis");
		pattern2.add("blo");
		pattern2.add("blunt");
		pattern2.add("bm");
		pattern2.add("bn");
		pattern2.add("bneg");
		pattern2.add("bod");
		pattern2.add("bodi");
		pattern2.add("boe");
		pattern2.add("bolic");
		pattern2.add("bombi");
		pattern2.add("bona");
		pattern2.add("bonat");
		pattern2.add("boo");
		pattern2.add("bor.");
		pattern2.add("bora");
		pattern2.add("bord");
		pattern2.add("bore");
		pattern2.add("bori");
		pattern2.add("bos");
		pattern2.add("bota");
		pattern2.add("both");
		pattern2.add("boto");
		pattern2.add("bound");
		pattern2.add("bp");
		pattern2.add("brit");
		pattern2.add("broth");
		pattern2.add("bs");
		pattern2.add("bsor");
		pattern2.add("bt");
		pattern2.add("btl");
		pattern2.add("bto");
		pattern2.add("btr");
		pattern2.add("buffer");
		pattern2.add("buga");
		pattern2.add("buli");
		pattern2.add("bumi");
		pattern2.add("bun");
		pattern2.add("bunti");
		pattern2.add("bure");
		pattern2.add("busie");
		pattern2.add("busse");
		pattern2.add("bust");
		pattern2.add("buta");
		pattern2.add("butio");
		pattern2.add("buto");
		pattern2.add("bv");
		pattern2.add("bw");
		pattern2.add("by.");
		pattern2.add("bys");
		pattern2.add("ca");
		pattern2.add("cabin");
		pattern2.add("cabl");
		pattern2.add("cach");
		pattern2.add("caden");
		pattern2.add("cag");
		pattern2.add("cah");
		pattern2.add("calat");
		pattern2.add("calla");
		pattern2.add("callin");
		pattern2.add("calo");
		pattern2.add("cand");
		pattern2.add("cane");
		pattern2.add("canic");
		pattern2.add("canis");
		pattern2.add("caniz");
		pattern2.add("canty");
		pattern2.add("cany");
		pattern2.add("caper");
		pattern2.add("carom");
		pattern2.add("caster");
		pattern2.add("castig");
		pattern2.add("casy");
		pattern2.add("cath");
		pattern2.add("cativ");
		pattern2.add("caval");
		pattern2.add("cc");
		pattern2.add("ccha");
		pattern2.add("ccia");
		pattern2.add("ccompa");
		pattern2.add("ccon");
		pattern2.add("ccout");
		pattern2.add("ce.");
		pattern2.add("ced.");
		pattern2.add("ceden");
		pattern2.add("cei");
		pattern2.add("cel.");
		pattern2.add("cell");
		pattern2.add("cen");
		pattern2.add("cenc");
		pattern2.add("cene");
		pattern2.add("ceni");
		pattern2.add("cent");
		pattern2.add("cep");
		pattern2.add("ceram");
		pattern2.add("cesa");
		pattern2.add("cessi");
		pattern2.add("cessib");
		pattern2.add("cest");
		pattern2.add("cet");
		pattern2.add("ceta");
		pattern2.add("cew");
		pattern2.add("ch");
		pattern2.add("ch.");
		pattern2.add("chab");
		pattern2.add("chanic");
		pattern2.add("chanis");
		pattern2.add("che");
		pattern2.add("cheap");
		pattern2.add("ched");
		pattern2.add("chelo");
		pattern2.add("chemi");
		pattern2.add("chene");
		pattern2.add("cher.");
		pattern2.add("chers");
		pattern2.add("chin");
		pattern2.add("chine.");
		pattern2.add("chiness");
		pattern2.add("chini");
		pattern2.add("chio");
		pattern2.add("chit");
		pattern2.add("chiz");
		pattern2.add("cho");
		pattern2.add("chti");
		pattern2.add("ci");
		pattern2.add("cia");
		pattern2.add("ciab");
		pattern2.add("ciar");
		pattern2.add("cic");
		pattern2.add("cier");
		pattern2.add("cific.");
		pattern2.add("cii");
		pattern2.add("cila");
		pattern2.add("cili");
		pattern2.add("cim");
		pattern2.add("cin");
		pattern2.add("cina");
		pattern2.add("cinat");
		pattern2.add("cinem");
		pattern2.add("cing");
		pattern2.add("cing.");
		pattern2.add("cino");
		pattern2.add("cion");
		pattern2.add("cipe");
		pattern2.add("ciph");
		pattern2.add("cipic");
		pattern2.add("cista");
		pattern2.add("cisti");
		pattern2.add("cit");
		pattern2.add("citiz");
		pattern2.add("ciz");
		pattern2.add("ck");
		pattern2.add("cki");
		pattern2.add("cl");
		pattern2.add("clar");
		pattern2.add("claratio");
		pattern2.add("clare");
		pattern2.add("clem");
		pattern2.add("clic");
		pattern2.add("clim");
		pattern2.add("cly");
		pattern2.add("cn");
		pattern2.add("co");
		pattern2.add("coag");
		pattern2.add("coe");
		pattern2.add("cog");
		pattern2.add("cogr");
		pattern2.add("coi");
		pattern2.add("coinc");
		pattern2.add("coli");
		pattern2.add("colo");
		pattern2.add("color");
		pattern2.add("comer");
		pattern2.add("cona");
		pattern2.add("cone");
		pattern2.add("cong");
		pattern2.add("cont");
		pattern2.add("copa");
		pattern2.add("copic");
		pattern2.add("copl");
		pattern2.add("corb");
		pattern2.add("coron");
		pattern2.add("cose");
		pattern2.add("cov");
		pattern2.add("cove");
		pattern2.add("cowa");
		pattern2.add("coze");
		pattern2.add("cozi");
		pattern2.add("cq");
		pattern2.add("crast");
		pattern2.add("crat.");
		pattern2.add("cratic");
		pattern2.add("creat");
		pattern2.add("cred");
		pattern2.add("creta");
		pattern2.add("crev");
		pattern2.add("cri");
		pattern2.add("crif");
		pattern2.add("crin");
		pattern2.add("cris");
		pattern2.add("criti");
		pattern2.add("cropl");
		pattern2.add("cropo");
		pattern2.add("crose");
		pattern2.add("crud");
		pattern2.add("cs");
		pattern2.add("ct");
		pattern2.add("ctab");
		pattern2.add("ctang");
		pattern2.add("ctant");
		pattern2.add("cte");
		pattern2.add("cter");
		pattern2.add("cticu");
		pattern2.add("ctimi");
		pattern2.add("ctur");
		pattern2.add("ctw");
		pattern2.add("cud");
		pattern2.add("cuf");
		pattern2.add("cui");
		pattern2.add("cuity");
		pattern2.add("culi");
		pattern2.add("cultis");
		pattern2.add("cultu");
		pattern2.add("cuma");
		pattern2.add("cume");
		pattern2.add("cumi");
		pattern2.add("cun");
		pattern2.add("cupi");
		pattern2.add("cupy");
		pattern2.add("curab");
		pattern2.add("curia");
		pattern2.add("cus");
		pattern2.add("cussi");
		pattern2.add("cut");
		pattern2.add("cutie");
		pattern2.add("cutiv");
		pattern2.add("cutr");
		pattern2.add("cy");
		pattern2.add("cze");
		pattern2.add("da");
		pattern2.add("da.");
		pattern2.add("dab");
		pattern2.add("dach");
		pattern2.add("daf");
		pattern2.add("dag");
		pattern2.add("dam");
		pattern2.add("dang");
		pattern2.add("dard");
		pattern2.add("dark");
		pattern2.add("dary");
		pattern2.add("dat");
		pattern2.add("dativ");
		pattern2.add("dato");
		pattern2.add("dav");
		pattern2.add("dave");
		pattern2.add("day");
		pattern2.add("db");
		pattern2.add("dc");
		pattern2.add("dd");
		pattern2.add("de.");
		pattern2.add("deaf");
		pattern2.add("debit");
		pattern2.add("debon");
		pattern2.add("decan");
		pattern2.add("decil");
		pattern2.add("decom");
		pattern2.add("ded");
		pattern2.add("dee.");
		pattern2.add("deif");
		pattern2.add("delie");
		pattern2.add("deliq");
		pattern2.add("delo");
		pattern2.add("dem");
		pattern2.add("dem.");
		pattern2.add("demic");
		pattern2.add("demic.");
		pattern2.add("demil");
		pattern2.add("demons");
		pattern2.add("demor");
		pattern2.add("den");
		pattern2.add("denar");
		pattern2.add("deno");
		pattern2.add("dentif");
		pattern2.add("denu");
		pattern2.add("dep");
		pattern2.add("depa");
		pattern2.add("depi");
		pattern2.add("depu");
		pattern2.add("deq");
		pattern2.add("derh");
		pattern2.add("derm");
		pattern2.add("derniz");
		pattern2.add("ders");
		pattern2.add("des");
		pattern2.add("des.");
		pattern2.add("desc");
		pattern2.add("deso");
		pattern2.add("desti");
		pattern2.add("destr");
		pattern2.add("desu");
		pattern2.add("det");
		pattern2.add("deto");
		pattern2.add("dev");
		pattern2.add("devil");
		pattern2.add("dey");
		pattern2.add("df");
		pattern2.add("dga");
		pattern2.add("dget");
		pattern2.add("dgi");
		pattern2.add("dgy");
		pattern2.add("dh");
		pattern2.add("di.");
		pattern2.add("dia");
		pattern2.add("diab");
		pattern2.add("dicam");
		pattern2.add("dice");
		pattern2.add("dict");
		pattern2.add("did");
		pattern2.add("dien");
		pattern2.add("dif");
		pattern2.add("dige");
		pattern2.add("dilato");
		pattern2.add("din");
		pattern2.add("dina");
		pattern2.add("dine.");
		pattern2.add("dini");
		pattern2.add("diniz");
		pattern2.add("dio");
		pattern2.add("diog");
		pattern2.add("dipl");
		pattern2.add("dir");
		pattern2.add("dire");
		pattern2.add("dirti");
		pattern2.add("dis");
		pattern2.add("disi");
		pattern2.add("dist");
		pattern2.add("diti");
		pattern2.add("div");
		pattern2.add("dj");
		pattern2.add("dk");
		pattern2.add("dla");
		pattern2.add("dle.");
		pattern2.add("dled");
		pattern2.add("dles.");
		pattern2.add("dless");
		pattern2.add("dlo");
		pattern2.add("dlu");
		pattern2.add("dly");
		pattern2.add("dm");
		pattern2.add("dn");
		pattern2.add("do");
		pattern2.add("do.");
		pattern2.add("dode");
		pattern2.add("doe");
		pattern2.add("dof");
		pattern2.add("dog");
		pattern2.add("dola");
		pattern2.add("doli");
		pattern2.add("dolor");
		pattern2.add("domiz");
		pattern2.add("donat");
		pattern2.add("doni");
		pattern2.add("dood");
		pattern2.add("dopp");
		pattern2.add("dor");
		pattern2.add("dos");
		pattern2.add("dout");
		pattern2.add("dov");
		pattern2.add("dox");
		pattern2.add("dp");
		pattern2.add("dr");
		pattern2.add("dragon");
		pattern2.add("drai");
		pattern2.add("dre");
		pattern2.add("drear");
		pattern2.add("dren");
		pattern2.add("drib");
		pattern2.add("dril");
		pattern2.add("drop");
		pattern2.add("drow");
		pattern2.add("drupli");
		pattern2.add("dry");
		pattern2.add("ds");
		pattern2.add("dsp");
		pattern2.add("dsw");
		pattern2.add("dsy");
		pattern2.add("dth");
		pattern2.add("du");
		pattern2.add("dua");
		pattern2.add("duc");
		pattern2.add("duca");
		pattern2.add("ducer");
		pattern2.add("duct.");
		pattern2.add("ducts");
		pattern2.add("duel");
		pattern2.add("dug");
		pattern2.add("dule");
		pattern2.add("dumbe");
		pattern2.add("dun");
		pattern2.add("dup");
		pattern2.add("dupe");
		pattern2.add("dv");
		pattern2.add("dw");
		pattern2.add("dy");
		pattern2.add("dyn");
		pattern2.add("dyse");
		pattern2.add("dysp");
		pattern2.add("eab");
		pattern2.add("eact");
		pattern2.add("ead");
		pattern2.add("eadie");
		pattern2.add("eage");
		pattern2.add("eager");
		pattern2.add("eal");
		pattern2.add("ealer");
		pattern2.add("ealou");
		pattern2.add("eamer");
		pattern2.add("eand");
		pattern2.add("eara");
		pattern2.add("earc");
		pattern2.add("eares");
		pattern2.add("earic");
		pattern2.add("earil");
		pattern2.add("eark");
		pattern2.add("eart");
		pattern2.add("earte");
		pattern2.add("easp");
		pattern2.add("eass");
		pattern2.add("east");
		pattern2.add("eat");
		pattern2.add("eaten");
		pattern2.add("eathi");
		pattern2.add("eatif");
		pattern2.add("eatu");
		pattern2.add("eav");
		pattern2.add("eaven");
		pattern2.add("eavi");
		pattern2.add("eavo");
		pattern2.add("eb");
		pattern2.add("ebel.");
		pattern2.add("ebels");
		pattern2.add("eben");
		pattern2.add("ebit");
		pattern2.add("ebr");
		pattern2.add("ecad");
		pattern2.add("ecanc");
		pattern2.add("ecca");
		pattern2.add("ece");
		pattern2.add("ecessa");
		pattern2.add("eci");
		pattern2.add("ecib");
		pattern2.add("ecificat");
		pattern2.add("ecifie");
		pattern2.add("ecify");
		pattern2.add("ecim");
		pattern2.add("ecit");
		pattern2.add("ecite");
		pattern2.add("eclam");
		pattern2.add("eclus");
		pattern2.add("ecol");
		pattern2.add("ecomm");
		pattern2.add("ecompe");
		pattern2.add("econc");
		pattern2.add("ecor");
		pattern2.add("ecora");
		pattern2.add("ecoro");
		pattern2.add("ecr");
		pattern2.add("ecrem");
		pattern2.add("ectan");
		pattern2.add("ecte");
		pattern2.add("ecu");
		pattern2.add("ecul");
		pattern2.add("ecula");
		pattern2.add("eda");
		pattern2.add("edd");
		pattern2.add("eder");
		pattern2.add("edes");
		pattern2.add("edi");
		pattern2.add("edia");
		pattern2.add("edib");
		pattern2.add("edica");
		pattern2.add("edim");
		pattern2.add("edit");
		pattern2.add("ediz");
		pattern2.add("edo");
		pattern2.add("edol");
		pattern2.add("edon");
		pattern2.add("edri");
		pattern2.add("edul");
		pattern2.add("edulo");
		pattern2.add("eec");
		pattern2.add("eedi");
		pattern2.add("eef");
		pattern2.add("eeli");
		pattern2.add("eely");
		pattern2.add("eem");
		pattern2.add("eena");
		pattern2.add("eep");
		pattern2.add("ees");
		pattern2.add("eest");
		pattern2.add("eety");
		pattern2.add("eex");
		pattern2.add("ef");
		pattern2.add("efere");
		pattern2.add("eff");
		pattern2.add("efic");
		pattern2.add("efici");
		pattern2.add("efil");
		pattern2.add("efine");
		pattern2.add("efinite");
		pattern2.add("efit");
		pattern2.add("efores");
		pattern2.add("efuse.");
		pattern2.add("egal");
		pattern2.add("eger");
		pattern2.add("egib");
		pattern2.add("egic");
		pattern2.add("eging");
		pattern2.add("egit");
		pattern2.add("egn");
		pattern2.add("ego.");
		pattern2.add("egos");
		pattern2.add("egul");
		pattern2.add("egur");
		pattern2.add("egy");
		pattern2.add("eh");
		pattern2.add("eher");
		pattern2.add("ei");
		pattern2.add("eic");
		pattern2.add("eid");
		pattern2.add("eig");
		pattern2.add("eigl");
		pattern2.add("eimb");
		pattern2.add("einf");
		pattern2.add("eing");
		pattern2.add("einst");
		pattern2.add("eird");
		pattern2.add("eite");
		pattern2.add("eith");
		pattern2.add("eity");
		pattern2.add("ej");
		pattern2.add("ejud");
		pattern2.add("ejudi");
		pattern2.add("ekin");
		pattern2.add("ekla");
		pattern2.add("ela");
		pattern2.add("ela.");
		pattern2.add("elac");
		pattern2.add("eland");
		pattern2.add("elativ");
		pattern2.add("elaw");
		pattern2.add("elaxa");
		pattern2.add("elea");
		pattern2.add("elebra");
		pattern2.add("elec");
		pattern2.add("eled");
		pattern2.add("elega");
		pattern2.add("elen");
		pattern2.add("eler");
		pattern2.add("eles");
		pattern2.add("elf");
		pattern2.add("eli");
		pattern2.add("elibe");
		pattern2.add("elic.");
		pattern2.add("elica");
		pattern2.add("elier");
		pattern2.add("eligib");
		pattern2.add("elim");
		pattern2.add("eling");
		pattern2.add("elio");
		pattern2.add("elis");
		pattern2.add("elish");
		pattern2.add("eliv");
		pattern2.add("ella");
		pattern2.add("ellab");
		pattern2.add("ello");
		pattern2.add("eloc");
		pattern2.add("elog");
		pattern2.add("elop.");
		pattern2.add("elsh");
		pattern2.add("elta");
		pattern2.add("elud");
		pattern2.add("elug");
		pattern2.add("emac");
		pattern2.add("emag");
		pattern2.add("eman");
		pattern2.add("emana");
		pattern2.add("emb");
		pattern2.add("eme");
		pattern2.add("emel");
		pattern2.add("emet");
		pattern2.add("emica");
		pattern2.add("emie");
		pattern2.add("emigra");
		pattern2.add("emin");
		pattern2.add("emine");
		pattern2.add("emini");
		pattern2.add("emis");
		pattern2.add("emish");
		pattern2.add("emiss");
		pattern2.add("emiz");
		pattern2.add("emniz");
		pattern2.add("emog");
		pattern2.add("emonio");
		pattern2.add("empi");
		pattern2.add("emul");
		pattern2.add("emula");
		pattern2.add("emun");
		pattern2.add("emy");
		pattern2.add("enamo");
		pattern2.add("enant");
		pattern2.add("encher");
		pattern2.add("endic");
		pattern2.add("enea");
		pattern2.add("enee");
		pattern2.add("enem");
		pattern2.add("enero");
		pattern2.add("enesi");
		pattern2.add("enest");
		pattern2.add("enetr");
		pattern2.add("enew");
		pattern2.add("enics");
		pattern2.add("enie");
		pattern2.add("enil");
		pattern2.add("enio");
		pattern2.add("enish");
		pattern2.add("enit");
		pattern2.add("eniu");
		pattern2.add("eniz");
		pattern2.add("enn");
		pattern2.add("eno");
		pattern2.add("enog");
		pattern2.add("enos");
		pattern2.add("enov");
		pattern2.add("ensw");
		pattern2.add("entage");
		pattern2.add("enthes");
		pattern2.add("enua");
		pattern2.add("enuf");
		pattern2.add("eny.");
		pattern2.add("enz");
		pattern2.add("eof");
		pattern2.add("eog");
		pattern2.add("eoi");
		pattern2.add("eol");
		pattern2.add("eopar");
		pattern2.add("eor");
		pattern2.add("eore");
		pattern2.add("eorol");
		pattern2.add("eos");
		pattern2.add("eot");
		pattern2.add("eoto");
		pattern2.add("eout");
		pattern2.add("eow");
		pattern2.add("epa");
		pattern2.add("epai");
		pattern2.add("epanc");
		pattern2.add("epel");
		pattern2.add("epent");
		pattern2.add("epetitio");
		pattern2.add("ephe");
		pattern2.add("epli");
		pattern2.add("epo");
		pattern2.add("eprec");
		pattern2.add("epreca");
		pattern2.add("epred");
		pattern2.add("epreh");
		pattern2.add("epro");
		pattern2.add("eprob");
		pattern2.add("epsh");
		pattern2.add("eptib");
		pattern2.add("eput");
		pattern2.add("eputa");
		pattern2.add("eq");
		pattern2.add("equil");
		pattern2.add("equis");
		pattern2.add("era");
		pattern2.add("erab");
		pattern2.add("erand");
		pattern2.add("erar");
		pattern2.add("erati.");
		pattern2.add("erb");
		pattern2.add("erbl");
		pattern2.add("erch");
		pattern2.add("erche");
		pattern2.add("ere.");
		pattern2.add("ereal");
		pattern2.add("ereco");
		pattern2.add("erein");
		pattern2.add("erel.");
		pattern2.add("eremo");
		pattern2.add("erena");
		pattern2.add("erence");
		pattern2.add("erene");
		pattern2.add("erent");
		pattern2.add("ereq");
		pattern2.add("eress");
		pattern2.add("erest");
		pattern2.add("eret");
		pattern2.add("erh");
		pattern2.add("eri");
		pattern2.add("eria");
		pattern2.add("erick");
		pattern2.add("erien");
		pattern2.add("erier");
		pattern2.add("erine");
		pattern2.add("erio");
		pattern2.add("erit");
		pattern2.add("eriu");
		pattern2.add("eriv");
		pattern2.add("eriva");
		pattern2.add("erm");
		pattern2.add("ernis");
		pattern2.add("ernit");
		pattern2.add("erniz");
		pattern2.add("erno");
		pattern2.add("ero");
		pattern2.add("erob");
		pattern2.add("eroc");
		pattern2.add("eror");
		pattern2.add("erou");
		pattern2.add("ers");
		pattern2.add("erset");
		pattern2.add("erter");
		pattern2.add("ertl");
		pattern2.add("ertw");
		pattern2.add("eru");
		pattern2.add("erut");
		pattern2.add("erwau");
		pattern2.add("esa");
		pattern2.add("esage.");
		pattern2.add("esages");
		pattern2.add("esc");
		pattern2.add("esca");
		pattern2.add("escan");
		pattern2.add("escr");
		pattern2.add("escu");
		pattern2.add("ese");
		pattern2.add("esec");
		pattern2.add("esecr");
		pattern2.add("esenc");
		pattern2.add("esert.");
		pattern2.add("eserts");
		pattern2.add("eserva");
		pattern2.add("esh");
		pattern2.add("esha");
		pattern2.add("eshen");
		pattern2.add("esi");
		pattern2.add("esic");
		pattern2.add("esid");
		pattern2.add("esiden");
		pattern2.add("esigna");
		pattern2.add("esim");
		pattern2.add("esin");
		pattern2.add("esiste");
		pattern2.add("esiu");
		pattern2.add("eskin");
		pattern2.add("esmi");
		pattern2.add("esol");
		pattern2.add("esolu");
		pattern2.add("eson");
		pattern2.add("esona");
		pattern2.add("esp");
		pattern2.add("esper");
		pattern2.add("espira");
		pattern2.add("espre");
		pattern2.add("ess");
		pattern2.add("essib");
		pattern2.add("estan");
		pattern2.add("estig");
		pattern2.add("estim");
		pattern2.add("esto");
		pattern2.add("eston");
		pattern2.add("estr");
		pattern2.add("estro");
		pattern2.add("estruc");
		pattern2.add("esur");
		pattern2.add("esurr");
		pattern2.add("esw");
		pattern2.add("etab");
		pattern2.add("etend");
		pattern2.add("eteo");
		pattern2.add("ethod");
		pattern2.add("etic");
		pattern2.add("etide");
		pattern2.add("etin");
		pattern2.add("etino");
		pattern2.add("etir");
		pattern2.add("etitio");
		pattern2.add("etitiv");
		pattern2.add("etn");
		pattern2.add("etona");
		pattern2.add("etra");
		pattern2.add("etre");
		pattern2.add("etric");
		pattern2.add("etrif");
		pattern2.add("etrog");
		pattern2.add("etros");
		pattern2.add("etua");
		pattern2.add("etym");
		pattern2.add("etz");
		pattern2.add("eu");
		pattern2.add("eun");
		pattern2.add("eup");
		pattern2.add("euro");
		pattern2.add("eus");
		pattern2.add("eute");
		pattern2.add("eutil");
		pattern2.add("eutr");
		pattern2.add("evap");
		pattern2.add("evas");
		pattern2.add("evast");
		pattern2.add("evea");
		pattern2.add("evell");
		pattern2.add("evelo");
		pattern2.add("eveng");
		pattern2.add("eveni");
		pattern2.add("ever");
		pattern2.add("everb");
		pattern2.add("evi");
		pattern2.add("evid");
		pattern2.add("evil");
		pattern2.add("evin");
		pattern2.add("eviv");
		pattern2.add("evoc");
		pattern2.add("evu");
		pattern2.add("ewa");
		pattern2.add("ewag");
		pattern2.add("ewee");
		pattern2.add("ewh");
		pattern2.add("ewil");
		pattern2.add("ewing");
		pattern2.add("ewit");
		pattern2.add("exp");
		pattern2.add("eyc");
		pattern2.add("eye.");
		pattern2.add("eys");
		pattern2.add("fa");
		pattern2.add("fabl");
		pattern2.add("fabr");
		pattern2.add("face");
		pattern2.add("fag");
		pattern2.add("fain");
		pattern2.add("falle");
		pattern2.add("fama");
		pattern2.add("famis");
		pattern2.add("far");
		pattern2.add("farth");
		pattern2.add("fata");
		pattern2.add("fathe");
		pattern2.add("fato");
		pattern2.add("fault");
		pattern2.add("fb");
		pattern2.add("fd");
		pattern2.add("fe.");
		pattern2.add("feas");
		pattern2.add("feath");
		pattern2.add("feb");
		pattern2.add("feca");
		pattern2.add("fect");
		pattern2.add("fed");
		pattern2.add("feli");
		pattern2.add("femo");
		pattern2.add("fend");
		pattern2.add("fende");
		pattern2.add("fer");
		pattern2.add("ferr");
		pattern2.add("fev");
		pattern2.add("ff");
		pattern2.add("ffes");
		pattern2.add("ffie");
		pattern2.add("ffin.");
		pattern2.add("ffis");
		pattern2.add("ffly");
		pattern2.add("ffy");
		pattern2.add("fh");
		pattern2.add("fi");
		pattern2.add("fia");
		pattern2.add("fic.");
		pattern2.add("fical");
		pattern2.add("fican");
		pattern2.add("ficate");
		pattern2.add("ficen");
		pattern2.add("ficer");
		pattern2.add("fici");
		pattern2.add("ficia");
		pattern2.add("ficie");
		pattern2.add("fics");
		pattern2.add("ficu");
		pattern2.add("fidel");
		pattern2.add("fight");
		pattern2.add("fili");
		pattern2.add("fillin");
		pattern2.add("fily");
		pattern2.add("fin");
		pattern2.add("fina");
		pattern2.add("find");
		pattern2.add("fine");
		pattern2.add("fing");
		pattern2.add("finn");
		pattern2.add("fisti");
		pattern2.add("fl");
		pattern2.add("fless");
		pattern2.add("flin");
		pattern2.add("flore");
		pattern2.add("fly");
		pattern2.add("fm");
		pattern2.add("fn");
		pattern2.add("fo");
		pattern2.add("fon");
		pattern2.add("fonde");
		pattern2.add("font");
		pattern2.add("for");
		pattern2.add("forat");
		pattern2.add("foray");
		pattern2.add("foret");
		pattern2.add("fori");
		pattern2.add("forta");
		pattern2.add("fos");
		pattern2.add("fp");
		pattern2.add("frat");
		pattern2.add("frea");
		pattern2.add("fresc");
		pattern2.add("fri");
		pattern2.add("fril");
		pattern2.add("frol");
		pattern2.add("fs");
		pattern2.add("ft");
		pattern2.add("fto");
		pattern2.add("fty");
		pattern2.add("fu");
		pattern2.add("fuel");
		pattern2.add("fug");
		pattern2.add("fumin");
		pattern2.add("fune");
		pattern2.add("furi");
		pattern2.add("fusi");
		pattern2.add("fuss");
		pattern2.add("futa");
		pattern2.add("fy");
		pattern2.add("ga");
		pattern2.add("gaf");
		pattern2.add("gal.");
		pattern2.add("gali");
		pattern2.add("galo");
		pattern2.add("gam");
		pattern2.add("gamet");
		pattern2.add("gamo");
		pattern2.add("ganis");
		pattern2.add("ganiz");
		pattern2.add("ganiza");
		pattern2.add("gano");
		pattern2.add("garn");
		pattern2.add("gass");
		pattern2.add("gath");
		pattern2.add("gativ");
		pattern2.add("gaz");
		pattern2.add("gb");
		pattern2.add("gd");
		pattern2.add("ge.");
		pattern2.add("ged");
		pattern2.add("geez");
		pattern2.add("gelin");
		pattern2.add("gelis");
		pattern2.add("geliz");
		pattern2.add("gely");
		pattern2.add("gen");
		pattern2.add("genat");
		pattern2.add("geniz");
		pattern2.add("geno");
		pattern2.add("geny");
		pattern2.add("geo");
		pattern2.add("geom");
		pattern2.add("gery");
		pattern2.add("gesi");
		pattern2.add("geth");
		pattern2.add("geto");
		pattern2.add("gety");
		pattern2.add("gev");
		pattern2.add("gg");
		pattern2.add("gge");
		pattern2.add("gger");
		pattern2.add("gglu");
		pattern2.add("ggo");
		pattern2.add("ghin");
		pattern2.add("ghout");
		pattern2.add("ghto");
		pattern2.add("gi.");
		pattern2.add("gia");
		pattern2.add("giar");
		pattern2.add("gic");
		pattern2.add("gicia");
		pattern2.add("gico");
		pattern2.add("gien");
		pattern2.add("gies.");
		pattern2.add("gil");
		pattern2.add("gimen");
		pattern2.add("gin.");
		pattern2.add("ginge");
		pattern2.add("gins");
		pattern2.add("gio");
		pattern2.add("gir");
		pattern2.add("girl");
		pattern2.add("gisl");
		pattern2.add("giu");
		pattern2.add("giv");
		pattern2.add("giz");
		pattern2.add("gl");
		pattern2.add("gla");
		pattern2.add("gladi");
		pattern2.add("glas");
		pattern2.add("gle");
		pattern2.add("glib");
		pattern2.add("glig");
		pattern2.add("glo");
		pattern2.add("glor");
		pattern2.add("gm");
		pattern2.add("gmy");
		pattern2.add("gna");
		pattern2.add("gna.");
		pattern2.add("gnett");
		pattern2.add("gni");
		pattern2.add("gnin");
		pattern2.add("gnio");
		pattern2.add("gno");
		pattern2.add("gnon");
		pattern2.add("go");
		pattern2.add("go.");
		pattern2.add("gob");
		pattern2.add("goe");
		pattern2.add("gog");
		pattern2.add("gois");
		pattern2.add("gon");
		pattern2.add("gona");
		pattern2.add("gondo");
		pattern2.add("goni");
		pattern2.add("goo");
		pattern2.add("goriz");
		pattern2.add("gorou");
		pattern2.add("gos.");
		pattern2.add("gov");
		pattern2.add("gp");
		pattern2.add("gr");
		pattern2.add("grada");
		pattern2.add("grai");
		pattern2.add("gran");
		pattern2.add("graph.");
		pattern2.add("grapher");
		pattern2.add("graphic");
		pattern2.add("graphy");
		pattern2.add("gray");
		pattern2.add("gren");
		pattern2.add("gress.");
		pattern2.add("grit");
		pattern2.add("gro");
		pattern2.add("gruf");
		pattern2.add("gs");
		pattern2.add("gste");
		pattern2.add("gth");
		pattern2.add("gua");
		pattern2.add("guard");
		pattern2.add("gue");
		pattern2.add("guit");
		pattern2.add("gun");
		pattern2.add("gus");
		pattern2.add("gut");
		pattern2.add("gw");
		pattern2.add("gy");
		pattern2.add("gyn");
		pattern2.add("gyra");
		pattern2.add("habl");
		pattern2.add("hach");
		pattern2.add("haem");
		pattern2.add("haet");
		pattern2.add("hagu");
		pattern2.add("hala");
		pattern2.add("halam");
		pattern2.add("ham");
		pattern2.add("hanci");
		pattern2.add("hancy");
		pattern2.add("hand.");
		pattern2.add("hang");
		pattern2.add("hanger");
		pattern2.add("hango");
		pattern2.add("haniz");
		pattern2.add("hank");
		pattern2.add("hante");
		pattern2.add("hapl");
		pattern2.add("hapt");
		pattern2.add("haran");
		pattern2.add("haras");
		pattern2.add("hard");
		pattern2.add("harde");
		pattern2.add("harle");
		pattern2.add("harpen");
		pattern2.add("harter");
		pattern2.add("hass");
		pattern2.add("haun");
		pattern2.add("haz");
		pattern2.add("haza");
		pattern2.add("hb");
		pattern2.add("head");
		pattern2.add("hear");
		pattern2.add("hecan");
		pattern2.add("hecat");
		pattern2.add("hed");
		pattern2.add("hedo");
		pattern2.add("heli");
		pattern2.add("hellis");
		pattern2.add("helly");
		pattern2.add("helo");
		pattern2.add("hemp");
		pattern2.add("hen");
		pattern2.add("hena");
		pattern2.add("henat");
		pattern2.add("heor");
		pattern2.add("hep");
		pattern2.add("hera");
		pattern2.add("herap");
		pattern2.add("herba");
		pattern2.add("herea");
		pattern2.add("hern");
		pattern2.add("herou");
		pattern2.add("hery");
		pattern2.add("hes");
		pattern2.add("hesp");
		pattern2.add("het");
		pattern2.add("heted");
		pattern2.add("heu");
		pattern2.add("hf");
		pattern2.add("hh");
		pattern2.add("hian");
		pattern2.add("hico");
		pattern2.add("high");
		pattern2.add("hil");
		pattern2.add("himer");
		pattern2.add("hina");
		pattern2.add("hione");
		pattern2.add("hip");
		pattern2.add("hirl");
		pattern2.add("hiro");
		pattern2.add("hirp");
		pattern2.add("hirr");
		pattern2.add("hisel");
		pattern2.add("hiss");
		pattern2.add("hither");
		pattern2.add("hiv");
		pattern2.add("hk");
		pattern2.add("hl");
		pattern2.add("hlan");
		pattern2.add("hlo");
		pattern2.add("hlori");
		pattern2.add("hm");
		pattern2.add("hmet");
		pattern2.add("hn");
		pattern2.add("hodiz");
		pattern2.add("hods");
		pattern2.add("hog");
		pattern2.add("hoge");
		pattern2.add("holar");
		pattern2.add("hole");
		pattern2.add("homa");
		pattern2.add("home");
		pattern2.add("hona");
		pattern2.add("hony");
		pattern2.add("hood");
		pattern2.add("hoon");
		pattern2.add("horat");
		pattern2.add("horis");
		pattern2.add("horte");
		pattern2.add("horu");
		pattern2.add("hose");
		pattern2.add("hosen");
		pattern2.add("hosp");
		pattern2.add("hous");
		pattern2.add("house");
		pattern2.add("hovel");
		pattern2.add("hp");
		pattern2.add("hr");
		pattern2.add("hree");
		pattern2.add("hroniz");
		pattern2.add("hropo");
		pattern2.add("hs");
		pattern2.add("hsh");
		pattern2.add("htar");
		pattern2.add("hten");
		pattern2.add("htes");
		pattern2.add("hty");
		pattern2.add("hug");
		pattern2.add("humin");
		pattern2.add("hunke");
		pattern2.add("hunt");
		pattern2.add("hust");
		pattern2.add("hut");
		pattern2.add("hw");
		pattern2.add("hwart");
		pattern2.add("hype");
		pattern2.add("hyph");
		pattern2.add("hys");
		pattern2.add("ia");
		pattern2.add("ial");
		pattern2.add("iam");
		pattern2.add("iamete");
		pattern2.add("ian");
		pattern2.add("ianc");
		pattern2.add("iani");
		pattern2.add("iant");
		pattern2.add("iape");
		pattern2.add("iass");
		pattern2.add("iativ");
		pattern2.add("iatric");
		pattern2.add("iatu");
		pattern2.add("ibe");
		pattern2.add("ibera");
		pattern2.add("ibert");
		pattern2.add("ibia");
		pattern2.add("ibin");
		pattern2.add("ibit.");
		pattern2.add("ibite");
		pattern2.add("ibl");
		pattern2.add("ibli");
		pattern2.add("ibo");
		pattern2.add("ibr");
		pattern2.add("ibri");
		pattern2.add("ibun");
		pattern2.add("icam");
		pattern2.add("icap");
		pattern2.add("icar");
		pattern2.add("icar.");
		pattern2.add("icara");
		pattern2.add("icas");
		pattern2.add("icay");
		pattern2.add("iccu");
		pattern2.add("iceo");
		pattern2.add("ich");
		pattern2.add("ici");
		pattern2.add("icid");
		pattern2.add("icina");
		pattern2.add("icip");
		pattern2.add("icipa");
		pattern2.add("icly");
		pattern2.add("icoc");
		pattern2.add("icr");
		pattern2.add("icra");
		pattern2.add("icry");
		pattern2.add("icte");
		pattern2.add("ictu");
		pattern2.add("ictua");
		pattern2.add("icula");
		pattern2.add("icum");
		pattern2.add("icuo");
		pattern2.add("icur");
		pattern2.add("id");
		pattern2.add("idai");
		pattern2.add("idanc");
		pattern2.add("idd");
		pattern2.add("ideal");
		pattern2.add("ides");
		pattern2.add("idi");
		pattern2.add("idian");
		pattern2.add("idiar");
		pattern2.add("idie");
		pattern2.add("idio");
		pattern2.add("idiou");
		pattern2.add("idit");
		pattern2.add("idiu");
		pattern2.add("idle");
		pattern2.add("idom");
		pattern2.add("idow");
		pattern2.add("idr");
		pattern2.add("idu");
		pattern2.add("iduo");
		pattern2.add("ie");
		pattern2.add("iede");
		pattern2.add("iega");
		pattern2.add("ield");
		pattern2.add("iena");
		pattern2.add("iene");
		pattern2.add("ienn");
		pattern2.add("ienti");
		pattern2.add("ier.");
		pattern2.add("iesc");
		pattern2.add("iest");
		pattern2.add("iet");
		pattern2.add("if.");
		pattern2.add("ifero");
		pattern2.add("iffen");
		pattern2.add("iffr");
		pattern2.add("ific.");
		pattern2.add("ifie");
		pattern2.add("ifl");
		pattern2.add("ift");
		pattern2.add("ig");
		pattern2.add("igab");
		pattern2.add("igera");
		pattern2.add("ighti");
		pattern2.add("igi");
		pattern2.add("igib");
		pattern2.add("igil");
		pattern2.add("igin");
		pattern2.add("igit");
		pattern2.add("igl");
		pattern2.add("igo");
		pattern2.add("igor");
		pattern2.add("igot");
		pattern2.add("igre");
		pattern2.add("igui");
		pattern2.add("igur");
		pattern2.add("ih");
		pattern2.add("ii");
		pattern2.add("ij");
		pattern2.add("ik");
		pattern2.add("ila");
		pattern2.add("ilab");
		pattern2.add("ilade");
		pattern2.add("ilam");
		pattern2.add("ilara");
		pattern2.add("ileg");
		pattern2.add("iler");
		pattern2.add("ilev");
		pattern2.add("ilf");
		pattern2.add("ili");
		pattern2.add("ilia");
		pattern2.add("ilib");
		pattern2.add("ilio");
		pattern2.add("ilist");
		pattern2.add("ilit");
		pattern2.add("iliz");
		pattern2.add("illab");
		pattern2.add("iln");
		pattern2.add("iloq");
		pattern2.add("ilty");
		pattern2.add("ilur");
		pattern2.add("ilv");
		pattern2.add("imag");
		pattern2.add("image");
		pattern2.add("imary");
		pattern2.add("imentar");
		pattern2.add("imet");
		pattern2.add("imi");
		pattern2.add("imida");
		pattern2.add("imile");
		pattern2.add("imini");
		pattern2.add("imit");
		pattern2.add("imni");
		pattern2.add("imon");
		pattern2.add("imu");
		pattern2.add("imula");
		pattern2.add("in.");
		pattern2.add("inau");
		pattern2.add("inav");
		pattern2.add("incel");
		pattern2.add("incer");
		pattern2.add("ind");
		pattern2.add("indling");
		pattern2.add("ine");
		pattern2.add("inee");
		pattern2.add("inerar");
		pattern2.add("iness");
		pattern2.add("inga");
		pattern2.add("inge");
		pattern2.add("ingen");
		pattern2.add("ingi");
		pattern2.add("ingling");
		pattern2.add("ingo");
		pattern2.add("ingu");
		pattern2.add("ini");
		pattern2.add("ini.");
		pattern2.add("inia");
		pattern2.add("inio");
		pattern2.add("inis");
		pattern2.add("inite.");
		pattern2.add("initio");
		pattern2.add("inity");
		pattern2.add("ink");
		pattern2.add("inl");
		pattern2.add("inn");
		pattern2.add("ino");
		pattern2.add("inoc");
		pattern2.add("inos");
		pattern2.add("inot");
		pattern2.add("ins");
		pattern2.add("inse");
		pattern2.add("insura");
		pattern2.add("int.");
		pattern2.add("inth");
		pattern2.add("inu");
		pattern2.add("inus");
		pattern2.add("iny");
		pattern2.add("io");
		pattern2.add("io.");
		pattern2.add("ioge");
		pattern2.add("iogr");
		pattern2.add("iol");
		pattern2.add("iom");
		pattern2.add("ionat");
		pattern2.add("ionery");
		pattern2.add("ioni");
		pattern2.add("ioph");
		pattern2.add("iori");
		pattern2.add("ios");
		pattern2.add("ioth");
		pattern2.add("ioti");
		pattern2.add("ioto");
		pattern2.add("iour");
		pattern2.add("ip");
		pattern2.add("ipe");
		pattern2.add("iphras");
		pattern2.add("ipi");
		pattern2.add("ipic");
		pattern2.add("ipre");
		pattern2.add("ipul");
		pattern2.add("iqua");
		pattern2.add("iquef");
		pattern2.add("iquid");
		pattern2.add("iquit");
		pattern2.add("ir");
		pattern2.add("ira");
		pattern2.add("irab");
		pattern2.add("irac");
		pattern2.add("irde");
		pattern2.add("irede");
		pattern2.add("iref");
		pattern2.add("irel");
		pattern2.add("ires");
		pattern2.add("irgi");
		pattern2.add("iri");
		pattern2.add("iride");
		pattern2.add("iris");
		pattern2.add("iritu");
		pattern2.add("iriz");
		pattern2.add("irmin");
		pattern2.add("irog");
		pattern2.add("iron.");
		pattern2.add("irul");
		pattern2.add("is.");
		pattern2.add("isag");
		pattern2.add("isar");
		pattern2.add("isas");
		pattern2.add("isc");
		pattern2.add("isch");
		pattern2.add("ise");
		pattern2.add("iser");
		pattern2.add("isf");
		pattern2.add("ishan");
		pattern2.add("ishon");
		pattern2.add("ishop");
		pattern2.add("isib");
		pattern2.add("isid");
		pattern2.add("isis");
		pattern2.add("isitiv");
		pattern2.add("isk");
		pattern2.add("islan");
		pattern2.add("isms");
		pattern2.add("iso");
		pattern2.add("isomer");
		pattern2.add("isp");
		pattern2.add("ispi");
		pattern2.add("ispy");
		pattern2.add("iss");
		pattern2.add("issal");
		pattern2.add("issen");
		pattern2.add("isses");
		pattern2.add("ista.");
		pattern2.add("iste");
		pattern2.add("isti");
		pattern2.add("istly");
		pattern2.add("istral");
		pattern2.add("isu");
		pattern2.add("isus");
		pattern2.add("ita.");
		pattern2.add("itabi");
		pattern2.add("itag");
		pattern2.add("itam");
		pattern2.add("itan");
		pattern2.add("itat");
		pattern2.add("ite");
		pattern2.add("itera");
		pattern2.add("iteri");
		pattern2.add("ites");
		pattern2.add("ith");
		pattern2.add("iti");
		pattern2.add("itia");
		pattern2.add("itic");
		pattern2.add("itica");
		pattern2.add("itick");
		pattern2.add("itig");
		pattern2.add("itill");
		pattern2.add("itim");
		pattern2.add("itio");
		pattern2.add("itis");
		pattern2.add("itism");
		pattern2.add("itom");
		pattern2.add("iton");
		pattern2.add("itram");
		pattern2.add("itry");
		pattern2.add("itt");
		pattern2.add("ituat");
		pattern2.add("itud");
		pattern2.add("itul");
		pattern2.add("itz.");
		pattern2.add("iu");
		pattern2.add("iv");
		pattern2.add("ivell");
		pattern2.add("iven.");
		pattern2.add("iver.");
		pattern2.add("ivers.");
		pattern2.add("ivil.");
		pattern2.add("ivio");
		pattern2.add("ivit");
		pattern2.add("ivore");
		pattern2.add("ivoro");
		pattern2.add("ivot");
		pattern2.add("iw");
		pattern2.add("ixo");
		pattern2.add("iy");
		pattern2.add("izar");
		pattern2.add("izi");
		pattern2.add("izont");
		pattern2.add("ja");
		pattern2.add("jacq");
		pattern2.add("jap");
		pattern2.add("je");
		pattern2.add("jers");
		pattern2.add("jestie");
		pattern2.add("jesty");
		pattern2.add("jew");
		pattern2.add("jop");
		pattern2.add("judg");
		pattern2.add("ka.");
		pattern2.add("kab");
		pattern2.add("kag");
		pattern2.add("kais");
		pattern2.add("kal");
		pattern2.add("kb");
		pattern2.add("ked");
		pattern2.add("kee");
		pattern2.add("keg");
		pattern2.add("keli");
		pattern2.add("kend");
		pattern2.add("ker");
		pattern2.add("kes");
		pattern2.add("kest.");
		pattern2.add("kety");
		pattern2.add("kf");
		pattern2.add("kh");
		pattern2.add("ki");
		pattern2.add("ki.");
		pattern2.add("kic");
		pattern2.add("kill");
		pattern2.add("kilo");
		pattern2.add("kim");
		pattern2.add("kin.");
		pattern2.add("kinde");
		pattern2.add("kiness");
		pattern2.add("king");
		pattern2.add("kip");
		pattern2.add("kis");
		pattern2.add("kish");
		pattern2.add("kk");
		pattern2.add("kl");
		pattern2.add("kley");
		pattern2.add("kly");
		pattern2.add("km");
		pattern2.add("knes");
		pattern2.add("kno");
		pattern2.add("kor");
		pattern2.add("kosh");
		pattern2.add("kou");
		pattern2.add("kron");
		pattern2.add("ks");
		pattern2.add("ksc");
		pattern2.add("ksl");
		pattern2.add("ksy");
		pattern2.add("kt");
		pattern2.add("kw");
		pattern2.add("labic");
		pattern2.add("labo");
		pattern2.add("laci");
		pattern2.add("lade");
		pattern2.add("lady");
		pattern2.add("lagn");
		pattern2.add("lamo");
		pattern2.add("land");
		pattern2.add("landl");
		pattern2.add("lanet");
		pattern2.add("lante");
		pattern2.add("larg");
		pattern2.add("lari");
		pattern2.add("lase");
		pattern2.add("latan");
		pattern2.add("lateli");
		pattern2.add("lativ");
		pattern2.add("lav");
		pattern2.add("lava");
		pattern2.add("lb");
		pattern2.add("lbin");
		pattern2.add("lc");
		pattern2.add("lce");
		pattern2.add("lci");
		pattern2.add("ld");
		pattern2.add("lde");
		pattern2.add("ldere");
		pattern2.add("lderi");
		pattern2.add("ldi");
		pattern2.add("ldis");
		pattern2.add("ldr");
		pattern2.add("ldri");
		pattern2.add("lea");
		pattern2.add("lebi");
		pattern2.add("left");
		pattern2.add("leg.");
		pattern2.add("legg");
		pattern2.add("lemat");
		pattern2.add("lematic");
		pattern2.add("len.");
		pattern2.add("lenc");
		pattern2.add("lene.");
		pattern2.add("lent");
		pattern2.add("leph");
		pattern2.add("lepr");
		pattern2.add("lerab");
		pattern2.add("lere");
		pattern2.add("lerg");
		pattern2.add("leri");
		pattern2.add("lero");
		pattern2.add("les");
		pattern2.add("lesco");
		pattern2.add("lesq");
		pattern2.add("less");
		pattern2.add("less.");
		pattern2.add("leva");
		pattern2.add("lever.");
		pattern2.add("levera");
		pattern2.add("levers");
		pattern2.add("ley");
		pattern2.add("leye");
		pattern2.add("lf");
		pattern2.add("lfr");
		pattern2.add("lg");
		pattern2.add("lga");
		pattern2.add("lgar");
		pattern2.add("lges");
		pattern2.add("lgo");
		pattern2.add("lh");
		pattern2.add("liag");
		pattern2.add("liam");
		pattern2.add("liariz");
		pattern2.add("lias");
		pattern2.add("liato");
		pattern2.add("libi");
		pattern2.add("licio");
		pattern2.add("licor");
		pattern2.add("lics");
		pattern2.add("lict.");
		pattern2.add("licu");
		pattern2.add("licy");
		pattern2.add("lida");
		pattern2.add("lider");
		pattern2.add("lidi");
		pattern2.add("lifer");
		pattern2.add("liff");
		pattern2.add("lifl");
		pattern2.add("ligate");
		pattern2.add("ligh");
		pattern2.add("ligra");
		pattern2.add("lik");
		pattern2.add("lil");
		pattern2.add("limbl");
		pattern2.add("limi");
		pattern2.add("limo");
		pattern2.add("limp");
		pattern2.add("lina");
		pattern2.add("line");
		pattern2.add("linea");
		pattern2.add("lini");
		pattern2.add("linker");
		pattern2.add("liog");
		pattern2.add("liq");
		pattern2.add("lisp");
		pattern2.add("lit");
		pattern2.add("lit.");
		pattern2.add("litica");
		pattern2.add("litics");
		pattern2.add("liver");
		pattern2.add("liz");
		pattern2.add("lj");
		pattern2.add("lka");
		pattern2.add("lkal");
		pattern2.add("lkat");
		pattern2.add("ll");
		pattern2.add("llaw");
		pattern2.add("lle");
		pattern2.add("llea");
		pattern2.add("llec");
		pattern2.add("lleg");
		pattern2.add("llel");
		pattern2.add("llen");
		pattern2.add("llet");
		pattern2.add("lli");
		pattern2.add("llin");
		pattern2.add("llina");
		pattern2.add("llo");
		pattern2.add("lloqui");
		pattern2.add("llout");
		pattern2.add("llow");
		pattern2.add("lm");
		pattern2.add("lmet");
		pattern2.add("lming");
		pattern2.add("lmod");
		pattern2.add("lmon");
		pattern2.add("ln");
		pattern2.add("lo.");
		pattern2.add("lobal");
		pattern2.add("loci");
		pattern2.add("lof");
		pattern2.add("logic");
		pattern2.add("logo");
		pattern2.add("logu");
		pattern2.add("lomer");
		pattern2.add("long");
		pattern2.add("loni");
		pattern2.add("loniz");
		pattern2.add("lood");
		pattern2.add("lope.");
		pattern2.add("lopi");
		pattern2.add("lopm");
		pattern2.add("lora");
		pattern2.add("lorato");
		pattern2.add("lorie");
		pattern2.add("lorou");
		pattern2.add("los.");
		pattern2.add("loset");
		pattern2.add("losophiz");
		pattern2.add("losophy");
		pattern2.add("lost");
		pattern2.add("lota");
		pattern2.add("lound");
		pattern2.add("lout");
		pattern2.add("lov");
		pattern2.add("lp");
		pattern2.add("lpab");
		pattern2.add("lpha");
		pattern2.add("lphi");
		pattern2.add("lping");
		pattern2.add("lpit");
		pattern2.add("lpl");
		pattern2.add("lpr");
		pattern2.add("lr");
		pattern2.add("ls");
		pattern2.add("lsc");
		pattern2.add("lse");
		pattern2.add("lsie");
		pattern2.add("lt");
		pattern2.add("ltag");
		pattern2.add("ltane");
		pattern2.add("lte");
		pattern2.add("lten");
		pattern2.add("ltera");
		pattern2.add("lthi");
		pattern2.add("lties.");
		pattern2.add("ltis");
		pattern2.add("ltr");
		pattern2.add("ltu");
		pattern2.add("ltura");
		pattern2.add("lua");
		pattern2.add("lubr");
		pattern2.add("luch");
		pattern2.add("luci");
		pattern2.add("luen");
		pattern2.add("luf");
		pattern2.add("luid");
		pattern2.add("luma");
		pattern2.add("lumi");
		pattern2.add("lumn.");
		pattern2.add("lumnia");
		pattern2.add("luo");
		pattern2.add("luor");
		pattern2.add("lup");
		pattern2.add("luss");
		pattern2.add("luste");
		pattern2.add("lut");
		pattern2.add("lven");
		pattern2.add("lvet");
		pattern2.add("lw");
		pattern2.add("ly");
		pattern2.add("lya");
		pattern2.add("lyb");
		pattern2.add("lyme");
		pattern2.add("lyno");
		pattern2.add("lys");
		pattern2.add("lyse");
		pattern2.add("ma");
		pattern2.add("mab");
		pattern2.add("maca");
		pattern2.add("machine");
		pattern2.add("macl");
		pattern2.add("magin");
		pattern2.add("magn");
		pattern2.add("mah");
		pattern2.add("maid");
		pattern2.add("mald");
		pattern2.add("malig");
		pattern2.add("malin");
		pattern2.add("malli");
		pattern2.add("malty");
		pattern2.add("mania");
		pattern2.add("manis");
		pattern2.add("maniz");
		pattern2.add("map");
		pattern2.add("marine.");
		pattern2.add("mariz");
		pattern2.add("marly");
		pattern2.add("marv");
		pattern2.add("masce");
		pattern2.add("mase");
		pattern2.add("mast");
		pattern2.add("mate");
		pattern2.add("math");
		pattern2.add("matis");
		pattern2.add("matiza");
		pattern2.add("mb");
		pattern2.add("mbat");
		pattern2.add("mbil");
		pattern2.add("mbing");
		pattern2.add("mbiv");
		pattern2.add("mc");
		pattern2.add("me.");
		pattern2.add("med");
		pattern2.add("med.");
		pattern2.add("media");
		pattern2.add("medie");
		pattern2.add("medy");
		pattern2.add("meg");
		pattern2.add("melon");
		pattern2.add("melt");
		pattern2.add("mem");
		pattern2.add("memo");
		pattern2.add("men");
		pattern2.add("mena");
		pattern2.add("menac");
		pattern2.add("mende");
		pattern2.add("mene");
		pattern2.add("meni");
		pattern2.add("mens");
		pattern2.add("mensu");
		pattern2.add("ment");
		pattern2.add("mente");
		pattern2.add("meon");
		pattern2.add("mersa");
		pattern2.add("mes");
		pattern2.add("mesti");
		pattern2.add("meta");
		pattern2.add("metal");
		pattern2.add("mete");
		pattern2.add("methi");
		pattern2.add("metr");
		pattern2.add("metric");
		pattern2.add("metrie");
		pattern2.add("metry");
		pattern2.add("mev");
		pattern2.add("mf");
		pattern2.add("mh");
		pattern2.add("mi.");
		pattern2.add("mia");
		pattern2.add("mida");
		pattern2.add("midg");
		pattern2.add("mig");
		pattern2.add("milia");
		pattern2.add("milie");
		pattern2.add("mill");
		pattern2.add("mina");
		pattern2.add("mind");
		pattern2.add("minee");
		pattern2.add("mingl");
		pattern2.add("mingli");
		pattern2.add("mingly");
		pattern2.add("mint");
		pattern2.add("minu");
		pattern2.add("miot");
		pattern2.add("mis");
		pattern2.add("miser.");
		pattern2.add("misl");
		pattern2.add("misti");
		pattern2.add("mistry");
		pattern2.add("mith");
		pattern2.add("miz");
		pattern2.add("mk");
		pattern2.add("ml");
		pattern2.add("mm");
		pattern2.add("mmary");
		pattern2.add("mn");
		pattern2.add("mna");
		pattern2.add("mnin");
		pattern2.add("mno");
		pattern2.add("mo");
		pattern2.add("mocr");
		pattern2.add("mocratiz");
		pattern2.add("mod");
		pattern2.add("mogo");
		pattern2.add("mois");
		pattern2.add("moise");
		pattern2.add("mok");
		pattern2.add("molest");
		pattern2.add("mome");
		pattern2.add("monet");
		pattern2.add("monge");
		pattern2.add("monia");
		pattern2.add("monism");
		pattern2.add("monist");
		pattern2.add("moniz");
		pattern2.add("monol");
		pattern2.add("mony.");
		pattern2.add("mor");
		pattern2.add("mora.");
		pattern2.add("mos");
		pattern2.add("mosey");
		pattern2.add("mosp");
		pattern2.add("moth");
		pattern2.add("mouf");
		pattern2.add("mous");
		pattern2.add("mov");
		pattern2.add("mp");
		pattern2.add("mpara");
		pattern2.add("mparab");
		pattern2.add("mpari");
		pattern2.add("mpet");
		pattern2.add("mphas");
		pattern2.add("mpi");
		pattern2.add("mpia");
		pattern2.add("mpies");
		pattern2.add("mpin");
		pattern2.add("mpir");
		pattern2.add("mpis");
		pattern2.add("mpori");
		pattern2.add("mposite");
		pattern2.add("mpous");
		pattern2.add("mpov");
		pattern2.add("mptr");
		pattern2.add("mpy");
		pattern2.add("mr");
		pattern2.add("ms");
		pattern2.add("msh");
		pattern2.add("msi");
		pattern2.add("mt");
		pattern2.add("mu");
		pattern2.add("mular");
		pattern2.add("mult");
		pattern2.add("multi");
		pattern2.add("mum");
		pattern2.add("mun");
		pattern2.add("mup");
		pattern2.add("muu");
		pattern2.add("mw");
		pattern2.add("na");
		pattern2.add("nab");
		pattern2.add("nabu");
		pattern2.add("nac.");
		pattern2.add("naca");
		pattern2.add("nact");
		pattern2.add("nager.");
		pattern2.add("nak");
		pattern2.add("nali");
		pattern2.add("nalia");
		pattern2.add("nalt");
		pattern2.add("namit");
		pattern2.add("nan");
		pattern2.add("nanci");
		pattern2.add("nanit");
		pattern2.add("nank");
		pattern2.add("narc");
		pattern2.add("nare");
		pattern2.add("nari");
		pattern2.add("narl");
		pattern2.add("narm");
		pattern2.add("nas");
		pattern2.add("nasc");
		pattern2.add("nasti");
		pattern2.add("nat");
		pattern2.add("natal");
		pattern2.add("natomiz");
		pattern2.add("nau");
		pattern2.add("nause");
		pattern2.add("naut");
		pattern2.add("nave");
		pattern2.add("nb");
		pattern2.add("ncar");
		pattern2.add("nces.");
		pattern2.add("ncha");
		pattern2.add("ncheo");
		pattern2.add("nchil");
		pattern2.add("nchis");
		pattern2.add("ncin");
		pattern2.add("ncit");
		pattern2.add("ncoura");
		pattern2.add("ncr");
		pattern2.add("ncu");
		pattern2.add("ndai");
		pattern2.add("ndan");
		pattern2.add("nde");
		pattern2.add("ndest.");
		pattern2.add("ndib");
		pattern2.add("ndif");
		pattern2.add("ndit");
		pattern2.add("ndiz");
		pattern2.add("nduc");
		pattern2.add("ndur");
		pattern2.add("ndwe");
		pattern2.add("ne.");
		pattern2.add("near");
		pattern2.add("neb");
		pattern2.add("nebu");
		pattern2.add("nec");
		pattern2.add("neck");
		pattern2.add("ned");
		pattern2.add("negat");
		pattern2.add("negativ");
		pattern2.add("nege");
		pattern2.add("nela");
		pattern2.add("neliz");
		pattern2.add("nemi");
		pattern2.add("nemo");
		pattern2.add("nen");
		pattern2.add("nene");
		pattern2.add("neo");
		pattern2.add("nepo");
		pattern2.add("neq");
		pattern2.add("ner");
		pattern2.add("nerab");
		pattern2.add("nerar");
		pattern2.add("nere");
		pattern2.add("neri");
		pattern2.add("nerr");
		pattern2.add("nes");
		pattern2.add("nes.");
		pattern2.add("nesp");
		pattern2.add("nest");
		pattern2.add("nesw");
		pattern2.add("netic");
		pattern2.add("nev");
		pattern2.add("neve");
		pattern2.add("new");
		pattern2.add("nf");
		pattern2.add("ngab");
		pattern2.add("ngel");
		pattern2.add("ngene");
		pattern2.add("ngere");
		pattern2.add("ngeri");
		pattern2.add("ngha");
		pattern2.add("ngib");
		pattern2.add("ngin");
		pattern2.add("ngit");
		pattern2.add("ngla");
		pattern2.add("ngov");
		pattern2.add("ngsh");
		pattern2.add("ngu");
		pattern2.add("ngum");
		pattern2.add("ngy");
		pattern2.add("nh");
		pattern2.add("nha");
		pattern2.add("nhab");
		pattern2.add("nhe");
		pattern2.add("nia");
		pattern2.add("nian");
		pattern2.add("niap");
		pattern2.add("niba");
		pattern2.add("nibl");
		pattern2.add("nid");
		pattern2.add("nidi");
		pattern2.add("nier");
		pattern2.add("nifi");
		pattern2.add("nificat");
		pattern2.add("nigr");
		pattern2.add("nik");
		pattern2.add("nim");
		pattern2.add("nimiz");
		pattern2.add("nin");
		pattern2.add("nine.");
		pattern2.add("ning");
		pattern2.add("nio");
		pattern2.add("nis.");
		pattern2.add("nista");
		pattern2.add("nit");
		pattern2.add("nith");
		pattern2.add("nitio");
		pattern2.add("nitor");
		pattern2.add("nitr");
		pattern2.add("nj");
		pattern2.add("nk");
		pattern2.add("nkero");
		pattern2.add("nket");
		pattern2.add("nkin");
		pattern2.add("nkl");
		pattern2.add("nl");
		pattern2.add("nm");
		pattern2.add("nme");
		pattern2.add("nmet");
		pattern2.add("nn");
		pattern2.add("nne");
		pattern2.add("nnial");
		pattern2.add("nniv");
		pattern2.add("nobl");
		pattern2.add("noble");
		pattern2.add("nocl");
		pattern2.add("nod");
		pattern2.add("noe");
		pattern2.add("nog");
		pattern2.add("noge");
		pattern2.add("noisi");
		pattern2.add("noli");
		pattern2.add("nologis");
		pattern2.add("nomic");
		pattern2.add("nomiz");
		pattern2.add("nomo");
		pattern2.add("nomy");
		pattern2.add("non");
		pattern2.add("nonag");
		pattern2.add("noni");
		pattern2.add("noniz");
		pattern2.add("nop");
		pattern2.add("nopoli");
		pattern2.add("norab");
		pattern2.add("norary");
		pattern2.add("nosc");
		pattern2.add("nose");
		pattern2.add("nost");
		pattern2.add("nota");
		pattern2.add("nou");
		pattern2.add("noun");
		pattern2.add("novel");
		pattern2.add("nowl");
		pattern2.add("np");
		pattern2.add("npi");
		pattern2.add("nprec");
		pattern2.add("nq");
		pattern2.add("nr");
		pattern2.add("nru");
		pattern2.add("ns");
		pattern2.add("nsab");
		pattern2.add("nsati");
		pattern2.add("nsc");
		pattern2.add("nse");
		pattern2.add("nses");
		pattern2.add("nsid");
		pattern2.add("nsig");
		pattern2.add("nsl");
		pattern2.add("nsm");
		pattern2.add("nsoc");
		pattern2.add("nspe");
		pattern2.add("nspi");
		pattern2.add("nstabl");
		pattern2.add("nt");
		pattern2.add("ntab");
		pattern2.add("nters");
		pattern2.add("nti");
		pattern2.add("ntib");
		pattern2.add("ntier");
		pattern2.add("ntif");
		pattern2.add("ntine");
		pattern2.add("nting");
		pattern2.add("ntip");
		pattern2.add("ntrolli");
		pattern2.add("nts");
		pattern2.add("ntume");
		pattern2.add("nua");
		pattern2.add("nud");
		pattern2.add("nuen");
		pattern2.add("nuffe");
		pattern2.add("nuin");
		pattern2.add("nuit");
		pattern2.add("num");
		pattern2.add("nume");
		pattern2.add("numi");
		pattern2.add("nun");
		pattern2.add("nuo");
		pattern2.add("nutr");
		pattern2.add("nv");
		pattern2.add("nw");
		pattern2.add("nym");
		pattern2.add("nyp");
		pattern2.add("nz");
		pattern2.add("nza");
		pattern2.add("oa");
		pattern2.add("oad");
		pattern2.add("oales");
		pattern2.add("oard");
		pattern2.add("oase");
		pattern2.add("oaste");
		pattern2.add("oati");
		pattern2.add("obab");
		pattern2.add("obar");
		pattern2.add("obel");
		pattern2.add("obi");
		pattern2.add("obin");
		pattern2.add("obing");
		pattern2.add("obr");
		pattern2.add("obul");
		pattern2.add("oce");
		pattern2.add("och");
		pattern2.add("ochet");
		pattern2.add("ocif");
		pattern2.add("ocil");
		pattern2.add("oclam");
		pattern2.add("ocod");
		pattern2.add("ocrac");
		pattern2.add("ocratiz");
		pattern2.add("ocre");
		pattern2.add("ocrit");
		pattern2.add("octora");
		pattern2.add("ocula");
		pattern2.add("ocure");
		pattern2.add("odded");
		pattern2.add("odic");
		pattern2.add("odio");
		pattern2.add("odo");
		pattern2.add("odor");
		pattern2.add("oduct.");
		pattern2.add("oducts");
		pattern2.add("oel");
		pattern2.add("oeng");
		pattern2.add("oer");
		pattern2.add("oeta");
		pattern2.add("oev");
		pattern2.add("ofi");
		pattern2.add("ofite");
		pattern2.add("ofitt");
		pattern2.add("ogar");
		pattern2.add("ogativ");
		pattern2.add("ogato");
		pattern2.add("oge");
		pattern2.add("ogene");
		pattern2.add("ogeo");
		pattern2.add("oger");
		pattern2.add("ogie");
		pattern2.add("ogis");
		pattern2.add("ogit");
		pattern2.add("ogl");
		pattern2.add("ogly");
		pattern2.add("ogniz");
		pattern2.add("ogro");
		pattern2.add("ogui");
		pattern2.add("ogy");
		pattern2.add("ogyn");
		pattern2.add("oh");
		pattern2.add("ohab");
		pattern2.add("oi");
		pattern2.add("oices");
		pattern2.add("oider");
		pattern2.add("oiff");
		pattern2.add("oig");
		pattern2.add("oilet");
		pattern2.add("oing");
		pattern2.add("ointer");
		pattern2.add("oism");
		pattern2.add("oison");
		pattern2.add("oisten");
		pattern2.add("oiter");
		pattern2.add("oj");
		pattern2.add("ok");
		pattern2.add("oken");
		pattern2.add("okie");
		pattern2.add("ola");
		pattern2.add("olan");
		pattern2.add("olass");
		pattern2.add("old");
		pattern2.add("olde");
		pattern2.add("oler");
		pattern2.add("olesc");
		pattern2.add("olet");
		pattern2.add("olfi");
		pattern2.add("oli");
		pattern2.add("olia");
		pattern2.add("olice");
		pattern2.add("olid.");
		pattern2.add("olif");
		pattern2.add("olil");
		pattern2.add("oling");
		pattern2.add("olio");
		pattern2.add("olis.");
		pattern2.add("olish");
		pattern2.add("olite");
		pattern2.add("olitio");
		pattern2.add("oliv");
		pattern2.add("ollie");
		pattern2.add("ologiz");
		pattern2.add("olor");
		pattern2.add("olpl");
		pattern2.add("olt");
		pattern2.add("olub");
		pattern2.add("olume");
		pattern2.add("olun");
		pattern2.add("olus");
		pattern2.add("olv");
		pattern2.add("oly");
		pattern2.add("omah");
		pattern2.add("omal");
		pattern2.add("omatiz");
		pattern2.add("ombe");
		pattern2.add("ombl");
		pattern2.add("ome");
		pattern2.add("omena");
		pattern2.add("omerse");
		pattern2.add("omet");
		pattern2.add("ometry");
		pattern2.add("omia");
		pattern2.add("omic.");
		pattern2.add("omica");
		pattern2.add("omid");
		pattern2.add("omin");
		pattern2.add("omini");
		pattern2.add("ommend");
		pattern2.add("omoge");
		pattern2.add("omon");
		pattern2.add("ompi");
		pattern2.add("ompro");
		pattern2.add("on");
		pattern2.add("ona");
		pattern2.add("onac");
		pattern2.add("onan");
		pattern2.add("onc");
		pattern2.add("oncil");
		pattern2.add("ond");
		pattern2.add("ondo");
		pattern2.add("onen");
		pattern2.add("onest");
		pattern2.add("ongu");
		pattern2.add("onic");
		pattern2.add("onio");
		pattern2.add("onis");
		pattern2.add("oniu");
		pattern2.add("onkey");
		pattern2.add("onodi");
		pattern2.add("onomy");
		pattern2.add("ons");
		pattern2.add("onspi");
		pattern2.add("onspira");
		pattern2.add("onsu");
		pattern2.add("onten");
		pattern2.add("onti");
		pattern2.add("ontif");
		pattern2.add("onum");
		pattern2.add("onva");
		pattern2.add("oo");
		pattern2.add("oode");
		pattern2.add("oodi");
		pattern2.add("ook");
		pattern2.add("oopi");
		pattern2.add("oord");
		pattern2.add("oost");
		pattern2.add("opa");
		pattern2.add("oped");
		pattern2.add("oper");
		pattern2.add("opera");
		pattern2.add("operag");
		pattern2.add("oph");
		pattern2.add("ophan");
		pattern2.add("opher");
		pattern2.add("oping");
		pattern2.add("opit");
		pattern2.add("opon");
		pattern2.add("oposi");
		pattern2.add("opr");
		pattern2.add("opu");
		pattern2.add("opy");
		pattern2.add("oq");
		pattern2.add("ora");
		pattern2.add("ora.");
		pattern2.add("orag");
		pattern2.add("oraliz");
		pattern2.add("orange");
		pattern2.add("orea");
		pattern2.add("oreal");
		pattern2.add("orei");
		pattern2.add("oresh");
		pattern2.add("orest.");
		pattern2.add("orew");
		pattern2.add("orgu");
		pattern2.add("oria");
		pattern2.add("orica");
		pattern2.add("oril");
		pattern2.add("orin");
		pattern2.add("orio");
		pattern2.add("ority");
		pattern2.add("oriu");
		pattern2.add("ormi");
		pattern2.add("orne");
		pattern2.add("orof");
		pattern2.add("oroug");
		pattern2.add("orpe");
		pattern2.add("orrh");
		pattern2.add("orse");
		pattern2.add("orsen");
		pattern2.add("orst");
		pattern2.add("orthi");
		pattern2.add("orthy");
		pattern2.add("orty");
		pattern2.add("orum");
		pattern2.add("ory");
		pattern2.add("osal");
		pattern2.add("osc");
		pattern2.add("osce");
		pattern2.add("oscop");
		pattern2.add("oscopi");
		pattern2.add("oscr");
		pattern2.add("osie");
		pattern2.add("ositiv");
		pattern2.add("osito");
		pattern2.add("osity");
		pattern2.add("osiu");
		pattern2.add("osl");
		pattern2.add("oso");
		pattern2.add("ospa");
		pattern2.add("ospo");
		pattern2.add("osta");
		pattern2.add("ostati");
		pattern2.add("ostil");
		pattern2.add("ostit");
		pattern2.add("otan");
		pattern2.add("oteleg");
		pattern2.add("oter.");
		pattern2.add("oters");
		pattern2.add("otes");
		pattern2.add("oth");
		pattern2.add("othesi");
		pattern2.add("othi");
		pattern2.add("otic.");
		pattern2.add("otica");
		pattern2.add("otice");
		pattern2.add("otif");
		pattern2.add("otis");
		pattern2.add("otos");
		pattern2.add("ou");
		pattern2.add("oubl");
		pattern2.add("ouchi");
		pattern2.add("ouet");
		pattern2.add("oul");
		pattern2.add("ouncer");
		pattern2.add("ound");
		pattern2.add("ouv");
		pattern2.add("oven");
		pattern2.add("overne");
		pattern2.add("overs");
		pattern2.add("overt");
		pattern2.add("ovis");
		pattern2.add("oviti");
		pattern2.add("ovol");
		pattern2.add("owder");
		pattern2.add("owel");
		pattern2.add("owest");
		pattern2.add("owi");
		pattern2.add("owni");
		pattern2.add("owo");
		pattern2.add("oya");
		pattern2.add("pa");
		pattern2.add("paca");
		pattern2.add("pace");
		pattern2.add("pact");
		pattern2.add("pad");
		pattern2.add("pagan");
		pattern2.add("pagat");
		pattern2.add("pai");
		pattern2.add("pain");
		pattern2.add("pal");
		pattern2.add("pana");
		pattern2.add("panel");
		pattern2.add("panty");
		pattern2.add("pany");
		pattern2.add("pap");
		pattern2.add("papu");
		pattern2.add("parabl");
		pattern2.add("parage");
		pattern2.add("pardi");
		pattern2.add("pare");
		pattern2.add("parel");
		pattern2.add("pari");
		pattern2.add("paris");
		pattern2.add("pate");
		pattern2.add("pater");
		pattern2.add("pathic");
		pattern2.add("pathy");
		pattern2.add("patric");
		pattern2.add("pav");
		pattern2.add("pay");
		pattern2.add("pb");
		pattern2.add("pd");
		pattern2.add("pe.");
		pattern2.add("pea");
		pattern2.add("pearl");
		pattern2.add("pec");
		pattern2.add("ped");
		pattern2.add("pede");
		pattern2.add("pedi");
		pattern2.add("pedia");
		pattern2.add("pedic");
		pattern2.add("pee");
		pattern2.add("peed");
		pattern2.add("pek");
		pattern2.add("pela");
		pattern2.add("pelie");
		pattern2.add("penan");
		pattern2.add("penc");
		pattern2.add("penth");
		pattern2.add("peon");
		pattern2.add("pera.");
		pattern2.add("perabl");
		pattern2.add("perag");
		pattern2.add("peri");
		pattern2.add("perist");
		pattern2.add("permal");
		pattern2.add("perme");
		pattern2.add("pern");
		pattern2.add("pero");
		pattern2.add("perti");
		pattern2.add("peru");
		pattern2.add("perv");
		pattern2.add("pet");
		pattern2.add("peten");
		pattern2.add("petiz");
		pattern2.add("pf");
		pattern2.add("pg");
		pattern2.add("ph.");
		pattern2.add("phari");
		pattern2.add("pheno");
		pattern2.add("pher");
		pattern2.add("phes.");
		pattern2.add("phic");
		pattern2.add("phie");
		pattern2.add("phing");
		pattern2.add("phisti");
		pattern2.add("phiz");
		pattern2.add("phl");
		pattern2.add("phob");
		pattern2.add("phone");
		pattern2.add("phoni");
		pattern2.add("phor");
		pattern2.add("phs");
		pattern2.add("pht");
		pattern2.add("phu");
		pattern2.add("phy");
		pattern2.add("pia");
		pattern2.add("pian");
		pattern2.add("picie");
		pattern2.add("picy");
		pattern2.add("pid");
		pattern2.add("pida");
		pattern2.add("pide");
		pattern2.add("pidi");
		pattern2.add("piec");
		pattern2.add("pien");
		pattern2.add("pigrap");
		pattern2.add("pilo");
		pattern2.add("pin");
		pattern2.add("pin.");
		pattern2.add("pind");
		pattern2.add("pino");
		pattern2.add("pio");
		pattern2.add("pion");
		pattern2.add("pith");
		pattern2.add("pitha");
		pattern2.add("pitu");
		pattern2.add("pk");
		pattern2.add("pl");
		pattern2.add("plan");
		pattern2.add("plast");
		pattern2.add("plia");
		pattern2.add("plier");
		pattern2.add("plig");
		pattern2.add("plin");
		pattern2.add("ploi");
		pattern2.add("plum");
		pattern2.add("plumb");
		pattern2.add("pm");
		pattern2.add("pn");
		pattern2.add("poc");
		pattern2.add("pod.");
		pattern2.add("poem");
		pattern2.add("poet");
		pattern2.add("pog");
		pattern2.add("poin");
		pattern2.add("point");
		pattern2.add("polyt");
		pattern2.add("poni");
		pattern2.add("pop");
		pattern2.add("por");
		pattern2.add("pory");
		pattern2.add("pos");
		pattern2.add("poss");
		pattern2.add("pot");
		pattern2.add("pota");
		pattern2.add("poun");
		pattern2.add("pp");
		pattern2.add("ppara");
		pattern2.add("ppe");
		pattern2.add("pped");
		pattern2.add("ppel");
		pattern2.add("ppen");
		pattern2.add("pper");
		pattern2.add("ppet");
		pattern2.add("pposite");
		pattern2.add("pr");
		pattern2.add("praye");
		pattern2.add("preci");
		pattern2.add("preco");
		pattern2.add("preem");
		pattern2.add("prefac");
		pattern2.add("prela");
		pattern2.add("prer");
		pattern2.add("prese");
		pattern2.add("press");
		pattern2.add("preten");
		pattern2.add("prev");
		pattern2.add("prie");
		pattern2.add("print");
		pattern2.add("pris");
		pattern2.add("priso");
		pattern2.add("proca");
		pattern2.add("profit");
		pattern2.add("prol");
		pattern2.add("prose");
		pattern2.add("prot");
		pattern2.add("ps");
		pattern2.add("pse");
		pattern2.add("psh");
		pattern2.add("psib");
		pattern2.add("pt");
		pattern2.add("ptab");
		pattern2.add("pte");
		pattern2.add("pth");
		pattern2.add("ptim");
		pattern2.add("ptur");
		pattern2.add("ptw");
		pattern2.add("pub");
		pattern2.add("pue");
		pattern2.add("puf");
		pattern2.add("pulc");
		pattern2.add("pum");
		pattern2.add("pun");
		pattern2.add("purr");
		pattern2.add("pus");
		pattern2.add("put");
		pattern2.add("pute");
		pattern2.add("puter");
		pattern2.add("putr");
		pattern2.add("putted");
		pattern2.add("puttin");
		pattern2.add("pw");
		pattern2.add("qu");
		pattern2.add("quav");
		pattern2.add("que.");
		pattern2.add("quer");
		pattern2.add("quet");
		pattern2.add("rab");
		pattern2.add("rabi");
		pattern2.add("rache");
		pattern2.add("racl");
		pattern2.add("raffi");
		pattern2.add("raft");
		pattern2.add("rai");
		pattern2.add("ralo");
		pattern2.add("ramet");
		pattern2.add("rami");
		pattern2.add("raneo");
		pattern2.add("range");
		pattern2.add("rani");
		pattern2.add("rano");
		pattern2.add("raper");
		pattern2.add("raphy");
		pattern2.add("rarc");
		pattern2.add("rare");
		pattern2.add("raref");
		pattern2.add("raril");
		pattern2.add("ras");
		pattern2.add("ration");
		pattern2.add("raut");
		pattern2.add("ravai");
		pattern2.add("ravel");
		pattern2.add("razie");
		pattern2.add("rb");
		pattern2.add("rbab");
		pattern2.add("rbag");
		pattern2.add("rbi");
		pattern2.add("rbif");
		pattern2.add("rbin");
		pattern2.add("rbine");
		pattern2.add("rbing.");
		pattern2.add("rbo");
		pattern2.add("rc");
		pattern2.add("rce");
		pattern2.add("rcen");
		pattern2.add("rcha");
		pattern2.add("rcher");
		pattern2.add("rcib");
		pattern2.add("rcit");
		pattern2.add("rcum");
		pattern2.add("rdal");
		pattern2.add("rdi");
		pattern2.add("rdia");
		pattern2.add("rdier");
		pattern2.add("rdin");
		pattern2.add("rding");
		pattern2.add("re.");
		pattern2.add("real");
		pattern2.add("rean");
		pattern2.add("rearr");
		pattern2.add("reav");
		pattern2.add("reaw");
		pattern2.add("rebrat");
		pattern2.add("recoll");
		pattern2.add("recompe");
		pattern2.add("recre");
		pattern2.add("red");
		pattern2.add("rede");
		pattern2.add("redis");
		pattern2.add("redit");
		pattern2.add("refac");
		pattern2.add("refe");
		pattern2.add("refer.");
		pattern2.add("refi");
		pattern2.add("refy");
		pattern2.add("regis");
		pattern2.add("reit");
		pattern2.add("reli");
		pattern2.add("relu");
		pattern2.add("renta");
		pattern2.add("rente");
		pattern2.add("reo");
		pattern2.add("repin");
		pattern2.add("reposi");
		pattern2.add("repu");
		pattern2.add("rer");
		pattern2.add("reri");
		pattern2.add("rero");
		pattern2.add("reru");
		pattern2.add("res.");
		pattern2.add("respi");
		pattern2.add("ressib");
		pattern2.add("rest");
		pattern2.add("restal");
		pattern2.add("restr");
		pattern2.add("reter");
		pattern2.add("retiz");
		pattern2.add("retri");
		pattern2.add("reu");
		pattern2.add("reuti");
		pattern2.add("rev");
		pattern2.add("reval");
		pattern2.add("revel");
		pattern2.add("rever.");
		pattern2.add("revers");
		pattern2.add("revert");
		pattern2.add("revil");
		pattern2.add("revolu");
		pattern2.add("rewh");
		pattern2.add("rf");
		pattern2.add("rfu");
		pattern2.add("rfy");
		pattern2.add("rg");
		pattern2.add("rger");
		pattern2.add("rget");
		pattern2.add("rgic");
		pattern2.add("rgin");
		pattern2.add("rging");
		pattern2.add("rgis");
		pattern2.add("rgit");
		pattern2.add("rgl");
		pattern2.add("rgon");
		pattern2.add("rgu");
		pattern2.add("rh");
		pattern2.add("rh.");
		pattern2.add("rhal");
		pattern2.add("ria");
		pattern2.add("riab");
		pattern2.add("riag");
		pattern2.add("rib");
		pattern2.add("riba");
		pattern2.add("ricas");
		pattern2.add("rice");
		pattern2.add("rici");
		pattern2.add("ricid");
		pattern2.add("ricie");
		pattern2.add("rico");
		pattern2.add("rider");
		pattern2.add("rienc");
		pattern2.add("rient");
		pattern2.add("rier");
		pattern2.add("riet");
		pattern2.add("rigan");
		pattern2.add("rigi");
		pattern2.add("riliz");
		pattern2.add("riman");
		pattern2.add("rimi");
		pattern2.add("rimo");
		pattern2.add("rimpe");
		pattern2.add("rina");
		pattern2.add("rina.");
		pattern2.add("rind");
		pattern2.add("rine");
		pattern2.add("ring");
		pattern2.add("rio");
		pattern2.add("riph");
		pattern2.add("riphe");
		pattern2.add("ripl");
		pattern2.add("riplic");
		pattern2.add("riq");
		pattern2.add("ris");
		pattern2.add("ris.");
		pattern2.add("risc");
		pattern2.add("rish");
		pattern2.add("risp");
		pattern2.add("ritab");
		pattern2.add("rited.");
		pattern2.add("riter.");
		pattern2.add("riters");
		pattern2.add("ritic");
		pattern2.add("ritu");
		pattern2.add("ritur");
		pattern2.add("rivel");
		pattern2.add("rivet");
		pattern2.add("rivi");
		pattern2.add("rj");
		pattern2.add("rket");
		pattern2.add("rkle");
		pattern2.add("rklin");
		pattern2.add("rl");
		pattern2.add("rle");
		pattern2.add("rled");
		pattern2.add("rlig");
		pattern2.add("rlis");
		pattern2.add("rlish");
		pattern2.add("rlo");
		pattern2.add("rm");
		pattern2.add("rmac");
		pattern2.add("rme");
		pattern2.add("rmen");
		pattern2.add("rmers");
		pattern2.add("rming");
		pattern2.add("rming.");
		pattern2.add("rmio");
		pattern2.add("rmit");
		pattern2.add("rmy");
		pattern2.add("rnar");
		pattern2.add("rnel");
		pattern2.add("rner");
		pattern2.add("rnet");
		pattern2.add("rney");
		pattern2.add("rnic");
		pattern2.add("rnis");
		pattern2.add("rnit");
		pattern2.add("rniv");
		pattern2.add("rno");
		pattern2.add("rnou");
		pattern2.add("rnu");
		pattern2.add("robl");
		pattern2.add("roc");
		pattern2.add("rocr");
		pattern2.add("roe");
		pattern2.add("rofe");
		pattern2.add("rofil");
		pattern2.add("rok");
		pattern2.add("roker");
		pattern2.add("role.");
		pattern2.add("romete");
		pattern2.add("romi");
		pattern2.add("romp");
		pattern2.add("ronal");
		pattern2.add("rone");
		pattern2.add("ronis");
		pattern2.add("ronta");
		pattern2.add("room");
		pattern2.add("root");
		pattern2.add("ropel");
		pattern2.add("ropic");
		pattern2.add("rori");
		pattern2.add("roro");
		pattern2.add("rosper");
		pattern2.add("ross");
		pattern2.add("rothe");
		pattern2.add("roty");
		pattern2.add("rova");
		pattern2.add("rovel");
		pattern2.add("rox");
		pattern2.add("rp");
		pattern2.add("rpea");
		pattern2.add("rpent");
		pattern2.add("rper.");
		pattern2.add("rpet");
		pattern2.add("rph");
		pattern2.add("rping");
		pattern2.add("rpo");
		pattern2.add("rr");
		pattern2.add("rrec");
		pattern2.add("rref");
		pattern2.add("rreo");
		pattern2.add("rrest");
		pattern2.add("rrio");
		pattern2.add("rriv");
		pattern2.add("rron");
		pattern2.add("rros");
		pattern2.add("rrys");
		pattern2.add("rs");
		pattern2.add("rsa");
		pattern2.add("rsati");
		pattern2.add("rsc");
		pattern2.add("rse");
		pattern2.add("rsec");
		pattern2.add("rsecr");
		pattern2.add("rser.");
		pattern2.add("rses");
		pattern2.add("rsev");
		pattern2.add("rsh");
		pattern2.add("rsha");
		pattern2.add("rsi");
		pattern2.add("rsib");
		pattern2.add("rson");
		pattern2.add("rsp");
		pattern2.add("rsw");
		pattern2.add("rtach");
		pattern2.add("rtag");
		pattern2.add("rteb");
		pattern2.add("rtend");
		pattern2.add("rteo");
		pattern2.add("rti");
		pattern2.add("rtib");
		pattern2.add("rtid");
		pattern2.add("rtier");
		pattern2.add("rtig");
		pattern2.add("rtili");
		pattern2.add("rtill");
		pattern2.add("rtily");
		pattern2.add("rtist");
		pattern2.add("rtiv");
		pattern2.add("rtri");
		pattern2.add("rtroph");
		pattern2.add("rtsh");
		pattern2.add("rua");
		pattern2.add("ruel");
		pattern2.add("ruen");
		pattern2.add("rugl");
		pattern2.add("ruin");
		pattern2.add("rumpl");
		pattern2.add("run");
		pattern2.add("runk");
		pattern2.add("runty");
		pattern2.add("rusc");
		pattern2.add("rutin");
		pattern2.add("rve");
		pattern2.add("rveli");
		pattern2.add("rven");
		pattern2.add("rver.");
		pattern2.add("rvest");
		pattern2.add("rvey");
		pattern2.add("rvic");
		pattern2.add("rviv");
		pattern2.add("rvo");
		pattern2.add("rw");
		pattern2.add("ryc");
		pattern2.add("rynge");
		pattern2.add("ryt");
		pattern2.add("sa");
		pattern2.add("sab");
		pattern2.add("sack");
		pattern2.add("sacri");
		pattern2.add("sact");
		pattern2.add("sai");
		pattern2.add("salar");
		pattern2.add("salm");
		pattern2.add("salo");
		pattern2.add("salt");
		pattern2.add("sanc");
		pattern2.add("sande");
		pattern2.add("sap");
		pattern2.add("sata");
		pattern2.add("satio");
		pattern2.add("satu");
		pattern2.add("sau");
		pattern2.add("savor");
		pattern2.add("saw");
		pattern2.add("sb");
		pattern2.add("scant");
		pattern2.add("scap");
		pattern2.add("scav");
		pattern2.add("sced");
		pattern2.add("scei");
		pattern2.add("sces");
		pattern2.add("sch");
		pattern2.add("scho");
		pattern2.add("scie");
		pattern2.add("scind");
		pattern2.add("scle");
		pattern2.add("scli");
		pattern2.add("scof");
		pattern2.add("scopy");
		pattern2.add("scoura");
		pattern2.add("scu");
		pattern2.add("sd");
		pattern2.add("se.");
		pattern2.add("sea");
		pattern2.add("seas");
		pattern2.add("seaw");
		pattern2.add("seco");
		pattern2.add("sect");
		pattern2.add("sed");
		pattern2.add("sede");
		pattern2.add("sedl");
		pattern2.add("seg");
		pattern2.add("segr");
		pattern2.add("sei");
		pattern2.add("sele");
		pattern2.add("self");
		pattern2.add("selv");
		pattern2.add("seme");
		pattern2.add("semol");
		pattern2.add("senat");
		pattern2.add("senc");
		pattern2.add("send");
		pattern2.add("sened");
		pattern2.add("seng");
		pattern2.add("senin");
		pattern2.add("sentd");
		pattern2.add("sentl");
		pattern2.add("sepa");
		pattern2.add("ser.");
		pattern2.add("serl");
		pattern2.add("sero");
		pattern2.add("servo");
		pattern2.add("ses");
		pattern2.add("sesh");
		pattern2.add("sest");
		pattern2.add("seum");
		pattern2.add("sev");
		pattern2.add("seven");
		pattern2.add("sewi");
		pattern2.add("sex");
		pattern2.add("sf");
		pattern2.add("sg");
		pattern2.add("sh");
		pattern2.add("sh.");
		pattern2.add("sher");
		pattern2.add("shev");
		pattern2.add("shin");
		pattern2.add("shio");
		pattern2.add("ship");
		pattern2.add("shiv");
		pattern2.add("sho");
		pattern2.add("shold");
		pattern2.add("shon");
		pattern2.add("shor");
		pattern2.add("short");
		pattern2.add("shw");
		pattern2.add("sib");
		pattern2.add("sicc");
		pattern2.add("side.");
		pattern2.add("sides");
		pattern2.add("sidi");
		pattern2.add("sidiz");
		pattern2.add("signa");
		pattern2.add("sile");
		pattern2.add("sily");
		pattern2.add("sin");
		pattern2.add("sina");
		pattern2.add("sine.");
		pattern2.add("sing");
		pattern2.add("sio");
		pattern2.add("sion");
		pattern2.add("siona");
		pattern2.add("sir");
		pattern2.add("sira");
		pattern2.add("sis");
		pattern2.add("sitio");
		pattern2.add("siu");
		pattern2.add("siv");
		pattern2.add("siz");
		pattern2.add("sk");
		pattern2.add("ske");
		pattern2.add("sket");
		pattern2.add("skine");
		pattern2.add("sking");
		pattern2.add("sl");
		pattern2.add("slat");
		pattern2.add("sle");
		pattern2.add("slith");
		pattern2.add("sm");
		pattern2.add("sma");
		pattern2.add("small");
		pattern2.add("sman");
		pattern2.add("smel");
		pattern2.add("smen");
		pattern2.add("smith");
		pattern2.add("smold");
		pattern2.add("sn");
		pattern2.add("so");
		pattern2.add("soce");
		pattern2.add("soft");
		pattern2.add("solab");
		pattern2.add("sold");
		pattern2.add("solic");
		pattern2.add("solv");
		pattern2.add("som");
		pattern2.add("son.");
		pattern2.add("sona");
		pattern2.add("song");
		pattern2.add("sop");
		pattern2.add("sophic");
		pattern2.add("sophiz");
		pattern2.add("sophy");
		pattern2.add("sorc");
		pattern2.add("sord");
		pattern2.add("sov");
		pattern2.add("sovi");
		pattern2.add("spa");
		pattern2.add("spai");
		pattern2.add("span");
		pattern2.add("spend");
		pattern2.add("speo");
		pattern2.add("sper");
		pattern2.add("sphe");
		pattern2.add("spher");
		pattern2.add("spho");
		pattern2.add("spil");
		pattern2.add("sping");
		pattern2.add("spio");
		pattern2.add("sply");
		pattern2.add("spon");
		pattern2.add("spor");
		pattern2.add("spot");
		pattern2.add("squall");
		pattern2.add("sr");
		pattern2.add("ss");
		pattern2.add("ssa");
		pattern2.add("ssas");
		pattern2.add("ssc");
		pattern2.add("ssel");
		pattern2.add("sseng");
		pattern2.add("sses.");
		pattern2.add("sset");
		pattern2.add("ssi");
		pattern2.add("ssie");
		pattern2.add("ssier");
		pattern2.add("ssily");
		pattern2.add("ssl");
		pattern2.add("ssli");
		pattern2.add("ssn");
		pattern2.add("sspend");
		pattern2.add("sst");
		pattern2.add("ssura");
		pattern2.add("ssw");
		pattern2.add("st.");
		pattern2.add("stag");
		pattern2.add("stal");
		pattern2.add("stami");
		pattern2.add("stand");
		pattern2.add("stap");
		pattern2.add("stat.");
		pattern2.add("sted");
		pattern2.add("sterni");
		pattern2.add("stero");
		pattern2.add("stew");
		pattern2.add("stewa");
		pattern2.add("sthe");
		pattern2.add("sti");
		pattern2.add("sti.");
		pattern2.add("stia");
		pattern2.add("stic");
		pattern2.add("stick");
		pattern2.add("stie");
		pattern2.add("stif");
		pattern2.add("sting");
		pattern2.add("stir");
		pattern2.add("stle");
		pattern2.add("stock");
		pattern2.add("stoma");
		pattern2.add("stone");
		pattern2.add("stop");
		pattern2.add("store");
		pattern2.add("str");
		pattern2.add("strad");
		pattern2.add("stratu");
		pattern2.add("stray");
		pattern2.add("strid");
		pattern2.add("stry");
		pattern2.add("stw");
		pattern2.add("sty");
		pattern2.add("su");
		pattern2.add("sual");
		pattern2.add("sub");
		pattern2.add("sug");
		pattern2.add("suis");
		pattern2.add("suit");
		pattern2.add("sul");
		pattern2.add("sum");
		pattern2.add("sumi");
		pattern2.add("sun");
		pattern2.add("sur");
		pattern2.add("sv");
		pattern2.add("sw");
		pattern2.add("swo");
		pattern2.add("sy");
		pattern2.add("syc");
		pattern2.add("syl");
		pattern2.add("syno");
		pattern2.add("syrin");
		pattern2.add("ta");
		pattern2.add("ta.");
		pattern2.add("tab");
		pattern2.add("tables");
		pattern2.add("taboliz");
		pattern2.add("taci");
		pattern2.add("tado");
		pattern2.add("taf");
		pattern2.add("tailo");
		pattern2.add("tal");
		pattern2.add("tala");
		pattern2.add("talen");
		pattern2.add("tali");
		pattern2.add("talk");
		pattern2.add("tallis");
		pattern2.add("talog");
		pattern2.add("tamo");
		pattern2.add("tande");
		pattern2.add("tanta");
		pattern2.add("taper");
		pattern2.add("tapl");
		pattern2.add("tara");
		pattern2.add("tarc");
		pattern2.add("tare");
		pattern2.add("tariz");
		pattern2.add("tase");
		pattern2.add("tasy");
		pattern2.add("tatic");
		pattern2.add("tatur");
		pattern2.add("taun");
		pattern2.add("tav");
		pattern2.add("taw");
		pattern2.add("taxis");
		pattern2.add("tb");
		pattern2.add("tc");
		pattern2.add("tch");
		pattern2.add("tchet");
		pattern2.add("td");
		pattern2.add("te.");
		pattern2.add("teadi");
		pattern2.add("teat");
		pattern2.add("tece");
		pattern2.add("tect");
		pattern2.add("ted");
		pattern2.add("tedi");
		pattern2.add("tee");
		pattern2.add("teg");
		pattern2.add("teger");
		pattern2.add("tegi");
		pattern2.add("tel.");
		pattern2.add("teli");
		pattern2.add("tels");
		pattern2.add("tema");
		pattern2.add("temat");
		pattern2.add("tenan");
		pattern2.add("tenc");
		pattern2.add("tend");
		pattern2.add("tenes");
		pattern2.add("tent");
		pattern2.add("tentag");
		pattern2.add("teo");
		pattern2.add("tep");
		pattern2.add("tepe");
		pattern2.add("terc");
		pattern2.add("terd");
		pattern2.add("teri");
		pattern2.add("teries");
		pattern2.add("teris");
		pattern2.add("teriza");
		pattern2.add("ternit");
		pattern2.add("terv");
		pattern2.add("tes.");
		pattern2.add("tess");
		pattern2.add("tess.");
		pattern2.add("tethe");
		pattern2.add("teu");
		pattern2.add("tex");
		pattern2.add("tey");
		pattern2.add("tf");
		pattern2.add("tg");
		pattern2.add("th.");
		pattern2.add("than");
		pattern2.add("the");
		pattern2.add("thea");
		pattern2.add("theas");
		pattern2.add("theat");
		pattern2.add("theis");
		pattern2.add("thet");
		pattern2.add("thic.");
		pattern2.add("thica");
		pattern2.add("thil");
		pattern2.add("think");
		pattern2.add("thl");
		pattern2.add("thode");
		pattern2.add("thodic");
		pattern2.add("thoo");
		pattern2.add("thorit");
		pattern2.add("thoriz");
		pattern2.add("ths");
		pattern2.add("tia");
		pattern2.add("tiab");
		pattern2.add("tiato");
		pattern2.add("tib");
		pattern2.add("tick");
		pattern2.add("tico");
		pattern2.add("ticu");
		pattern2.add("tidi");
		pattern2.add("tien");
		pattern2.add("tif");
		pattern2.add("tify");
		pattern2.add("tig");
		pattern2.add("tigu");
		pattern2.add("tillin");
		pattern2.add("tim");
		pattern2.add("timp");
		pattern2.add("timul");
		pattern2.add("tin");
		pattern2.add("tina");
		pattern2.add("tine.");
		pattern2.add("tini");
		pattern2.add("tio");
		pattern2.add("tioc");
		pattern2.add("tionee");
		pattern2.add("tiq");
		pattern2.add("tisa");
		pattern2.add("tise");
		pattern2.add("tism");
		pattern2.add("tiso");
		pattern2.add("tisp");
		pattern2.add("tistica");
		pattern2.add("titl");
		pattern2.add("tiu");
		pattern2.add("tiv");
		pattern2.add("tiva");
		pattern2.add("tiz");
		pattern2.add("tiza");
		pattern2.add("tizen");
		pattern2.add("tl");
		pattern2.add("tla");
		pattern2.add("tlan");
		pattern2.add("tle.");
		pattern2.add("tled");
		pattern2.add("tles.");
		pattern2.add("tlet.");
		pattern2.add("tlo");
		pattern2.add("tm");
		pattern2.add("tme");
		pattern2.add("tn");
		pattern2.add("to");
		pattern2.add("tob");
		pattern2.add("tocrat");
		pattern2.add("todo");
		pattern2.add("tof");
		pattern2.add("togr");
		pattern2.add("toic");
		pattern2.add("toma");
		pattern2.add("tomb");
		pattern2.add("tomy");
		pattern2.add("tonali");
		pattern2.add("tonat");
		pattern2.add("tono");
		pattern2.add("tony");
		pattern2.add("tora");
		pattern2.add("torie");
		pattern2.add("toriz");
		pattern2.add("tos");
		pattern2.add("tour");
		pattern2.add("tout");
		pattern2.add("towar");
		pattern2.add("tp");
		pattern2.add("tra");
		pattern2.add("trab");
		pattern2.add("trach");
		pattern2.add("traci");
		pattern2.add("tracit");
		pattern2.add("tracte");
		pattern2.add("tras");
		pattern2.add("traven");
		pattern2.add("traves");
		pattern2.add("tref");
		pattern2.add("trem");
		pattern2.add("tremi");
		pattern2.add("tria");
		pattern2.add("trices");
		pattern2.add("tricia");
		pattern2.add("trics");
		pattern2.add("trim");
		pattern2.add("triv");
		pattern2.add("tromi");
		pattern2.add("troni");
		pattern2.add("trony");
		pattern2.add("trophe");
		pattern2.add("trosp");
		pattern2.add("trov");
		pattern2.add("trui");
		pattern2.add("trus");
		pattern2.add("ts");
		pattern2.add("tsc");
		pattern2.add("tsh");
		pattern2.add("tsw");
		pattern2.add("tt");
		pattern2.add("ttes");
		pattern2.add("tto");
		pattern2.add("ttu");
		pattern2.add("tu");
		pattern2.add("tua");
		pattern2.add("tuar");
		pattern2.add("tubi");
		pattern2.add("tud");
		pattern2.add("tue");
		pattern2.add("tuf");
		pattern2.add("tui");
		pattern2.add("tum");
		pattern2.add("tunis");
		pattern2.add("tup.");
		pattern2.add("ture");
		pattern2.add("turi");
		pattern2.add("turis");
		pattern2.add("turo");
		pattern2.add("tury");
		pattern2.add("tus");
		pattern2.add("tv");
		pattern2.add("tw");
		pattern2.add("twa");
		pattern2.add("twis");
		pattern2.add("two");
		pattern2.add("ty");
		pattern2.add("tya");
		pattern2.add("tyl");
		pattern2.add("type");
		pattern2.add("typh");
		pattern2.add("tz");
		pattern2.add("tze");
		pattern2.add("uab");
		pattern2.add("uac");
		pattern2.add("uana");
		pattern2.add("uani");
		pattern2.add("uarant");
		pattern2.add("uard");
		pattern2.add("uari");
		pattern2.add("uart");
		pattern2.add("uat");
		pattern2.add("uav");
		pattern2.add("ube");
		pattern2.add("ubel");
		pattern2.add("uber");
		pattern2.add("ubero");
		pattern2.add("ubi");
		pattern2.add("ubing");
		pattern2.add("uble.");
		pattern2.add("uca");
		pattern2.add("ucib");
		pattern2.add("ucit");
		pattern2.add("ucle");
		pattern2.add("ucr");
		pattern2.add("ucu");
		pattern2.add("ucy");
		pattern2.add("udd");
		pattern2.add("uder");
		pattern2.add("udest");
		pattern2.add("udev");
		pattern2.add("udic");
		pattern2.add("udied");
		pattern2.add("udies");
		pattern2.add("udis");
		pattern2.add("udit");
		pattern2.add("udon");
		pattern2.add("udsi");
		pattern2.add("udu");
		pattern2.add("uene");
		pattern2.add("uens");
		pattern2.add("uente");
		pattern2.add("ueril");
		pattern2.add("ufa");
		pattern2.add("ufl");
		pattern2.add("ughen");
		pattern2.add("ugin");
		pattern2.add("ui");
		pattern2.add("uiliz");
		pattern2.add("uin");
		pattern2.add("uing");
		pattern2.add("uirm");
		pattern2.add("uita");
		pattern2.add("uiv");
		pattern2.add("uiver.");
		pattern2.add("uj");
		pattern2.add("uk");
		pattern2.add("ula");
		pattern2.add("ulab");
		pattern2.add("ulati");
		pattern2.add("ulch");
		pattern2.add("ulche");
		pattern2.add("ulder");
		pattern2.add("ule");
		pattern2.add("ulen");
		pattern2.add("ulgi");
		pattern2.add("uli");
		pattern2.add("ulia");
		pattern2.add("uling");
		pattern2.add("ulish");
		pattern2.add("ullar");
		pattern2.add("ullib");
		pattern2.add("ullis");
		pattern2.add("ulm");
		pattern2.add("ulo");
		pattern2.add("uls");
		pattern2.add("ulses");
		pattern2.add("ulti");
		pattern2.add("ultra");
		pattern2.add("ultu");
		pattern2.add("ulu");
		pattern2.add("ulul");
		pattern2.add("ulv");
		pattern2.add("umab");
		pattern2.add("umbi");
		pattern2.add("umbly");
		pattern2.add("umi");
		pattern2.add("uming");
		pattern2.add("umoro");
		pattern2.add("ump");
		pattern2.add("unat");
		pattern2.add("une");
		pattern2.add("uner");
		pattern2.add("uni");
		pattern2.add("unim");
		pattern2.add("unin");
		pattern2.add("unish");
		pattern2.add("univ");
		pattern2.add("uns");
		pattern2.add("unsw");
		pattern2.add("untab");
		pattern2.add("unter.");
		pattern2.add("untes");
		pattern2.add("unu");
		pattern2.add("uny");
		pattern2.add("unz");
		pattern2.add("uors");
		pattern2.add("uos");
		pattern2.add("uou");
		pattern2.add("upe");
		pattern2.add("upers");
		pattern2.add("upia");
		pattern2.add("uping");
		pattern2.add("upl");
		pattern2.add("upp");
		pattern2.add("upport");
		pattern2.add("uptib");
		pattern2.add("uptu");
		pattern2.add("ura");
		pattern2.add("ura.");
		pattern2.add("urag");
		pattern2.add("uras");
		pattern2.add("urbe");
		pattern2.add("urc");
		pattern2.add("urd");
		pattern2.add("ureat");
		pattern2.add("urfer");
		pattern2.add("urfr");
		pattern2.add("urif");
		pattern2.add("urific");
		pattern2.add("urin");
		pattern2.add("urio");
		pattern2.add("urit");
		pattern2.add("uriz");
		pattern2.add("url");
		pattern2.add("urling.");
		pattern2.add("urno");
		pattern2.add("uros");
		pattern2.add("urpe");
		pattern2.add("urpi");
		pattern2.add("urser");
		pattern2.add("urtes");
		pattern2.add("urthe");
		pattern2.add("urti");
		pattern2.add("urtie");
		pattern2.add("uru");
		pattern2.add("us");
		pattern2.add("usad");
		pattern2.add("usan");
		pattern2.add("usap");
		pattern2.add("usc");
		pattern2.add("usci");
		pattern2.add("usea");
		pattern2.add("usia");
		pattern2.add("usic");
		pattern2.add("uslin");
		pattern2.add("usp");
		pattern2.add("ussl");
		pattern2.add("ustere");
		pattern2.add("ustr");
		pattern2.add("usu");
		pattern2.add("usur");
		pattern2.add("utab");
		pattern2.add("utat");
		pattern2.add("ute.");
		pattern2.add("utel");
		pattern2.add("uten");
		pattern2.add("uteni");
		pattern2.add("uti");
		pattern2.add("utiliz");
		pattern2.add("utine");
		pattern2.add("uting");
		pattern2.add("utiona");
		pattern2.add("utis");
		pattern2.add("utiz");
		pattern2.add("utl");
		pattern2.add("utof");
		pattern2.add("utog");
		pattern2.add("utomatic");
		pattern2.add("uton");
		pattern2.add("utou");
		pattern2.add("uts");
		pattern2.add("uu");
		pattern2.add("uum");
		pattern2.add("uv");
		pattern2.add("uxu");
		pattern2.add("uze");
		pattern2.add("va");
		pattern2.add("va.");
		pattern2.add("vab");
		pattern2.add("vacil");
		pattern2.add("vacu");
		pattern2.add("vag");
		pattern2.add("vage");
		pattern2.add("valie");
		pattern2.add("valo");
		pattern2.add("valu");
		pattern2.add("vamo");
		pattern2.add("vaniz");
		pattern2.add("vapi");
		pattern2.add("varied");
		pattern2.add("vat");
		pattern2.add("ve.");
		pattern2.add("ved");
		pattern2.add("veg");
		pattern2.add("vel.");
		pattern2.add("velli");
		pattern2.add("velo");
		pattern2.add("vely");
		pattern2.add("venom");
		pattern2.add("venue");
		pattern2.add("verd");
		pattern2.add("vere.");
		pattern2.add("verel");
		pattern2.add("veren");
		pattern2.add("verenc");
		pattern2.add("veres");
		pattern2.add("verie");
		pattern2.add("vermin");
		pattern2.add("verse");
		pattern2.add("verth");
		pattern2.add("ves");
		pattern2.add("ves.");
		pattern2.add("veste");
		pattern2.add("vete");
		pattern2.add("veter");
		pattern2.add("vety");
		pattern2.add("viali");
		pattern2.add("vian");
		pattern2.add("vide.");
		pattern2.add("vided");
		pattern2.add("viden");
		pattern2.add("vides");
		pattern2.add("vidi");
		pattern2.add("vif");
		pattern2.add("vign");
		pattern2.add("vik");
		pattern2.add("vil");
		pattern2.add("vilit");
		pattern2.add("viliz");
		pattern2.add("vin");
		pattern2.add("vina");
		pattern2.add("vinc");
		pattern2.add("vind");
		pattern2.add("ving");
		pattern2.add("viol");
		pattern2.add("vior");
		pattern2.add("viou");
		pattern2.add("vip");
		pattern2.add("viro");
		pattern2.add("visit");
		pattern2.add("viso");
		pattern2.add("visu");
		pattern2.add("viti");
		pattern2.add("vitr");
		pattern2.add("vity");
		pattern2.add("viv");
		pattern2.add("vo.");
		pattern2.add("voi");
		pattern2.add("vok");
		pattern2.add("vola");
		pattern2.add("vole");
		pattern2.add("volt");
		pattern2.add("volv");
		pattern2.add("vomi");
		pattern2.add("vorab");
		pattern2.add("vori");
		pattern2.add("vory");
		pattern2.add("vota");
		pattern2.add("votee");
		pattern2.add("vv");
		pattern2.add("vy");
		pattern2.add("wabl");
		pattern2.add("wac");
		pattern2.add("wager");
		pattern2.add("wago");
		pattern2.add("wait");
		pattern2.add("wal.");
		pattern2.add("wam");
		pattern2.add("wart");
		pattern2.add("wast");
		pattern2.add("wate");
		pattern2.add("waver");
		pattern2.add("wb");
		pattern2.add("wearie");
		pattern2.add("weath");
		pattern2.add("wedn");
		pattern2.add("weet");
		pattern2.add("weev");
		pattern2.add("well");
		pattern2.add("wer");
		pattern2.add("west");
		pattern2.add("wev");
		pattern2.add("whi");
		pattern2.add("wi");
		pattern2.add("wil");
		pattern2.add("willin");
		pattern2.add("winde");
		pattern2.add("wing");
		pattern2.add("wir");
		pattern2.add("wise");
		pattern2.add("with");
		pattern2.add("wiz");
		pattern2.add("wk");
		pattern2.add("wles");
		pattern2.add("wlin");
		pattern2.add("wno");
		pattern2.add("wo");
		pattern2.add("wom");
		pattern2.add("woven");
		pattern2.add("wp");
		pattern2.add("wra");
		pattern2.add("wri");
		pattern2.add("writa");
		pattern2.add("wsh");
		pattern2.add("wsl");
		pattern2.add("wspe");
		pattern2.add("wst");
		pattern2.add("wt");
		pattern2.add("wy");
		pattern2.add("xa");
		pattern2.add("xace");
		pattern2.add("xago");
		pattern2.add("xam");
		pattern2.add("xap");
		pattern2.add("xas");
		pattern2.add("xc");
		pattern2.add("xe");
		pattern2.add("xecuto");
		pattern2.add("xed");
		pattern2.add("xeri");
		pattern2.add("xero");
		pattern2.add("xh");
		pattern2.add("xhi");
		pattern2.add("xhil");
		pattern2.add("xhu");
		pattern2.add("xi");
		pattern2.add("xia");
		pattern2.add("xic");
		pattern2.add("xidi");
		pattern2.add("xime");
		pattern2.add("ximiz");
		pattern2.add("xo");
		pattern2.add("xob");
		pattern2.add("xp");
		pattern2.add("xpand");
		pattern2.add("xpecto");
		pattern2.add("xped");
		pattern2.add("xt");
		pattern2.add("xti");
		pattern2.add("xu");
		pattern2.add("xua");
		pattern2.add("xx");
		pattern2.add("yac");
		pattern2.add("yar");
		pattern2.add("yat");
		pattern2.add("yb");
		pattern2.add("yc");
		pattern2.add("yce");
		pattern2.add("ycer");
		pattern2.add("ych");
		pattern2.add("yche");
		pattern2.add("ycom");
		pattern2.add("ycot");
		pattern2.add("yd");
		pattern2.add("yee");
		pattern2.add("yer");
		pattern2.add("yerf");
		pattern2.add("yes");
		pattern2.add("yet");
		pattern2.add("ygi");
		pattern2.add("yh");
		pattern2.add("yi");
		pattern2.add("yla");
		pattern2.add("yllabl");
		pattern2.add("ylo");
		pattern2.add("ylu");
		pattern2.add("ymbol");
		pattern2.add("yme");
		pattern2.add("ympa");
		pattern2.add("ynchr");
		pattern2.add("ynd");
		pattern2.add("yng");
		pattern2.add("ynic");
		pattern2.add("ynx");
		pattern2.add("yo");
		pattern2.add("yod");
		pattern2.add("yog");
		pattern2.add("yom");
		pattern2.add("yonet");
		pattern2.add("yons");
		pattern2.add("yos");
		pattern2.add("yped");
		pattern2.add("yper");
		pattern2.add("ypi");
		pattern2.add("ypo");
		pattern2.add("ypoc");
		pattern2.add("ypta");
		pattern2.add("ypu");
		pattern2.add("yram");
		pattern2.add("yria");
		pattern2.add("yro");
		pattern2.add("yrr");
		pattern2.add("ysc");
		pattern2.add("yse");
		pattern2.add("ysica");
		pattern2.add("ysio");
		pattern2.add("ysis");
		pattern2.add("yso");
		pattern2.add("yss");
		pattern2.add("yst");
		pattern2.add("ysta");
		pattern2.add("ysur");
		pattern2.add("ythin");
		pattern2.add("ytic");
		pattern2.add("yw");
		pattern2.add("za");
		pattern2.add("zab");
		pattern2.add("zar");
		pattern2.add("zb");
		pattern2.add("ze");
		pattern2.add("zen");
		pattern2.add("zep");
		pattern2.add("zer");
		pattern2.add("zero");
		pattern2.add("zet");
		pattern2.add("zi");
		pattern2.add("zil");
		pattern2.add("zis");
		pattern2.add("zl");
		pattern2.add("zm");
		pattern2.add("zo");
		pattern2.add("zom");
		pattern2.add("zool");
		pattern2.add("zte");
		pattern2.add("zz");
		pattern2.add("zzy");

}}


